#!/bin/sh
#
# Copyright (c) 1993 InterSoft Co.  All Rights Reserved
# THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF InterSoft Co.
# The copyright notice above does not evidence any
# actual or intended publication of such source code.
#
# MODULE & VERSION : $Id: genib.sh,v 1.9 1995/10/19 18:46:09 bruno Exp $
# DATE             : $Date: 1995/10/19 18:46:09 $ 
# TIME             : 
#
#	genib [-?|-h|-d|-v|-i] target [file1 ...]
#
#

PROG=`basename $0`
VERS="$Revision: 1.9 $"
DATE=`date "+%y/%m/%d %H:%M:%S"`
COMMENTS="//"
USAGE="Usage: `basename $0` [-?|-h|-d|-v|-i] module files ..."
VERSION=""
DEPS=""       
IGNORE=""
SCCSDIR=SCCS
RET=0
export RET

# Get command line options
while getopts h?dvi OPT
do
	case $OPT in
	d)
		DEPS=1
		;;
	v)
		VERSION=1
		;;
	i)
		if [ "$VERSION" = "" ]
			then
			 echo "genib: Option -i must follow option -v "
			 exit 1
		fi	 
		IGNORE=1  
		;;
	h|\?)
		echo $USAGE 1>&2
		exit 2
		;;
	esac
done

shift `expr $OPTIND - 1`

if [ $# -eq 0 ]
then
	echo $USAGE 1>&2
	exit 3
fi

# Save Project File
project=$1

j=""
shift
for i
do      
	ext=`expr $i : '.*\.\(.*\)'`
 	if [ "$ext" != "h" -a "$ext" != "fmh" -a "$ext" != "rph" -a "$ext" != "sch" ] 
 	 then
		j="$j $i" 
		# Scan includes in files
		if [ -n "$DEPS" ]
		then 	
			j="$j `grep \"^#[ 	]*include[ 	]*\\\"\" $i | cut -d'\"' -f2 | cut -d'\"' -f1`"
			j="$j `grep \"^#[ 	]*include[ 	]*<\" $i | cut -d'<' -f2 | cut -d'>' -f1`"
		fi
     else
     	echo "$PROG: warning: $i ignored"
    fi
done

# Start writing ibuild file
if [ -n "$IPROJECT" ]                   
then
	echo "project $IPROJECT;"
fi

echo "$COMMENTS This file has been automatically generated by $PROG $VERS"
	
linea=""               
deps=""

# Loop through 'j' building ibuild lines

if [ -n "$VERSION" ]
then 	
# Versions of files wanted
	echo "$COMMENTS Source versions for '$project' as of date $DATE"
	echo 
	echo 'BIN="./";'
	echo 'OBJ="./";'
	echo 
	echo "$project {"
	for i in $j
	do                 
	    path=`dirname $i`         
	    file=`basename $i`
	    if [ -r "$PWD/$path/$SCCSDIR/s.$file" ]
	      then                          
		    version="(`prs -d":I:" $PWD/$path/$SCCSDIR/s.$file`)"
		  else
	    	if [ -r "$PWD/include/$SCCSDIR/s.$file" ]
		      then                          
			    version="(`prs -d":I:" $PWD/include/$SCCSDIR/s.$file`)"
			  else
			    version=""
			fi    
		fi    
		dep=`expr $i : '.*\.\(.*\)'`
	 	if [ "$dep" = "h" -o "$dep" = "fmh" -o "$dep" = "rph" -o "$dep" = "sch" ] 
		   	then 
		   		if [ "$deps" = "" ]
		   	       then deps=":"
		   	    fi     
		   		if [ "$version" != "" -o "$IGNORE" = "" ]
			   		then
				   		deps="$deps $i$version"
		   		fi
			else
		   		if [ "$deps" != "" ]
				  then 	echo "	$linea $deps;"
				       	deps=""
				  else 	if [ "$linea" != "" ]
							then echo "	$linea;"  
		   				fi	
				fi    
				linea="$i$version"
		fi		
	done
else
# Plain files wanted
	echo "$COMMENTS Date: $DATE"
	echo
	echo 'BIN="./";'
	echo 'OBJ="./";'
	echo 
	echo "$project {"
	for i in $j
	do           
		dep=`expr $i : '.*\.\(.*\)'`
	 	if [ "$dep" = "h" -o "$dep" = "fmh" -o "$dep" = "rph" -o "$dep" = "sch" ]
		   	then 
		   		if [ "$deps" = "" ]
		   	       then deps=":"
		   	    fi     
		   		deps="$deps $i"
			else
		   		if [ "$deps" != "" ]
				  then 	echo "	$linea $deps;"
				       	deps=""
				  else 	if [ "$linea" != "" ]
							then echo "	$linea;"  
		   				fi	
				fi    
				linea=$i
		fi		
	done
fi
# Flush last line
echo "	$linea $deps;"

# Close ibuild module
echo "}"
