:
#
# Copyright (c) 1987 InterSoft Co.  All Rights Reserved
# THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF InterSoft Co.
# The copyright notice above does not evidence any
# actual or intended publication of such source code.
#
# MODULE & VERSION : $Id: pmintrf.sh,v 1.4 1994/02/22 12:11:19 dino Exp $
# DATE             : $Date: 1994/02/22 12:11:19 $
# TIME             : 
#
# DESCRIPTION:
# Interface for a printer using the Printer Manager
# for the UNIX System V spooler lp.
#

IDEAFIX=/usr/ideafix
LANGUAGE=spanish
export IDEAFIX LANGUAGE
filter=$IDEAFIX/bin/pm
pmodel=$IDEAFIX/bin/cap/epson
printer=`basename "$0"`
request=$1
name=$2
title=$3
copies=$4
options=$5
user=`grep "^$name:" /etc/passwd | cut -d: -f5`
# slave = 1 si es impresora esclava, sino 0
slave=0
# banner page: 1 = yes, 0 = no
bannerh=0
# trailer page: 1 = yes, 0 = no
bannert=0

if [ $slave -eq 1 ]
then
	device=`lpstat -v | grep " $printer:" | cut -d" " -f4`
	ttymodel=`$IDEAFIX/bin/ttytype $device`
	if [ -z "$device" ]
	then
		disable -r"I can't find my device" $printer
		exit 1
	fi
	if [ -z "$ttymodel" ]
	then
		disable -r"I don't know witch is my terminal model" $printer
		exit 1
	fi
	mc5=`tput -T $ttymodel mc5`
	mc4=`tput -T $ttymodel mc4`
	if [ -z "$mc5" -o -z "$mc4" ]
	then
		disable -r"I don't have the mc5 or mc4 terminfo secuences" $printer
		exit 1
	fi
fi

x="XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX"

#
# We build a string of options for the filter in 'filtops'.
# The lp, when receiving -oXX passes XX in options.
# They are passed as -i options to the printer manager.
#

filtops="-b"
for i in $options
do
	filtops="$filtops -i$i"
done

#
# Test if the filter can be executed
#
if [ -n "$filter" -a ! -x $filter ]
then
	disable -r"can't execute $filter filter" $printer
	exit 1
fi

if [ $slave -eq 1 ]
then
	$IDEAFIX/bin/wmblock $device 1
	echo "$mc5\c"
	ATTR=`stty -g < $device`
	stty -echo < $device

	trap "echo "'"'"\014\c"'"'" > $device; tput -T $ttymodel mc4 > $device; stty $ATTR < $device; $IDEAFIX/bin/wmblock $device 0; exit 1" 15
fi

#
# Print banner page
#
if [ $bannerh -eq 1 ]
then
	echo "$x\n$x\n$x\n\n"
	banner "$name"
	echo
	if [ -n "$usr" ]
	then
		echo "User: $usr\n"
	fi
	echo "Request id: $request	Printer: $printer\n"
	. /etc/TIMEZONE
	date
	echo
	if [ -n "$title" ]
	then
		banner `echo "$title" | sed 's/ /\\n/g' | awk '{for (i = 1; i <= length; i += 10) printf("%s\n", substr($0, i, 10)); }'`
		echo "\n"
	fi
	echo "$x\n$x\n$x\014\c"
fi

#
# Print each file
#
shift 5
files="$*"
i=1
while [ $i -le $copies ]
do
	for file in $files
	do
		$filter $filtops $pmodel "$file" 2>&1
		echo "\014\c"
	done
	i=`expr $i + 1`
done

#
# Trailer page with the listing owner & other data.
#
if [ $bannert -eq 1 ]
then
	echo "$x\n$x\n$x\n\n"
	echo "            Request: $request\n"
	echo "            User   : $name"
	echo "\n\n$x\n$x\n$x\014\c"
fi

#
# A trailer page. Usefull when some drivers eat up the last
# characters sended to printer (ex: AT Compatibles parallel port).
# The \r don't modify printer head position but are usefull
# to avoid the "eating characters" problem.
#
echo "\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\c"
echo "\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\c"
echo "\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\c"
echo "\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\c"
echo "\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\c"
echo "\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\c"
echo "\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\c"
echo "\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\c"
echo "\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\c"
echo "\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\r\c"

if [ $slave -eq 1 ]
then
echo "$mc4\c"
stty $ATTR < $device
$IDEAFIX/bin/wmblock $device 0
trap 15
fi

exit 0
