#include <ideafix.h>
#include "demo.sch"
#include "lorden.fmh"
#include "lorden.rph"

/* Funciones privadas */

private void Lectura();
private fm_status after();

/* Declaraciones globales */
form fm0;
report rp0;

/* Programa principal */
wcmd(lorden, 3.4 8/22/91)
{
	fm_cmd cmd;    
	int orderno=-1;

	fm0 = OpenForm("lorden", FM_EABORT);
	rp0 = OpenReport("lorden", RP_NOBEGIN);

	if (DoForm(fm0, NULLFP, after) != FM_UPDATE) return;

	/*	
	 * Proceso central	
	 */
	BeginReport(rp0, 1, "");

	/* Establezco la relacion con las otras tablas */
	SetRelation(MOVIM, 3, IO_EABORT);

	/* Inicilizo la clave */
	SetFld(MOVIM_ORDERNO, FmSFld(fm0, DESDE));
	SetFld(MOVIM_ITEMNO, LOW_VALUE);
	
	while ( GetRecord(MOVIM, NEXT_KEY, IO_NOT_LOCK) != ERROR && 
			IFld(MOVIM_ORDERNO) <= FmIFld(fm0, HASTA) ) {

		if ( IFld(ORDENES_ORDERNO) != orderno ) {
			RpSetFFld(rp0, VALOR, FFld(ORDENES_VALOR) + 
					FFld(ORDENES_MIVA));
			orderno = IFld(ORDENES_ORDERNO);
		}

		/* Paso los datos al buffer */
		DbToRp(rp0, ORDERNO, VALOR);

		/* Calculo el precio por item : precio unit. por cantidad */
		RpSetFFld(rp0, PRECIOT, FFld(MOVIM_PRVTA) * 
				IFld(MOVIM_CANTID));

		/* Imprimo la linea que da salida a las demas */
		DoReport(rp0, LINEA);
	}

}

private fm_status after(fm, fno, row)
form fm;
fmfield fno;
int row;
{
	switch (fno) {
	case AGRUP:
		break;
	case DESDE:
		break;
	case HASTA:
		break;
	case SALIDA:
		/* Definicin del destino de la salida */
		switch (FmInOffset(fm)) {
		case 0:
			RpSetOutput(rp0, RP_IO_TERM, NULL_STR);
			break;
		case 1:
			RpSetOutput(rp0, RP_IO_PRINTER, NULL_STR);
			break;
		}
	
		break;
	}
	return FM_OK;
}
