#include <ideafix.h>
#include "ordenes.fmh"
#include "ordenes2.fmh"
#include "ordenes3.fmh"
#include "demo.sch"

/* Funciones privadas */
private fm_status before(), after(), before_ordenes2(), after_ordenes2(),
	before_ordenes3(), after_ordenes3();

private void Lectura();

/* Declaraciones globales */
int i;
form fm0, fm1, fm2;

int NLIN;
/* Programa principal */
wcmd(ordenes, %I% %G%)
{
	fm_cmd cmd;
	fm0 = OpenForm("ordenes", FM_EABORT);
	fm1 = UseSubform(fm0, MENTR, 1);
	fm2 = UseSubform(fm0, MENTR, 2);
	NLIN = FmFldLen(fm0, MULTIP);

	while ((cmd = DoForm(fm0, before, after)) != FM_EXIT)
	switch (cmd) {
	case FM_READ:		Lectura(cmd, THIS_KEY); break;
	case FM_READ_NEXT:	Lectura(cmd, NEXT_KEY); break;
	case FM_READ_PREV:	Lectura(cmd, PREV_KEY); break;
	case FM_ADD:
		InitRecord(ORDENES);
	case FM_UPDATE:
		BeginTransaction();
		FmToDb(fm0, 0, CONTROL_FLD, 0);
		FmToDb(fm1, 0, CONTROL_FLD, 0);
		FmToDb(fm2, 0, CONTROL_FLD, 0);
		PutRecord(ORDENES);

		CopyFld(ORDENES_ORDERNO, MOVIM_ORDERNO);
		SetFld(MOVIM_ITEMNO, LOW_VALUE);
		while(GetRecord(MOVIMbyORDERNO, NEXT_KEY|PARTIAL_KEY, IO_NOT_LOCK, 1)!=ERROR)
			DelRecord(MOVIM);

		CopyFld(ORDENES_ORDERNO, MOVIM_ORDERNO);
		for(i=0 ; i<NLIN && !FmIsNull(fm0, ITEMNO, i) ; i++) {
			FmToDb(fm0, ITEMNO, TOTROW, i);
			SetFFld(MOVIM_PRVTA, FmFFld(fm0, PRECIO, i));
			PutRecord(MOVIM);
		}
		EndTransaction();
		break;
	case FM_DELETE:
		BeginTransaction();
		FmToDb(fm0, 0, ORDERNO);
		DelRecord(ORDENES);
		SetFld(MOVIM_ITEMNO, LOW_VALUE);
		CopyFld(ORDENES_ORDERNO, MOVIM_ORDERNO);
		while(GetRecord(MOVIMbyORDERNO, NEXT_KEY|PARTIAL_KEY, IO_NOT_LOCK, 1)!=ERROR)
			DelRecord(MOVIM);

		EndTransaction();
		break;
	case FM_IGNORE:
		FreeTable(ORDENES);
		break;
	}
}

/* Rutina de lectura y pasaje a pantalla */
private void Lectura(cmd, mode)
fm_cmd cmd;
find_mode mode;
{
	FmToDb(fm0, 0, ORDERNO);
	switch(GetRecord(ORDENESbyORDERNO, mode, IO_LOCK|IO_TEST)) {
	case IO_LOCKED:
		FmSetStatus(fm0, FM_LOCKED);
		(void)FindRecord(ORDENESbyORDERNO, mode);
		DbToFm(fm0, 0, ORDERNO);
		FmShowFlds(fm0, 0, ORDERNO);
		return;
	case ERROR:
		FmSetStatus(fm0, cmd==FM_READ ? FM_NEW : FM_EOF); return;
	}
	DbToFm(fm0, 0, IVA, 0);
	DbToFm(fm0, MENTR, CONTROL_FLD, 0);
	DbToFm(fm1, 0, CONTROL_FLD, 0);
	DbToFm(fm2, 0, CONTROL_FLD, 0);
	CopyFld(ORDENES_ORDERNO, MOVIM_ORDERNO);
	i=0;
	SetFld(MOVIM_ITEMNO, LOW_VALUE);
	while(GetRecord(MOVIMbyORDERNO, NEXT_KEY|PARTIAL_KEY, IO_NOT_LOCK, 1)!=ERROR)
		DbToFm(fm0, ITEMNO, TOTROW, i++);
	FmShowFlds(fm0, 0, ORDERNO);
}

private fm_status before(fm, fno, row)
form fm;
fmfield fno;
int row;
{
	switch (FmSubformId(fm)) {
	case SF_ORDENES2:
		return before_ordenes2(fm, fno, row);
	case SF_ORDENES3:
		return before_ordenes3(fm, fno, row);
	}
	switch (fno) {
	case ORDERNO:
		break;
	case FECHA:
		break;
	case CLIENO:
		break;
	case MULTIP:
		break;
	case ITEMNO:
		break;
	case CANTID:
		break;
	case MENTR:
		break;
	}
	return FM_OK;
}

private fm_status after(fm, fno, row)
form fm;
fmfield fno;
int row;
{
	switch (FmSubformId(fm)) {
	case SF_ORDENES2:
		return after_ordenes2(fm, fno, row);
	case SF_ORDENES3:
		return after_ordenes3(fm, fno, row);
	}
	switch (fno) {
	case ORDERNO:
		break;
	case FECHA:
		break;
	case CLIENO:
		break;
	case MULTIP:
		break;
	case ITEMNO:
		break;
	case CANTID:
		break;
	case MENTR:
		break;
	}
	return FM_OK;
}

private fm_status before_ordenes2(fm, fno, row)
form fm;
fmfield fno;
int row;
{
	switch (fno) {
	case DOMICILIO:
		break;
	}
	return FM_OK;
}

private fm_status after_ordenes2(fm, fno, row)
form fm;
fmfield fno;
int row;
{
	switch (fno) {
	case DOMICILIO:
		break;
	}
	return FM_OK;
}

private fm_status before_ordenes3(fm, fno, row)
form fm;
fmfield fno;
int row;
{
	switch (fno) {
	case COMPANIA:
		break;
	}
	return FM_OK;
}

private fm_status after_ordenes3(fm, fno, row)
form fm;
fmfield fno;
int row;
{
	switch (fno) {
	case COMPANIA:
		break;
	}
	return FM_OK;
}
