#include <ideafix.h>
#include "demo.sch"
#include "lorden.fmh"
#include "lorden.rph"

/* Funciones privadas */

private fm_status after(form fm, fmfield fno, int row);

/* Declaraciones globales */
form fm0;
report rp0;

/* Programa principal */
wcmd(lorden, 3.4 8/22/91)
{
	dbcursor CUR1;
	
	fm0 = OpenForm("lorden", FM_EABORT);
	rp0 = OpenReport("lorden", RP_NOBEGIN);

	if (DoForm(fm0, NULLFP, after) != FM_UPDATE) return;

	/*	
	 * Proceso central	
	 */
	BeginReport(rp0, 1, "");

	/* Establezco la relacion con las otras tablas 	*/
	SetRelation(MOVIM, 3, IO_EABORT);
	
	/* Creo un cursor								*/
	CUR1 = CreateCursor(MOVIMbyORDERNO, IO_NOT_LOCK);
	
	/* Establezco los limites del cursor			*/
	SetCursorFrom(CUR1, FmIFld(fm0, DESDE), MIN_SHORT);
	SetCursorTo(CUR1, FmIFld(fm0, HASTA), MAX_SHORT);
	
	while ( FetchCursor(CUR1) != ERROR ) {
		/* Paso los datos al buffer */
		DbToRp(rp0, ORDERNO, VALOR);

		/* Calculo el precio por item : precio unit. por cantidad */
		RpSetFFld(rp0, PRECIOT, IFld(MOVIM_CANTID) *
				FFld(MOVIM_PRVTA)); 
		RpSetFFld(rp0, VALOR, FFld(ORDENES_VALOR));
		/* Imprimo la linea que da salida a las demas */
		DoReport(rp0, LINEA);
	}
	
	DeleteCursor(CUR1);
}

private fm_status after(form fm, fmfield fno, int row)
{
	switch (fno) {
	case AGRUP:
		break;
	case DESDE:
		break;
	case HASTA:
		break;
	case SALIDA:
		/* Definicin del destino de la salida */
		switch (FmInOffset(fm)) {
		case 0:
			RpSetOutput(rp0, RP_IO_TERM, NULL_STR);
			break;
		case 1:
			RpSetOutput(rp0, RP_IO_PRINTER, NULL_STR);
			break;
		}
	
		break;
	}
	return FM_OK;
}
