/****************************************************************
* Copyright (c) 1992 InterSoft Co.  All Rights Reserved
* THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF InterSoft Co.
* The copyright notice above does not evidence any
* actual or intended publication of such source code.
*
* $Id: iconnect.h,v 1.19 1996/06/04 15:31:15 santiago Exp $
*
* DESCRIPTION
* Class definitions for Ipc Connection type.
*********************************************************************/

#ifndef ICONNECT_H
#define ICONNECT_H

#include <ifound.h>

#ifdef __GNUC__
#pragma interface
#endif

#include <essentia/dbconn.h>
#include <essentia/dbmcom.h>

class IpcConnection : public DbConnection
{

	friend class Shadow;
	friend class ShTube;

// private:

	// metodos que utilizan la clase Shadow, ShObject
	inline Int getActBuffSize();
	inline void resetNMsgs();
	inline MsgBuff getBuffer();
	inline short getBuffFlags();
	inline void setBuffFlags(short f);
	inline void setCurrMsgLength(Int l);
	inline void setDefCurrMsgLength();
	inline void setPtrBuff(Int len);
	inline Int getClientId();
	inline MsgBuff beginOfBuffer();
	inline MsgBuff realBuffer();
	inline Int ipcClientId();
	
	void initialize(Int id);
	bool checkIntr(const String &msg, int errNo);
	void createError(const String &funct, int err);

	BytePtr rbuffer;
	int stchannel;
	int snd_channel;
	int cont_channel;
	int rcv_channel;
	int semid;

	void _flush();
	Int _fill();
	bool stopSv();

	inline bool connExists(char t, const String &hst, Int id, 
						   const String &svName);

	IpcConnection(const IpcConnection &);
	
public:

	IpcConnection(const DbConfigFile &file, ConnMode doAbort);
	IpcConnection(Int key, String svName,
				  ConnMode abort = abortOnInit|abortOnRun);
	~IpcConnection();

	// rutina para la inicializacion de la ejecucion de la rutina
	void begin(Int io, SvMessage so);
	void connect(bool secServ = false);
	bool waitForServerHalt();

	virtual bool addSchema(const String &schname);
	virtual bool delSchema(const String &schname);

};

#include <essentia/iconnect.icc>

#endif // ICONNECT_H
