/********************************************************************
* Copyright (c) 1992 InterSoft Co.  All Rights Reserved
* THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF InterSoft Co.
* The copyright notice above does not evidence any
* actual or intended publication of such source code.
*
* $Id: rconnect.h,v 1.19 1996/06/06 20:33:52 pablog Exp $
*
* DESCRIPTION
* Class definitions for remote Connection type.
*********************************************************************/

#ifndef RCONNECT_H
#define RCONNECT_H

#include <ifound.h>

#ifdef __GNUC__
#pragma interface
#endif

#include <ifound/convconn.h>
#include <essentia/dbconn.h>
#include <essentia/sockconn.h>

#define BAD_SEND		-7
#define BAD_RECV		-8

class DbConfigFile;

class RemoteConnection : public DbConnection {

// private:

	MsgBuff rbuffer;
	SocketConnection *scon;
	BaseAction(StringRef, StringRef) *query_user; 	// useful for WINDOWS clients

	void _flush();
	Int _fill();

	int receiveFrom();
	int sendTo();
	void convertHeaders(MsgBuff rbuffer, Int len);
	void initialize(const String &nm, const String &schname);

	RemoteConnection(const RemoteConnection&);
	
protected:

	bool needConvert;
	short (*convS)(short);
	Int   (*convI)(Int);
	void  (*convH)(MsgBuff);

public:

	RemoteConnection(const String &nm, String svName,
		ConnMode abort = abortOnInit|abortOnRun,
		String schname = NULL_STRING, 
		BaseAction(StringRef, StringRef) *query = NULL);
	RemoteConnection(const DbConfigFile &file,
		ConnMode abort = abortOnInit|abortOnRun,
		String schname = NULL_STRING, 
		BaseAction(StringRef, StringRef) *query = NULL);
	~RemoteConnection();

	// operadores redefinidos
	Connection &operator<<(Int i);
	Connection &operator>>(Int &i);

	// nuevos operadores para los el push/pop de parametros
	inline void push(Int i);
	inline void push(const String &s);
	inline void push(void *v, Int i);
	inline void pop(Int &i);
	inline void pop(String &s);
	inline void pop(void *v, Int i);

	void connect(bool secServ = false);

	inline const String &hostName();
	inline MsgBuff beginOfBuffer();
	inline MsgBuff realBuffer();
};


#include <essentia/rconnect.icc>


#endif // RCONNECT_H
