// -----------------------------------------------------------------------
// Copyright (c) 1995 InterSoft Co.  All Rights Reserved
// THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF InterSoft Co.
// The copyright notice above does not evidence any actual or intended 
// publication of such source code.
//
// $Id: crkconn.h,v 1.2 1996/07/03 13:36:48 hernan Exp $
//
// Description:
// -----------------------------------------------------------------------

#ifndef CRKCONN_H
#define CRKCONN_H

#ifdef __GNUC__
#pragma interface
#endif

#include <guiconn/guiconn.h>
#include <cracker/reqconn.h>
#include <ifound/mainobj.h>

// WARNING: order of inheritance is important!
class CrackerGUIConnection : public RequestConnection, public GUIConnection, 
								public FramedObject
{
public:

	CrackerGUIConnection(const String &name);
	CrackerGUIConnection(const String &name, Int debug);
	~CrackerGUIConnection();

	bool ok() const;

	static bool canConnect();
	
	Int execute();
	bool createObject(FramedObject *obj);
	void destroyObject(FramedObject *obj);

	Int mainLoop(FramedObject *mainObj);
	void exitLoop(FramedObject *mainObj, Int retVal);

	CrackerGUIConnection *CrackerConn();

	bool processRequest(RequestConnection &conn);

private:
	void init();

	IFPICCPCCP oldDisplayHandler;
	IFPICCPCCP oldDisplayErrorHandler;
	IFPICCPCCP oldFatalErrorHandler;
	IFPICCPCCP oldAriErrorHandler;
};

#endif

