// -----------------------------------------------------------------------
// Copyright (c) 1995 InterSoft Co.  All Rights Reserved
// THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF InterSoft Co.
// The copyright notice above does not evidence any actual or intended 
// publication of such source code.
//
// $Id: guiconn.h,v 1.2 1996/07/03 13:36:49 hernan Exp $
//
// Description:
// -----------------------------------------------------------------------

#ifndef GUICONN_H
#define GUICONN_H

#ifdef __GNUC__
#pragma interface
#endif

#include <ifound/str.h>

class OptionParser;
class ISApp;
class FramedObject;
class wxWindowsGUIConnection;
class CrackerGUIConnection;

class MainLoopData;
class gtype(Stack, MainLoopData);

class GUIConnection
{
public:

	GUIConnection(const String &name);
	virtual ~GUIConnection();

	inline const String &appName() const;
	inline ISApp *app() const;

	void createRootClass();
	void deleteRootClass();

	virtual bool ok() const;
	virtual void error(Int errCode);

	virtual Int execute() = 0;
	virtual bool createObject(FramedObject *obj) = 0;
	virtual void destroyObject(FramedObject *obj) = 0;
	
	Int processObject(FramedObject *obj);
	inline Int processObject(FramedObject &obj);
	
	virtual Int mainLoop(FramedObject *mainObj) = 0;
	virtual void exitLoop(FramedObject *mainObj, Int retVal);

	virtual bool editOptions(OptionParser *op);
	
	virtual wxWindowsGUIConnection *wxWindowsConn();
	virtual CrackerGUIConnection *CrackerConn();

	bool keepGoing(FramedObject *obj) const;
	FramedObject *topLevelObject() const;

protected:

	enum {
		KeepGoing = INT_MIN
	};

	bool startMainLoop(FramedObject *obj);
	Int stopMainLoop(FramedObject *obj);
	
	Int topReturnValue() const;

private:
	
	friend class MainLoopData;

	String appName_d;
	String compData_d;
	ISApp *rc_d;

	gtype(Stack, MainLoopData)	&loopStack_d;
	
	MainLoopData &loopData(FramedObject *obj) const;
	MainLoopData *findLoopData(FramedObject *obj) const;
};

CrackerGUIConnection *crackerConnection();

#include <guiconn/guiconn.icc>

#endif

