// -----------------------------------------------------------------------
// Copyright (c) 1995 InterSoft Co.  All Rights Reserved
// THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF InterSoft Co.
// The copyright notice above does not evidence any actual or intended 
// publication of such source code.
//
// $Id: wxconn.h,v 1.2 1996/07/03 13:36:50 hernan Exp $
//
// Description:
// -----------------------------------------------------------------------

#ifndef WXCONN_H
#define WXCONN_H

#ifdef __GNUC__
#pragma interface
#endif

#include <guiconn/guiconn.h>

#include <wxwin/enter_wx.h>
#	include <wx_main.h>
#include <wxwin/leave_wx.h>

// WARNING: order of inheritance is important!
class wxWindowsGUIConnection : public wxApp, public GUIConnection {
	
public:

	wxWindowsGUIConnection(const String &name);
	~wxWindowsGUIConnection();

	inline const String &appName() const;

	static bool canConnect();

	// GUIConnection part	
	Int execute();
	bool createObject(FramedObject *obj);
	void destroyObject(FramedObject *obj);
	Int mainLoop(FramedObject *mainObj);
	void exitLoop(FramedObject *mainObj, Int retVal);

	bool editOptions(OptionParser *);

	// wxWindows part
	wxFrame *OnInit();
	int OnExit();
	int MainLoop();
	
	wxWindowsGUIConnection *wxWindowsConn();
	
	static wxFrame *getTopFrame();

private:
	wxFrame *mainFrame_d;

	IFPICCPCCP oldDisplayHandler;
	IFPICCPCCP oldDisplayErrorHandler;
	IFPICCPCCP oldFatalErrorHandler;
	IFPICCPCCP oldAriErrorHandler;
};

inline const String &wxWindowsGUIConnection::appName() const
{
	return GUIConnection::appName();
}

#endif

