/********************************************************************
* Copyright (c) 1994 InterSoft Co.  All Rights Reserved
* THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF InterSoft Co.
* The copyright notice above does not evidence any
* actual or intended publication of such source code.
*
* $Id: fmtype.h,v 3.2 1996/07/15 18:45:34 eugen Exp $
*
* DESCRIPTION
* Form enums
*********************************************************************/

#ifndef FORMTYPE_H
#define FORMTYPE_H

class FmField;

struct Fm {

	enum Flag {
		NORMAL		= 0,
		NODISPLAY	= 1 << 0,
		EABORT		= 1 << 1,
		SYMBOLS		= 1 << 2,
		FDUMP		= 1 << 3,
		PRSERVER	= 1 << 4,
		DOCALLBKS	= 1 << 5,
		NOCREATE	= 1 << 6
	};

	enum Event {
		no_action = 0,
		read,
		read_next,
		read_prev,
		read_first,
		read_last,
		reset,
		update,
		add,
		del,
		close,
		undo,
		subform,
		clear_fld,
		first_userdef_action,
		last_predef_action = first_userdef_action-1
	};

	enum Action {
		error,
		locked,
		bof,
		eof,

		stay,
		ok,
		skip
	};

	typedef Action (*Fp)(FmField &f);
};

#endif
