// -----------------------------------------------------------------------
// Copyright (c) 1995 InterSoft Co.  All Rights Reserved
// THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF InterSoft Co.
// The copyright notice above does not evidence any actual or intended 
// publication of such source code.
//
// $Id: cfmrep.h,v 1.3 1996/08/15 16:36:20 eduardoc Exp $
//
// Description:
// -----------------------------------------------------------------------

#ifndef CFMREP_H
#define CFMREP_H

#ifdef __GNUC__
#pragma interface
#endif

#include <ideafix.h>
#include <ideafix/priv/fmrep.h>

class FmAction;
class String;
class CFormRep;
class gtype(PtrArray, CFormRep);

extern "C" {

	// C interface
	form OpenForm(char *nm, int flags);
	void CloseForm(form fmd);
	void CloseAllForms(void);
	fm_cmd DoForm(form fmd, fm_status_fp beforeIx,
							 fm_status_fp afterIx);
	void FmClearFlds(form fmd, fmfield from, fmfield to, ...);
	void FmSetDisplayOnly(form fmd, fmfield from, fmfield to, 
									 bool value);
	void FmClearAllFlds(form fmd);
	void DisplayForm(form fmd);
	void ClearForm(form fmd);
	fm_status FmErrMsg(form fm, int m, ...);
	void FmRecalc(form fmd, UShort curr_row);
	Int FmCheckSum(form fmd);
	void FmVerifyCheckSum(form fmd, Int chksum);
	int FmNextFld(form fmd, fmfield fno, ...);
	void FmShowFlds(form fmd, fmfield from, fmfield to, ...);
	void FmShowAllFlds(form fmd);
	void FmSetStatus(form fmd, fm_status sts);
	void FmSetError(form fmd, fmfield fld, ...);
	fm_status FmStatus(form fmd);
	form FmCheckSubform(form fmd, fmfield fld, ...); // check & use
	form UseSubform(form fmd, fmfield fld, UShort subf_n, ...);
	fm_cmd DoSubform(form fmd, fm_status_fp beforeIx, 
							fm_status_fp afterIx, fmfield fld, UShort subf_n, ...);
	int FmSubformId(form fmd);
	form FmFather(form fmd);
	UShort FmSubfRow(form fmd);
	void FmToDb(form fmd, fmfield from, fmfield to, ...);
	void FmToTable(form fmd, dbtable tab, ...);
	void DbToFm(form fmd, fmfield from, fmfield to, ...);
	void TableToFm(dbtable tab, form fmd, ...);
	char *FmFldPrev(form fmd);
	int FmFldLen(form fmd, fmfield fn);
	bool FmChgFld(form fmd);
	void FmSetKeyCode(form fmd, UChar code);
	UChar FmKeyCode(form fmd);
	fmfield FindFmField(form fmd, const char *s);
	fmfield FmFindField(form fmd, int rowno, int col, int *mult_row);
	bool FmIsKeyField(form fmd, fmfield fld);
	bool FmIsControlField(form fmd, fmfield fld);
	FmValueObj *_checkField(form fmd, fmfield fn, char *fun);
	char *Detail(FmValueObj *f, char *funct);
	char *FmSFld(form fmd, fmfield fn, ...);
	bool FmIsNull(form fmd, fmfield fn, ...);
	fmfield FmInMult(form fmd, fmfield fn);
	void FmGetFld(char *buf, form fmd, fmfield fn, ...);
	int FmIFld(form fmd, fmfield fn, ...);
	Int FmLFld(form fmd, fmfield fn, ...);
	double FmFFld(form fmd, fmfield fn, ...);
	DATE FmDFld(form fmd, fmfield fn, ...);
	TIME FmTFld(form fmd, fmfield fn, ...);
	NUM FmNFld(form fmd, fmfield fn, ...);
	UShort FmInOffset(form fmd);
	void FmSetInOffset(form fmd, UShort n);
	char *FmInValue(form fmd, fmfield fn, UShort ndx);
	char *FmInDescr(form fmd, fmfield fn, UShort ndx);
	void FmSetFld(form fmd, fmfield fn, char *buf, ...);
	void FmSetIFld(form fmd, fmfield fn, int val, ...);
	void FmSetLFld(form fmd, fmfield fn, Int val, ...);
	void FmSetFFld(form fmd, fmfield fn, double val, ...);
	void FmSetDFld(form fmd, fmfield fn, DATE val, ...);
	void FmSetTFld(form fmd, fmfield fn, TIME val, ...);
	void FmSetNFld(form fmd, fmfield fn, NUM *val, ...);
	void FmSetMask(form fm, fmfield fld, char *mask);
	form FmFindForm(window wd);
	bool FmIsSubForm(form fmd);
	void _setLFld(FmValueObj *f, char *msg, Int val, Int rowno);
	CFormRep *_CheckForm(Int fmd);
}

CFormRep * loadCFormRep(String theFormName);

class CFormRep : public FormRep {
	typedef FormRep inherited;
	
	/*
	friend void CloseForm(form fmd);
	friend void CloseAllForms(void);
	friend fm_cmd DoForm(form fmd, fm_status_fp beforeIx,
							 fm_status_fp afterIx);
	friend void FmClearFlds(form fmd, fmfield from, fmfield to, ...);
	friend void FmSetDisplayOnly(form fmd, fmfield from, fmfield to, 
									 bool value);
	friend void FmClearAllFlds(form fmd);
	friend void DisplayForm(form fmd);
	friend void ClearForm(form fmd);
	friend fm_status FmErrMsg(form fm, int m, ...);
	friend void FmRecalc(form fmd, UShort curr_row);
	friend Int FmCheckSum(form fmd);
	friend void FmVerifyCheckSum(form fmd, Int chksum);
	friend int FmNextFld(form fmd, fmfield fno, ...);
	friend void FmShowFlds(form fmd, fmfield from, fmfield to, ...);
	friend void FmShowAllFlds(form fmd);
	friend void FmSetStatus(form fmd, fm_status sts);
	friend void FmSetError(form fmd, fmfield fld, ...);
	friend fm_status FmStatus(form fmd);
	friend form UseSubform(form fmd, fmfield fld, UShort subf_n, ...);
	friend fm_cmd DoSubform(form fmd, fm_status_fp beforeIx, 
							fm_status_fp afterIx, fmfield fld, UShort subf_n, ...);
	friend int FmSubformId(form fmd);
	friend form FmFather(form fmd);
	friend UShort FmSubfRow(form fmd);
	friend void FmToDb(form fmd, fmfield from, fmfield to, ...);
	friend void FmToTable(form fmd, dbtable tab, ...);
	friend void DbToFm(form fmd, fmfield from, fmfield to, ...);
	friend void TableToFm(dbtable tab, form fmd, ...);
	friend char *FmFldPrev(form fmd);
	friend int FmFldLen(form fmd, fmfield fn);
	friend bool FmChgFld(form fmd);
	friend void FmSetKeyCode(form fmd, UChar code);
	friend UChar FmKeyCode(form fmd);
	friend fmfield FindFmField(form fmd, const char *s);
	friend fmfield FmFindField(form fmd, int rowno, int col, int *mult_row);
	friend bool FmIsKeyField(form fmd, fmfield fld);
	friend bool FmIsControlField(form fmd, fmfield fld);
	friend FmValueObj *_checkField(form fmd, fmfield fn, char *fun);
	friend char *Detail(FmValueObj *f, char *funct);
//	friend void FmFieldRep::setFld(const char *buf, Int rowno);
//	friend char *FmFieldRep::getFld(char *funct, Int rowno);
	friend char *FmSFld(form fmd, fmfield fn, ...);
	friend bool FmIsNull(form fmd, fmfield fn, ...);
	friend fmfield FmInMult(form fmd, fmfield fn);
	friend void FmGetFld(char *buf, form fmd, fmfield fn, ...);
	friend int FmIFld(form fmd, fmfield fn, ...);
	friend Int FmLFld(form fmd, fmfield fn, ...);
	friend double FmFFld(form fmd, fmfield fn, ...);
	friend DATE FmDFld(form fmd, fmfield fn, ...);
	friend TIME FmTFld(form fmd, fmfield fn, ...);
	friend NUM FmNFld(form fmd, fmfield fn, ...);
	friend UShort FmInOffset(form fmd);
	friend void FmSetInOffset(form fmd, UShort n);
	friend char *FmInValue(form fmd, fmfield fn, UShort ndx);
	friend char *FmInDescr(form fmd, fmfield fn, UShort ndx);
	friend void FmSetFld(form fmd, fmfield fn, char *buf, ...);
	friend void FmSetIFld(form fmd, fmfield fn, int val, ...);
	friend void FmSetLFld(form fmd, fmfield fn, Int val, ...);
	friend void FmSetFFld(form fmd, fmfield fn, double val, ...);
	friend void FmSetDFld(form fmd, fmfield fn, DATE val, ...);
	friend void FmSetTFld(form fmd, fmfield fn, TIME val, ...);
	friend void FmSetNFld(form fmd, fmfield fn, NUM *val, ...);
	friend void FmSetMask(form fm, fmfield fld, char *mask);
	friend void _setLFld(FmValueObj *f, char *msg, Int val, Int rowno);
	friend form FmFindForm(window wd);
	friend bool FmIsSubForm(form fmd);
	friend CFormRep *_CheckForm(Int fmd);

	// gencf interface
	friend void gencf(char *Path, char *FileName);
	friend void NumberSubf(FILE *out, CFormRep *fp, int nivel);
	friend void AllFields(CFormRep *fp);
	friend void CheckFields(CFormRep *pp, dbindex idx, int nivel);
	friend void AllSubforms(FILE *out, CFormRep *fp);
	friend void PreYPos(FILE *out, char nom[20], int cual, CFormRep *fp);
	friend void Abm(FILE *out, CFormRep *fp);
	friend void UpDate(FILE *out, CFormRep *fp);
	friend dbindex ChooseKey(dbtable xtab);
	friend int BuscaMulti(int match, dbindex idx);

	// fdump interface
	friend void showFormSize(int &argc, char **&argv);

	// doform interface
	friend void extractValues(form fmd);
	friend dbtable ChooseTab(CFormRep *fp);
	friend void CheckFields(CFormRep *pp, dbindex idx);
	friend void PassToFm(form fm);
	friend void PassToDb(form fm);
	friend FmValueObj *_check_field(form fm, fmfield fn);
	
	// execform interface
	friend int execForm(form fmd, String& procedure, int exmode,
						int pnrows, int pncols, bool restart);

	friend Fm::Action before(FmField &fld);
	friend Fm::Action after(FmField &fld);
	*/

	// now the members
	static gtype(PtrArray, CFormRep) forms_d;

	Int id_;
	fm_status_fp beforeFunc_;
	fm_status_fp afterFunc_;

	// 'two-element-queue' of actions to be executed
	FmAction *currAction_d;				// action to 'call'
	FmAction *nextAction_d;			// next action to 'call'

	void initValues();

public:

	CFormRep();
	virtual ~CFormRep();

	virtual CFormRep *getCFormRep();
	virtual Fm::Action callUserAction(Fm::Event event);
//	virtual bool callUserBefore(FmFieldObj *theObject, Int rowNo = 0);
//	virtual bool callUserAfter(FmFieldObj *theObject, Int rowNo = 0);

	virtual void executeAction(FmAction &);

	Fm::Event doForm();
	Fm::Event doSubform();

	virtual FormRep *createSubform();

	inline FmAction &currAction() const;
	void addActionInQueue(FmAction &actn);
	void advanceActionQueue();
	void assignCallBacks(fm_status_fp beforeIx, fm_status_fp afterIx);
	
	void display(bool s);
	void flushActions();

	// get & set action's result
	Fm::Action result() const;
	void result(Fm::Action r);

	Int id() const;
	Int assignId();

	struct EnumCSubforms : public EnumerateSubforms {
		CFormRep *cform;
		virtual bool execute() = 0;
		virtual bool execute(FormRep *obj);
	};
	
	static CFormRep *getForm(Int fmd);
	static bool validForm(Int fmd);
	static void close(Int fmd);
	static void closeAll();

	virtual String type() const;
	
	void setOnKeyCallBack(Int Fkey, fm_status_fp Fp, 
					   FmFieldObj *From = NULL, FmFieldObj *To = NULL );
	void setOnKeyCallBack(const wxKeyEvent &Fkey, fm_status_fp Fp, 
					   FmFieldObj *From = NULL, FmFieldObj *To = NULL );
    void setCallBack(CallBack type, fm_status_fp Fp, 
		 			   FmFieldObj *From = NULL, FmFieldObj *To = NULL );

    void setCallBack(FmCallBackEvent *event, fm_status_fp Fp, 
		 			   FmFieldObj *From = NULL, FmFieldObj *To = NULL );
};

#include <ideafix/priv/cfmrep.icc>

#endif
