/********************************************************************
* Copyright (c) 1996 InterSoft Co.  All Rights Reserved
* THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF InterSoft Co.
* The copyright notice above does not evidence any
* actual or intended publication of such source code.
*
* $Id: dbimplem.h,v 1.5 1996/06/06 21:02:41 pablog Exp $
*
* DESCRIPTION
*********************************************************************/

#ifndef DBIMPLEM_H
#define DBIMPLEM_H

#include <ifound.h>

#ifdef __GNUC__
#	pragma interface
#endif


class DataBaseImplem
 {

// private:

	useIdCheck(DataBaseImplem
_id);

protected:

	DataBaseRep *dataBase_x;
	
public:

	DataBaseImplem
(DataBaseRep *db);
	virtual ~DataBaseImplem
();

	static DataBaseImplem
 *create(DataBaseRep *db);

	inline DataBaseRep *dataBase();
	
	virtual Int lock(Int l) = 0;
	virtual void free() = 0;
};

class DbSetImplem
 {

// private:

	useIdCheck(DbSetImplem
_id);

protected:

	DbSetRep *set_x;
	
public:

	DbSetImplem
(DbSetRep *set);
	virtual ~DbSetImplem
();

	virtual Int get(DbObjectRep *obj, Int mode, Int nparts) = 0;
	virtual void free(DbIndexRep *index, DbObjectRepBuffer *buffer, Int mode, Int nparts) = 0;
	virtual Int find(DbIndexRep *index, DbObjectRepBuffer *buffer, Int mode, Int nparts) = 0;
	virtual void del(DbObjectRepBuffer *buffer) = 0;
	virtual void add(DbObjectRepBuffer *buffer) = 0;
	virtual void put(DbObjectRepBuffer *buffer) = 0;

	virtual Int lock(Int lockMode) = 0;
	virtual void free() = 0;

	virtual Int delAll() = 0;
};

class DbIndexImplem
 {

// private:

	useIdCheck(DbIndexImplem
_id);

protected:

	DbIndexRep *index_x;
	
public:

	DbIndexImplem
(DbIndexRep *index);
	virtual ~DbIndexImplem
();
};

class DbCursorImplem
 {

// private:

	useIdCheck(DbCursorImplem
_id);

protected:

	DbCursorRep *cursor_x;
	
public:

	DbCursorImplem
(DbCursorRep *cursor);
	virtual ~DbCursorImplem
();
};

#include <ideafix/priv/dbimplem.icc>

#endif
