// --------------------------------------------------------------------------
// Copyright (c) 1995 InterSoft Co.  All Rights Reserved
// THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF InterSoft Co.
// The copyright notice above does not evidence any actual or intended 
// publication of such source code.
//
// $Id: enumobj.h,v 1.4 1996/07/03 14:14:50 hernan Exp $
//
// Description:
// --------------------------------------------------------------------------

#ifndef ENUMOBJ_H
#define ENUMOBJ_H

#include <ifound/str.h>

class gtype(PtrArray, EnumObjectEntry);

class EnumObjectEntry {

public:

	inline EnumObjectEntry(const String &enumName, Int val = INT_MIN,
			const String &shortDescr = NULL_STRING,
			const String &longDescr = NULL_STRING, bool fix = false);

	inline Int value() const;
	inline const String &name() const;

	void shortDescr(const String &shortDesc);
	inline const String &shortDescr() const;
	void longDescr(const String &longDesc);
	inline const String &longDescr() const;

	inline bool fixed(void) const;
	inline void value(Int );
	inline void name(const String & );
	inline void fixed(bool );

	EnumObjectEntry(const EnumObjectEntry&);

private:

	String enumName_d;
	Int value_d;
	String shortDescr_d;
	String longDescr_d;

	bool fixed_d;
};

class EnumObject {

public:

	EnumObject(const String &nm);
	virtual ~EnumObject();

	Int numEntries() const;
	EnumObjectEntry *entry(Int i) const;

	bool addEntry(const String &entryName, Int val = INT_MIN);
	EnumObjectEntry *findEntry(const String &entryName) const;
	EnumObjectEntry *findEntry(Int value) const;
	void resolveDescriptions(const String &msg);
	
	inline const String &name() const;

	// for debugging only...
	void print();

	EnumObject(const EnumObject &eo);
	bool addEntry(Int pos,const String &entryName, Int val = INT_MIN);
	bool addEntry(Int pos,EnumObjectEntry *ent);
	void setEnumValues(void);
	void delEntry(Int pos);
	void setValue(Int pos,Int val = INT_MIN);
	void setName(Int pos,const String &nm);
	void name(const String &nm);

private:

	String name_d;
	gtype(PtrArray, EnumObjectEntry) &entries_d;

};

#include <ideafix/priv/enumobj.icc>

#endif
