// -----------------------------------------------------------------------
// Copyright (c) 1995 InterSoft Co.  All Rights Reserved
// THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF InterSoft Co.
// The copyright notice above does not evidence any actual or intended 
// publication of such source code.
//
// $Id: fmbase.h,v 1.7 1996/08/15 16:36:08 eduardoc Exp $
//
// Description:
// -----------------------------------------------------------------------

#ifndef FMBASE_H
#define FMBASE_H

#ifdef __GNUC__
#pragma interface
#endif

#include <ideafix/priv/fmobj.h>

class wxItem;
class wxPanel;
class wxStaticItem;
class gtype(PtrArray, wxItem);
class gtype(PtrArray, wxStaticItem);

class FmBaseItem : public FmObject {
	typedef FmObject inherited;

	gtype(PtrArray, wxItem)	&items_;

protected:
	virtual wxItem *new_wxItem(wxPanel *panel,
				int x, int y, int w, int h, Int style, char *name) = 0;

	FM_DECLARE_WXOBJECTS

public:
	FmBaseItem();
	~FmBaseItem();

	FM_DECLARE_ABSTRACT_CLASS
	
	// get object's associated item(s)
	virtual wxItem *item(Int row = 0) const;
	
	virtual void updateOffset();
};


class FmBaseStatic : public FmObject {
	typedef FmObject inherited;

	gtype(PtrArray, wxStaticItem)	&items_;
	
protected:
	virtual wxStaticItem *new_wxStatic(wxPanel *panel,
				int x, int y, int w, int h, Int style, char *name) = 0;
	
	FM_DECLARE_WXOBJECTS

public:
	FmBaseStatic();
	~FmBaseStatic();

	FM_DECLARE_ABSTRACT_CLASS
	
	// get object's associated item(s)
	wxStaticItem *getStatic(Int row = 0) const;

	virtual void updateOffset();
};

#include <ideafix/priv/fmbase.icc>

#endif
