// -----------------------------------------------------------------------
// Copyright (c) 1995 InterSoft Co.  All Rights Reserved
// THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF InterSoft Co.
// The copyright notice above does not evidence any actual or intended 
// publication of such source code.
//
// $Id: fmitem.h,v 1.7 1996/08/15 16:36:26 eduardoc Exp $
//
// Description:
// -----------------------------------------------------------------------

#ifndef FMITEM_H
#define FMITEM_H

#ifdef __GNUG__
#	pragma interface
#endif

#include <ideafix/priv/fmbase.h>

class wxItem;
class wxEvent;
class wxBitmap;
typedef wxBitmap FmBitmap;

class FmButton : public FmBaseItem
{      
    typedef FmBaseItem inherited;
    
public:
	enum LabelType {
			LABEL_NONE	= 0,
			LABEL_STRING,
			LABEL_BITMAP
	};

protected:
	Fm::Event	actionId_;       
	LabelType 	labelType_; 
	String 		label_;
	String		bitmapName_;
	FmBitmap	*bitmap_;
	FmValueObj	*field_;
	
protected:
  	static void actionFunc(wxItem& item, wxEvent& event);
	virtual wxItem *new_wxItem(wxPanel *panel,
					int x, int y, int w, int h, Int style, char *name);

public:
  	FmButton();
  	~FmButton();             

	FM_DECLARE_CLASS

	virtual String nfmItemName() const;

	void initValues();
	    
 	void label(const String& label);
 	void bitmapName(const String& bitmapName);  	 
 	void bitmap(FmBitmap *bitmap);
	void actionId(Int actionId);
	inline Fm::Event actionId() const;
 	inline FmValueObj *field() const;
};
/* ------------------------------------------------------------ */


class FmStaticText : public FmBaseItem
{      
    typedef FmBaseItem inherited;
    
	String 		label_;
	
protected:
	virtual wxItem *new_wxItem(wxPanel *panel,
					int x, int y, int w, int h, Int style, char *name);

public:
  	FmStaticText();
  	~FmStaticText();             

	FM_DECLARE_CLASS

	virtual String nfmItemName() const;

 	void label(const String& label);
};

#include <ideafix/priv/fmitem.icc>

#endif /* FMITEM_H */
