// -----------------------------------------------------------------------
// Copyright (c) 1995 InterSoft Co.  All Rights Reserved
// THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF InterSoft Co.
// The copyright notice above does not evidence any actual or intended 
// publication of such source code.
//
// $Id: fmmenu.h,v 1.2 1996/07/15 19:53:38 eugen Exp $
//
// Description:
// -----------------------------------------------------------------------

#ifndef FMMENU_H
#define FMMENU_H

#ifdef __GNUC__
#pragma interface
#endif

#include <ideafix/priv/fmobj.h>

class FmAction;
class FmMenuBar;

class wxMenu;
class wxMenuBar;

class FmMenuItem;
class FmMenuItemSubmenu;
class gtype(PtrArray, FmMenuItem);

class FmMenuItem : public Resource {
public:
	FmMenuItem(FmMenuItemSubmenu *menu, const String &label = NULL_STRING);
	virtual ~FmMenuItem();
	
	FmMenuItemSubmenu *owner() const;
	const String &label() const;

	virtual FormRep *formRep() const;

	virtual void wxCreate(wxMenuBar *menuBar);
	virtual void wxCreate(wxMenu *menu) = 0;

	enum Type {
		separator,
		action,
		submenu
	};

	virtual Type type() const = 0;
	virtual void store(FILE *out) const;
	virtual bool load(FILE *in);

	virtual String nfmItemHeader() const = 0;
	virtual void storeNfmMenuItem(FILE *out) const;

	virtual Int numItems(void) const;
	virtual FmMenuItem *item(Int index);
	virtual const String &actionName(void) const;

private:
	FmMenuItemSubmenu *owner_x;
	String label_d;
};

class FmMenuItemSimple : public FmMenuItem {
	typedef FmMenuItem inherited;
	
public:
	FmMenuItemSimple(FmMenuItemSubmenu *menu, 
			const String &name = NULL_STRING,
			const String &label = NULL_STRING);

	const String &actionName() const;
	
	void wxCreate(wxMenu *menu);

	Type type() const;
	void store(FILE *out) const;
	bool load(FILE *in);
	
	String nfmItemHeader() const;

private:
	FmAction &formAction() const;

	String actionName_d;
};

class FmMenuItemSeparator : public FmMenuItem {
	typedef FmMenuItem inherited;

public:
	FmMenuItemSeparator(FmMenuItemSubmenu *menu);

protected:
	void wxCreate(wxMenu *menu);

	String nfmItemHeader() const;

	Type type() const;
};

class FmMenuItemSubmenu : public FmMenuItem {
	typedef FmMenuItem inherited;

public:
	FmMenuItemSubmenu(FmMenuItemSubmenu *menu, const String &label = NULL_STRING);
	~FmMenuItemSubmenu();
	
	Int addItem(FmMenuItem *item);
	void delItem(FmMenuItem *item);
	void delItem(Int index);
	FmMenuItem *item(Int index);

	void wxCreate(wxMenuBar *menuBar);
	void wxCreate(wxMenu *menu);

	Type type() const;
	void store(FILE *out) const;
	bool load(FILE *in);
	
	FmMenuItem *loadItem(FILE *in);
	
	String nfmItemHeader() const;
	void storeNfmMenuItem(FILE *out) const;

	Int numItems(void) const;

protected:
	gtype(PtrArray, FmMenuItem) &items_d;

private:
	wxMenu *wxCreate();
};

class FmMenuBar : public FmObject, public FmMenuItemSubmenu {
	typedef FmObject inherited;

public:
	FmMenuBar();
	~FmMenuBar();

	FM_DECLARE_CLASS

	String nfmItemName() const;

	FormRep *formRep() const;

	FM_DECLARE_WXOBJECTS
	
	void storeHeader(FILE *out) const;
	bool loadHeader(FILE *in);
	void storeNfm(FILE *out) const;
};

#include <ideafix/priv/fmmenu.icc>

#endif


