// -----------------------------------------------------------------------
// Copyright (c) 1995 InterSoft Co.  All Rights Reserved
// THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF InterSoft Co.
// The copyright notice above does not evidence any actual or intended 
// publication of such source code.
//
// $Id: fmpopup.h,v 1.3 1996/07/15 19:53:45 eugen Exp $
//
// Description:
// -----------------------------------------------------------------------

#ifndef FMPOPUP_H
#define FMPOPUP_H

#ifdef __GNUC__
#pragma interface
#endif

#include <ifound.h>

class FramedObject;

class MenuLines {
public:
	// indexes are from 0
	virtual ~MenuLines();
	virtual String getLine(Int i);
	virtual bool exec(Int i);
	virtual bool hasExec();
};

class OldMenuLines : public MenuLines
{
public:
	OldMenuLines(CPFPCPI, char*, FPCPPI = 0, char ** = 0);
	
	String getLine(Int i);
	bool hasExec();
	bool exec(Int i);

private:
	CPFPCPI getLine_x;
	char	*getLineArg_x;
	FPCPPI	exec_x;
	char	**execArg_x;
};

#ifndef POP_DEFAULT
#	define POP_STATIC	1	/* el menu queda si eje. op.	 		*/
#	define POP_VOLATIL	2	/* el menu desaparece si ejec. op.		*/
#	define POP_BORDER	4	/* el borde cambia a simple si ejec. op.*/
#	define POP_BLINK	8	/* la opcion se pone en blinking si ejec. op. */
#	define POP_DEFAULT POP_STATIC|POP_BORDER
#endif

Int PopUpMenuLines(Int nrows, Int ncols,
		const String &label, MenuLines &lines, 
		FramedObject *parent = 0, Int x = 0, Int y = 0,
		Int attrib = POP_DEFAULT);

extern "C" {
int	PopUpMenu(int nRows,int nCols, char *label,
		CPFPCPI getLine, char*getArg, FPCPPI exec, char**execArg, int attrib);
int PopUpVMenu(int nfils, int ncols, char *label, char *argv[]);
int PopUpLMenu(int nfils, int ncols, const char *label, ...);
};

#endif

