// -----------------------------------------------------------------------
// Copyright (c) 1995 InterSoft Co.  All Rights Reserved
// THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF InterSoft Co.
// The copyright notice above does not evidence any actual or intended 
// publication of such source code.
//
// $Id: fmstat.h,v 1.6 1996/08/15 16:36:34 eduardoc Exp $
//
// Description:
// -----------------------------------------------------------------------

#ifndef FMSTAT_H
#define FMSTAT_H

#ifdef __GNUC__
#pragma interface
#endif

#include <ideafix/priv/fmbase.h>

class wxBitmap;
typedef wxBitmap FmBitmap;

class FmStaticBox : public FmBaseStatic {
    typedef FmBaseStatic inherited;

	Int shadow_;
    Int mask_;
    Int sstyle_;

protected:
	FM_DECLARE_WXOBJECTS
	
    virtual wxStaticItem *new_wxStatic(wxPanel *panel,
				int x, int y, int w, int h, Int style, char *name);
				
public:
  	FmStaticBox();
  	~FmStaticBox();

	FM_DECLARE_CLASS

	virtual String nfmItemName() const;

	void initValues();

private:
	void shadow(Int shadow);
	void mask(Int mask);
	void sstyle(Int sstyle);
};

class FmStaticSeparator	: public FmBaseStatic {
    typedef FmBaseStatic inherited;

	Int shadow_;
    Int sstyle_;
    
protected:    
	FM_DECLARE_WXOBJECTS
    virtual wxStaticItem *new_wxStatic(wxPanel *panel,
				int x, int y, int w, int h, Int style, char *name);
				
public:
  	FmStaticSeparator();
  	~FmStaticSeparator();

	FM_DECLARE_CLASS

	virtual String nfmItemName() const;

	void initValues();
	    
private:
	void shadow(Int shadow);
	void sstyle(Int sstyle);
};

class FmStaticBitmap : public FmBaseStatic {
    typedef FmBaseStatic inherited;

	String bitmapName_;

protected:    
    virtual wxStaticItem *new_wxStatic(wxPanel *panel,
				int x, int y, int w, int h, Int style, char *name);
				
public:
  	FmStaticBitmap();
  	~FmStaticBitmap();

	FM_DECLARE_CLASS

	virtual String nfmItemName() const;

	void initValues();
	    
private:
	void bitmapName(const String& bitmapName);
};
 
#endif

