// -----------------------------------------------------------------------
// Copyright (c) 1995 InterSoft Co.  All Rights Reserved
// THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF InterSoft Co.
// The copyright notice above does not evidence any actual or intended 
// publication of such source code.
//
// $Id: fmsubf.h,v 1.5 1996/07/15 19:53:50 eugen Exp $
//
// Description:
// -----------------------------------------------------------------------

#ifndef FMSUBF_H
#define FMSUBF_H

#ifdef __GNUG__
#	pragma interface
#endif

#include <ideafix/priv/fmobj.h>
#include <ideafix/priv/fmrep.h>

class FunctionVal;
class gtype(OptionValueArray, FunctionVal);

typedef Byte SubformIndex;

class SubformDescr;
class gtype(SimpleArray, SubformDescr);

class FmSubform : public FmFieldObj {
	typedef FmFieldObj inherited;

public:
	FmSubform();
	~FmSubform();
	
	FM_DECLARE_CLASS

	virtual String nfmItemName() const;

	virtual FieldType fType() const;
	
	virtual Int alignSize() const;
	virtual Int bufferSize() const;

	bool _isNull(FmBufferRow br) const;
	void _clear(FmBufferRow br);

	bool _copyFieldToDb(FmBufferRow br, InTableVal *join);
	bool _copyFieldFromDb(FmBufferRow br, InTableVal *join);
	bool _removeFieldFromDb(FmBufferRow br, InTableVal *join);

	void _allocBuffer(FmBufferRow br);
	void _freeBuffer(FmBufferRow br);
	void _sendBuffer(RequestConnection &conn, FmBufferRow br);
	void _receiveBuffer(RequestConnection &conn, FmBufferRow br);

	bool isNew(Int row) const;

	// display && hide subform window
	FormRep *currentSubform(Int row) const;
	SubformIndex currentSubformIndex(Int row) const;

	FormRep *useSubform(SubformIndex index, Int row);
	void resolveArgs(FmFieldObj *callerObj, Int callerRow, Int index, 
						FormalArg::Type type, bool onlyCheck = false);

	// add & query subforms
	// values must be already in list 'addInListValue'
	void addSubforms(gtype(OptionValueArray, FunctionVal) *s);
	void clearSubforms();
	void clearSubform(FormRep *subform);
	void setSubform(FormRep *subform);
	
	SubformIndex numSubforms() const;
	const String &subformName(SubformIndex index) const;
	FormRep *subform(SubformIndex index) const;
	SubformIndex subformIndex(const String &name) const;
	
	bool loadSubforms();

	Fm::Event doSubform(Int index, Int row, bool always,
			FmFieldObj *callerObj, Int callerRow);
	void endSubform(Fm::Event event);
	
    FormRep *selectSubform(const FmBufferRow br, SubformIndex index);
	FormRep *currentSubform(FmBufferRow br) const;
	SubformIndex currentSubformIndex(FmBufferRow br) const;
	FmBuffer *currentSubformBuffer(FmBufferRow br) const;

protected:

	FM_DECLARE_BUILDING
	FM_DECLARE_WXOBJECTS

private:

	gtype(SimpleArray, SubformDescr) &subfs_;	// Subforms w/ names

	struct Data {
		FmBuffer buffer;
		SubformIndex index;
		bool changed;
	
		Data() : buffer(NULL) {}
	};

	Data *subformBuffer(FmBufferRow br) const;

	FormRep *currentSubform(const Data *data) const;
	SubformIndex currentSubformIndex(const Data *data) const;
	void setSubformIndex(Data *data, SubformIndex index) const;

	// find subform by descr
	SubformDescr *findSubform(const String &name);
	SubformDescr *findSubform(const FormRep *object);
};

#include <ideafix/priv/fmsubf.icc>

#endif
