// -------------------------------------------------------------------------
// Copyright (c) 1995 InterSoft Co.  All Rights Reserved
// THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF InterSoft Co.
// The copyright notice above does not evidence any actual or intended 
// publication of such source code.
//
// $Id: gridcc.h,v 3.1 1996/07/30 15:11:12 ksa Exp $
//
// Description:
// Declaration of the Grid object and related functions, for
// creating grid filled with text strings.  
// -------------------------------------------------------------------------
                                           
#ifndef GRIDCC_H
#define GRIDCC_H

#ifdef __GNUC__
#pragma interface
#endif

#include <ifound/mainobj.h>
#include <ideafix/priv/griddev.h>

class RequestConnection;
class GridColumn;
class String;

class CrkCliGridDev : public GridDev , public FramedObject
{
    Int x_d, 
    	y_d, 
    	w_d, 
    	h_d;

public:

	CrkCliGridDev(GridRep *grep, const String &name, Int x, Int y, Int w, Int h);
	virtual ~CrkCliGridDev();
    
	virtual bool execute();
    void sendLine(RequestConnection &conn);
    void getNextLine(RequestConnection &conn);
	void restart(RequestConnection &conn);
	
	// From FramedObject
	virtual bool canUseCracker() const;
	virtual bool crackerCreate(RequestConnection &conn);
	virtual void crackerDestroy(RequestConnection &conn);
	virtual void startMessageLoop();
	virtual void stopMessageLoop();
	
	bool processRequest(RequestConnection &conn);
};
#endif
