// -------------------------------------------------------------------------
// Copyright (c) 1995 InterSoft Co.  All Rights Reserved
// THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF InterSoft Co.
// The copyright notice above does not evidence any actual or intended 
// publication of such source code.
//
// $Id: gridcd.h,v 3.4 1996/07/30 15:11:13 ksa Exp $
//
// Description: Character dump device 
// -------------------------------------------------------------------------

#ifndef GRIDCD_H
#define GRIDCD_H

#ifdef __GNUC__
#	pragma interface
#endif

#include <ideafix/priv/griddev.h>

class CDGridDev : public GridDev {
protected:
	char 	borders_d[12],
		 	more_d,
			*dump_d;
	Int		saveStatus_d;

	Int 	nColumns_d,
			*columns_d,
			width_d,
			height_d,
			totalWidth_d,
			*widths_d,
			lineCount_d,
			cPos_d,
			page_d;
	
public:

	CDGridDev(GridRep *grep, const String &name, int dest, int ncopies);
	~CDGridDev();
    
    virtual void build();
	void build(String fileName, Int from=0, Int to = - 1, bool selection = false);

    Int width() 	{ return width_d;		}
    Int height()	{ return height_d + 1;	}
    char* borders()	{ return borders_d;		}
    char  more()	{ return more_d;		}

    void width(Int w) 	{ width_d = w;		}
    void height(Int h)	{ height_d = h - 1;	}
	void more(char m)	{ more_d = m;		}
    void borders(char*b);
    
	virtual bool execute();
	void save(int);
	void save(char);
	void save(const char*);
	virtual bool saveHeaders();
	virtual bool saveGrid();
	void saveBottom();
	void flushPage();
	void saveHeader(Int);
	void saveDelimiter(Int col);
	void drawColumns(Int row);
	void saveCell(Int row, Int col);
	void saveCellDelimiter(Int row, Int col);
};

#endif
