// -------------------------------------------------------------------------
// Copyright (c) 1995 InterSoft Co.  All Rights Reserved
// THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF InterSoft Co.
// The copyright notice above does not evidence any actual or intended 
// publication of such source code.
//
// $Id: griddev.h,v 3.5 1996/07/30 15:11:14 ksa Exp $
//
// Description:
// Declaration of the Grid object and related functions, for
// creating grid filled with text strings.  
// -------------------------------------------------------------------------

#ifndef GRIDDEV_H
#define GRIDDEV_H

#ifdef __GNUC__
#	pragma interface
#endif

#include <ideafix/priv/gridrep.h>

class FramedObject; 

class GridDev : public Resource {
protected:

	GridRep *grep_d;
	String name_d;
	Int type_d;
	Int x_offset_d;
	Int y_offset_d;
	Int last_x_offset_d;
	Int last_y_offset_d;
    
    FILE* file_d;          // For non-interactive devices
    String fileName_d;     // 
    int   dest_d;          //
    int   nCopies_d;       //
    Int   firstRow_d;      //
    Int   lastRow_d;       //
	bool  selection_d;     //
	bool  header_d;        //

public:

	GridDev();
	GridDev(GridRep *grep, const String &name, Int t, int dest, int ncopies);
	void create(GridRep *grep, const String &name, Int t, int dest, int ncopies);
	virtual ~GridDev();

	virtual void build() {}
	virtual void refreshAll() {}
    virtual bool execute() {return true;}
	virtual bool continueExecution();

	virtual void drawColumns(Int from, Int to) {}
	virtual void drawCell(Int col, Int row) {}
	virtual void drawSelectedLine(Int row) {}

	virtual void updateVirtualSize() {}

	inline bool gridIsDone() const;
	virtual void onClick(Int col, Int row);
	virtual bool onNextLine();

	inline void freeLines();
	inline void selectLine(Int);
	inline void unSelectLine(Int);
	inline bool lineSelected(Int);
	inline bool isSelection();
	inline Int nLinesSelected();
	inline Int selected(Int);

	virtual void lockColumn(Int c) {}
	inline Int  lastLocked() const;
	
	inline Int  xOffset() const;
	inline Int  lastXOffset() const;
	virtual void xOffset(Int offset);

	inline Int  yOffset() const;
	inline Int  lastYOffset() const;
	virtual void yOffset(Int offset);

	inline Int type() const;

	virtual void startMessageLoop() {}
	virtual void stopMessageLoop() {}
	virtual FramedObject* mainObject();

	inline Int numbersWidth() const;
	inline bool isNumbers() const;
	virtual void showNumbers(bool show);

	inline const String& name() const;
	inline Int items() const;
	inline Int nCols() const;
	inline Int base() const;
	inline void base(Int newbase);
	inline Int pageHeight() const;
	inline Int pageWidth() const;
	inline Int virtualHeight() const;
	inline Int virtualWidth() const;

	inline GridRep* grep();
	inline GridColumn *gridColumn(Int n) const;
	inline Int columnType(Int n) const;
	virtual Int columnWidth(Int n) const;
	virtual void columnWidth(Int n, Int w);
	inline Int columnOffset(Int n) const;
	inline bool columnLocked(Int n) const;
	inline bool columnShowed(Int c) const;
	inline bool columnClickable(Int c) const;
	inline bool columnSizeable(Int c) const;
	inline bool columnLockable(Int c) const;
	inline bool columnPrintable(Int c) const;
	virtual void showColumn(Int c, bool sh);
	inline String formattedValue(Int row, Int col);

	virtual void setLines(Int x, Int y);
	virtual void endGrid();
	virtual void abortGrid();
    virtual void restart();
    virtual bool saveHeaders();
    virtual bool saveGrid();
    
	virtual void initIconCache();
	bool openDestination();
};

#include <ideafix/priv/griddev.icc>

#endif
