// -------------------------------------------------------------------------
// Copyright (c) 1995 InterSoft Co.  All Rights Reserved
// THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF InterSoft Co.
// The copyright notice above does not evidence any actual or intended 
// publication of such source code.
//
// $Id: griddlg.h,v 3.4 1996/07/30 15:11:15 ksa Exp $
//
// Description:
// -------------------------------------------------------------------------

#ifndef GRIDDLG_H
#define GRIDDLG_H

#ifdef __GNUC__
#	pragma interface
#endif

#define gridSMALL_FONT   0
#define gridMEDIUM_FONT  1
#define gridLARGE_FONT   2

#include <ideafix/priv/gridwin.h>
#include <ideafix/priv/tdialg.h>

class WxGridDev;
class wxWindow;
class wxDialogBox;
class wxMessage;
class wxListBox;
class wxButton;
class wxCheckBox;
class wxRadioBox;
class wxText;
class wxChoice;
class wxItem;

class	PSGridDev;
class	CDGridDev;
class	DLGridDev;
class	FSGridDev;
class	SetupPostscriptPageDialog;
class	SetupDumpDialog;
class	SetupDelimitedDialog;
class	SetupFixedDialog;

class FontBox : public TableLayoutDialog
{
	typedef TableLayoutDialog inherited;
protected:
	wxFrame *parent_;

	wxMessage	*hFontMes_;
	wxChoice	*hFont_;
	int			hFontValue_;
	wxCheckBox	*hBold_;
	Bool		hBoldValue_;

	wxMessage	*gFontMes_;
	wxChoice	*gFont_;
	int			gFontValue_;
	wxCheckBox	*gBold_;
	Bool		gBoldValue_;

	wxCheckBox *mode_;
	Bool modeValue_;

public:

	FontBox(wxFrame *parent);
	~FontBox();
	void setValues(GCanvas::FONTS hfont = GCanvas::SMALL_FONT, Bool hbold = TRUE,
						   GCanvas::FONTS gfont = GCanvas::SMALL_FONT, Bool gbold = FALSE);
	void getValues(GCanvas::FONTS *hfont, Bool *hbold, 
						   GCanvas::FONTS *gfont, Bool *gbold, Bool *mode);
	void onOk();
	void onCancel();
	Bool OnClose();
};

class ShowBox : public TableLayoutDialog
{
	typedef TableLayoutDialog inherited;
protected:
	wxListBox	*hidden_,
				*showed_;
	wxButton	*showall_,
				*show_,
				*hide_;
	WxGridDev	*gdev_;
	bool		isShowed_d;
	Int			inShowed_,
				inHidden_;

public:

	ShowBox(wxWindow *parent,WxGridDev* gdev);
	~ShowBox();
	Bool Show(Bool);
	Bool Show();
	void update();
	void onHidden();
	void onShowed();
	void onShowAll();
	void onShow();
	void onHide();
	void onOk();
	void onCancel();
	Bool OnClose();
	Bool itemsCallback(wxItem*);
};

class SaveBox : public TableLayoutDialog
{
	typedef TableLayoutDialog inherited;
protected:
	wxWindow	*parent_;
	wxText		*fileName_d;
	wxButton	*browse_d;
	wxChoice	*dest_d;
	wxButton	*destSetup_d;
	wxChoice	*range_d;
	wxText		*from_d,
				*to_d;

	WxGridDev	*gdev_d;

	PSGridDev	*psDev_d;
	CDGridDev	*cdDev_d;
	DLGridDev	*dlDev_d;
	FSGridDev	*fsDev_d;

	SetupPostscriptPageDialog	*psDia_d;
	SetupDumpDialog			*cdDia_d;
	SetupDelimitedDialog	*dlDia_d;
	SetupFixedDialog		*fsDia_d;
	
	Bool		setupState_d,
				rangeState_d;
	Int			destId_d,
				rangeId_d,
				fromRow_d,
				toRow_d;

public:

	SaveBox(wxWindow *parent,WxGridDev* gdev);
	~SaveBox();
	Bool Show(Bool);
	void onBrowse();
	void onDest();
	void onDestSetup();
	void onRange();
	void onOk();
	void onCancel();
	Bool OnClose();
	void onCloseChild(void*);
	Bool itemsCallback(wxItem *o);
};

class SetupPostscriptDialog : public TableLayoutDialog
{
	typedef TableLayoutDialog inherited;
protected:
	WxGridDev	*gdev_d;
	PSGridDev	*psDev_d;
	SetupPostscriptPageDialog* paperDialog_d;
	wxRadioBox	*printTo_d;
	wxText		*printCommand_d,
				*printOptions_d,
				*fileName_d,
				*preview_d;
	wxButton	*browse_d,
				*paper_d;
	wxMessage	*printCommand_m,
				*printOptions_m,
				*fileName_m,
				*preview_m,
				*paper_m;
	char		*paperName_d;
public:

	SetupPostscriptDialog(wxWindow *parent,WxGridDev* gdev);
	~SetupPostscriptDialog();
	Bool itemsCallback(wxItem *);
	void onPrintTo();
	void onBrowse();
	void onPaper();
	void onOk();
	void onCancel();
	Bool OnClose();
	void onCloseChild(void*);
};

class SetupPostscriptPageDialog : public TableLayoutDialog
{
	typedef TableLayoutDialog inherited;
protected:
	PSGridDev	*dev_d;
	wxRadioBox	*paperTypes_d,
				*orient_d;
	wxText		*upMargin_d,
				*leftMargin_d,
				*rightMargin_d,
				*downMargin_d;
public:

	SetupPostscriptPageDialog(wxWindow *parent,PSGridDev* dev);
	~SetupPostscriptPageDialog();
	void onOk();
	void onCancel();
	Bool OnClose();
};

class SetupDumpDialog : public TableLayoutDialog
{
	typedef TableLayoutDialog inherited;
protected:
	CDGridDev	*dev_d;
	wxText		*widthTxt_d,
				*heightTxt_d,
				*borderTxt_d,
				*moreTxt_d;
	wxMessage	*mesWidth_d,
				*mesHeight_d,
				*mesMore_d,
				*mesBorder_d;

public:

	SetupDumpDialog(wxWindow *parent,CDGridDev* dev_d);
	~SetupDumpDialog();
	void onOk();
	void onCancel();
	Bool OnClose();
};

class SetupDelimitedDialog : public TableLayoutDialog
{
	typedef TableLayoutDialog inherited;
protected:
	wxCheckBox	*headerCB_d;
	wxText		*colDelTxt_d,
				*rowDelTxt_d;
	wxMessage	*mesCol_d,
				*mesRow_d;
	DLGridDev	*dev_d;
public:

	SetupDelimitedDialog(wxWindow *parent,DLGridDev* dev_d);
	~SetupDelimitedDialog();
	void onOk();
	void onCancel();
	Bool OnClose();
};


class SetupFixedDialog : public TableLayoutDialog
{
	typedef TableLayoutDialog inherited;
protected:
	wxCheckBox	*headerCB_d;
	wxText		*colDelTxt_d,
				*rowDelTxt_d;
	wxMessage	*mesCol_d,
				*mesRow_d;
	FSGridDev	*dev_d;
public:

	SetupFixedDialog(wxWindow *parent,FSGridDev* dev_d);
	~SetupFixedDialog();
	void onOk();
	void onCancel();
	Bool OnClose();
};

#endif
