// -------------------------------------------------------------------------
// Copyright (c) 1995 InterSoft Co.  All Rights Reserved
// THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF InterSoft Co.
// The copyright notice above does not evidence any actual or intended 
// publication of such source code.
//
// $Id: gridfm.h,v 3.4 1996/07/30 15:11:16 ksa Exp $
//
// Description: Formatted output  
// -------------------------------------------------------------------------

#ifndef GRIDFM_H
#define GRIDFM_H

#ifdef __GNUC__
#	pragma interface
#endif

#include <ideafix/priv/griddev.h>

class FMGridDev : public GridDev {
protected:

	Int 	nColumns_d,
			*columns_d;
	Int		saveStatus_d;
	Int		currentLine_d;
	String	heading_d,
			footing_d;
	Int 	fLen_d,
			leftM_d,
			topM_d,
			botM_d;
	
public:
	FMGridDev(GridRep *grep, const String &name, int dest = RP_IO_DEFAULT,
				int nCopies = 1);
	~FMGridDev();
    
    virtual void build();
	void build(String fileName, Int from = 0, Int to = -1, bool selection = false);
    
    void fLen(Int i)		{ fLen_d	= i;	}
    void leftMargin(Int i)	{ leftM_d	= i;	}
    void topMargin(Int i)	{ topM_d	= i;	}
    void botMargin(Int i)	{ botM_d	= i;	}
                                            
    bool  header()			{ return header_d;	}
    void  header(bool h)	{header_d = h;		}   
    
    void heading(String&);
    void footing(String&);
    virtual bool execute();
	void save(char);
	void save(const String&);
	virtual bool saveHeaders();
	virtual bool saveGrid();
	void saveHeader(Int);
	void saveCell(Int row, Int col);

	virtual void drawColumns(Int row);
	void endPage();
};

#endif
