// -------------------------------------------------------------------------
// Copyright (c) 1995 InterSoft Co.  All Rights Reserved
// THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF InterSoft Co.
// The copyright notice above does not evidence any actual or intended 
// publication of such source code.
//
// $Id: gridfs.h,v 3.4 1996/07/30 15:11:16 ksa Exp $
//
// Description: Character dump device 
// -------------------------------------------------------------------------

#ifndef GRIDFS_H
#define GRIDFS_H

#ifdef __GNUC__
#	pragma interface
#endif

#include <ideafix/priv/griddev.h>

class FSGridDev : public GridDev {

protected:

	String 	colDel_d,
			rowDel_d,
			colDelimiter_d,
			rowDelimiter_d;
	Int 	width_d,
			nColumns_d,
			*columns_d,
	  		*widths_d;
	Int		saveStatus_d;
	
public:

	FSGridDev(GridRep *grep, const String &name, int dest = RP_IO_DEFAULT,
			int nCopies = 1);
	~FSGridDev();
    
    virtual void build();
	void build(String fileName, Int from = 0, Int to = ERR, bool selection = false);

    bool  header()			{ return header_d;		}
    void  header(bool h)	{ header_d =	h;		}   

    String colDelimiter()	{ return colDelimiter_d;}
    String rowDelimiter()	{ return rowDelimiter_d;}
    void colDelimiter(String d);
    void rowDelimiter(String d);
	
	virtual bool execute();
	bool continueExecution();
	void save(char);
	void save(const char*);
	void save(const String&);
	virtual bool saveHeaders();
	virtual bool saveGrid();
	void saveHeader(Int);
	void saveCell(Int row, Int col);
    void findMaxSize(Int row);
	virtual void drawColumns(Int row);
};

#endif
