// -------------------------------------------------------------------------
// Copyright (c) 1995 InterSoft Co.  All Rights Reserved
// THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF InterSoft Co.
// The copyright notice above does not evidence any actual or intended 
// publication of such source code.
//
// $Id: gridps.h,v 3.4 1996/07/30 15:11:18 ksa Exp $
//
// Description:
// Declaration of the Grid object and related functions, for
// creating grid filled with text strings.  
// -------------------------------------------------------------------------

#ifndef GRIDPS_H
#define GRIDPS_H

#ifdef __GNUC__
#	pragma interface
#endif

#include <ideafix/priv/griddev.h>

class IconCache;
class GridIcon;
class wxPostScriptDC;
class wxFont;
class wxWindow;

class PSGridDev : public GridDev
{

protected:

	wxPostScriptDC* dc_d;
	Int		pageWidth_d,
		 	pageHeight_d;
	float	upMargin_d,
			leftMargin_d,
			rightMargin_d,
			downMargin_d;
	Int 	nHorPages_d;
	Int 	*columnOffsets_d,
			*columnWidths_d,
			*pageWidths_d;
	float	headerHeight_d,
			headerDescent_d,
			gridHeight_d,
			gridWidth_d,
			gridDescent_d,
			interLines_d;

	wxFont  *headFont_d,
			*gridFont_d;

	IconCache *icon_cache_d;
	Int icon_c_qn_d;
	
public:

	PSGridDev(GridRep *grep, const String &name);
	~PSGridDev();

	void build(Int from, Int to = -1, bool selection=false);
	void build(String fileName, Int from =0, Int to = -1, bool selection = false);
	virtual void build();
	void setup();
	void headFont(wxFont*);
	void gridFont(wxFont*);

	virtual bool execute();
	void calculateWidths();
	bool continueExecution ();
	void printHeader(Int c);
	void printCell(Int y,Int row,Int col);
	
	virtual Int xCharToPixel(Int xpos = 1) const;
	virtual Int yCharToPixel(Int ypos = 1) const;
	virtual Int xPixelToChar(Int xpos = 1) const;
	virtual Int yPixelToChar(Int ypos = 1) const;
	Int headerHeight() const;

	char* paperName();
	void  paperName(char*);
	void  orientation(int);
	inline Int upMargin();		
	inline Int leftMargin();	
	inline Int rightMargin();	
	inline Int downMargin();	
	inline void upMargin(Int m); 	
	inline void leftMargin(Int m);	
	inline void rightMargin(Int m);
	inline void downMargin(Int m);	

	GridIcon *icon(const String &name);
};

#include <ideafix/priv/gridps.icc>

#endif
