// -------------------------------------------------------------------------
// Copyright (c) 1995 InterSoft Co.  All Rights Reserved
// THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF InterSoft Co.
// The copyright notice above does not evidence any actual or intended 
// publication of such source code.
//
// $Id: gridwx.h,v 1.7 1996/07/30 15:11:20 ksa Exp $
//
// Description:
// Declaration of the Grid object and related functions, for
// creating grid filled with text strings.  
// -------------------------------------------------------------------------

#ifndef GRIDWX_H
#define GRIDWX_H

#ifdef __GNUC__
#	pragma interface
#endif

#include <ifound/mainobj.h>
#include <ideafix/priv/griddev.h>

class wxCanvas;
class wxFrame;
class PSGridDev;
class GridFrame;
class GridCanvas;
class LGridCanvas;
class HeadCanvas;
class LHeadCanvas;
class IconCache;
class GridIcon;

#ifdef wx_xview 
#define WxDalta 2
#else
#define WxDalta 0
#endif

class WxGridDev : public GridDev , public FramedObject
{
protected:

	wxFrame     *wp_d;
	GridFrame   *gridFrame_d;
	HeadCanvas  *headCanvas_d;
	LHeadCanvas *lHeadCanvas_d;
	GridCanvas  *gridCanvas_d;
	LGridCanvas *lGridCanvas_d;

	Int select_col_d;
	Int select_row_d;
	Int curr_c_off_d;

	Int icon_c_qn_d;
	IconCache *icon_cache_d;

public:

	WxGridDev();
	WxGridDev(GridRep *grep, const String &name, Int x, Int y);
	~WxGridDev();
    
	void create(GridRep *grep, const String &name, Int x, Int y);
	virtual void build();
	virtual bool execute();
	virtual void endGrid();
    virtual void abortGrid();
    
	virtual void refreshAll();
	void refreshGrid();
	void refreshLGrid();

	virtual bool selectedCell(Int *col = NULL, Int *row = NULL);
	virtual void selectCell(Int col, Int row);
	virtual void unSelectCell();
	virtual void stringOffset(Int c_off);
	virtual Int  stringOffset();
          
	virtual void drawColumns(Int x, Int y, Int w, Int h);
	virtual void drawColumns(Int from, Int to);
	virtual void drawCell(Int col,Int row);
	virtual void drawSelectedLine(Int row);

	virtual void updateVirtualSize();

	virtual void showColumn(Int n , bool sh);
	virtual void lockColumn(Int c);
	virtual Int columnWidth(Int n) const;
	virtual void columnWidth(Int n, Int w);

	virtual void xOffset(Int offset);
	virtual void yOffset(Int offset);
	inline Int xOffset() const;
	inline Int yOffset() const;

	virtual Int xCharToPixel(Int xpos = 1) const;
	virtual Int yCharToPixel(Int ypos = 1) const;
	virtual Int xPixelToChar(Int xpos = 1) const;
	virtual Int yPixelToChar(Int ypos = 1) const;

	Int sbarWidth() const;

	virtual void showNumbers(bool show);

	inline GridFrame*   gridFrame();
	inline GridCanvas*  gridCanvas();
	inline LGridCanvas* lGridCanvas();
	inline HeadCanvas*  headCanvas();
	inline LHeadCanvas* lHeadCanvas();
	
	
	virtual void setLines(Int x, Int y);
	void feedIconCache(Int from, Int to);
	GridIcon *icon(const String &name);

	// From FramedObject
	virtual bool canUseWxWindows() const;
	virtual bool wxWindowsCreate();
	virtual void wxWindowsDestroy();
	virtual void startMessageLoop();
	virtual void stopMessageLoop();
	virtual FramedObject* mainObject();	
	
};

#include <ideafix/priv/gridwx.icc>

#endif
