/********************************************************************
* Copyright (c) 1995 InterSoft Co.  All Rights Reserved
* THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF InterSoft Co.
* The copyright notice above does not evidence any
* actual or intended publication of such source code.
*
* $Id: ixsystem.h,v 1.4 1996/06/06 20:55:57 pablog Exp $
*
* DESCRIPTION
*
* ROUTINE       |  PURPOSE
*---------------+---------------------------------------------------
*********************************************************************/

#define UNITSFILE	"units"
#define GROUPSFILE	"groups"
#define CMENUEXT	".mno"
#define AUTHDIR		"AUTHDIR"

class IxSMenu;

class IxSystem {

// private:

	static void storeMenu(IxSMenu *menu, const String &fileName);
	static void loadMenu(IxSMenu *menu, const String &fileName);

	static void storeUnitsPerms(const String &storeDir, Int gpId);
	static void storeGroups(const String &storeDir);

	static String authDir(bool abort = true);
	
	static String compGroupInfo(Int &gpType, bool abort = true);
	static void dbGroupInfo(const String &gName, Int &gpId, Int &gpType);
	static String dbGroupInfo(Int &gpId, Int &gpType);

	static Int menuId(const String &unitName);

	static bool canExecUnit(Int unitId, Int gpId, Int gpType);

	static IxSMenu *generateMenu(Int unitId, const String &unitName, 
							  Int gpid, Int gpType);
	static IxSMenu *generateMenus(Int unitId, const String &unitName, 
							   Int gpId, Int gpType);

public:

	static String msg(const char *message);
	
	static bool readPermission(const String &unit);

	// execute checking in the database
	static Int execute(const String &unitName);

	// execute without checking in the database
	static Int exec(const String &unitName);

	static bool generate(const String &unitName, 
						 const String &grName = NULL_STRING);

	static String mnoFullName(const String &unit);

	static void destHost(const String &h);

	static Int moduleIsInstalled(Int modId);
	static Int moduleIsInstalled(Int modId, String &wsch);
	static bool moduleExists(Int modId, String &wsch);
};


