/********************************************************************
* Copyright (c) 1994 InterSoft Co.  All Rights Reserved
* THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF InterSoft Co.
* The copyright notice above does not evidence any
* actual or intended publication of such source code.
*
* $Id: repexpr.h,v 1.4 1996/05/31 14:45:35 gustavof Exp $
*
* DESCRIPTION
* Class definitions for ReportExpr Type.
*********************************************************************/

#ifndef REPEXPR_H
#define REPEXPR_H

#ifdef __GNUC__
#	pragma interface
#endif

#include <ifound/expr.h>
#include <ifound/functype.h>

#if HAVE_PRAGMA_PACK
#	pragma pack(4)
#endif

class ReportRep;

class ReportExpr : public Expr {
	
// private:

	ReportRep *rp;
	RpZoneRep *zrep;
	bool prevVal;
			
	void getEnv();
//	void resolveOthers(Instruction::Id op);
	void execGlobalObjSet();
	void execGlobalObjGet();
//	Int mapField(const String &);
//	Int mapVariable(const String &);
	void execToday();
	void execHour();

	enum { RP_LOCAL_OBJ_MSK = 0x80000000 };
public:

	ReportExpr(ReportRep *r, RpZoneRep *zr = NULL);
	ReportExpr(const String &txt, ReportRep *r, RpZoneRep *zr = NULL);
	~ReportExpr();
	
	AnyValue eval(bool pv);
	AnyValue eval();
	
	ReportExpr *getReportExpr();

	ReportRep *reportRep()	{ return rp; }
	RpZoneRep *zoneRep()	{ return zrep; }

	void addFunctions();
	Int resolveFields();
	//const AnyValue &localObjectValue(Int varId);
	virtual void execLocalObjGet();
	virtual  Int resolveGlobalObj(const String &fName);
	virtual  Int resolveLocalObject(const String &fName);
	virtual Int installLocalObject(const String &fName);
};

class RpZoneExpr;
void clearAliases();
bool addAlias(const String &aliasName, RpZoneExpr *ze);
RpZoneExpr *findAlias(const String &aliasName);
RpZoneExpr *findExpr(ReportRep *rp, const String &name);

#if HAVE_PRAGMA_PACK
#	pragma pack()
#endif

#endif // REPEXPR_H
