#ifndef RPCANV_H 
#define RPCANV_H

#pragma interface
  
// Julian Smart's wxWindows toolkit
#include <wxwin/enter_wx.h>
#include <wx_frame.h>
#include <wx_canvs.h>
#include <wxwin/priv/wx_tbarex.h>
#include <wxwin/leave_wx.h>

class wxBrush;
class RpToolBar;
class RepCanvas;
class WxFramedRpDevice;

class RepFrame :	public wxFrame
{
	WxFramedRpDevice *wxrepDev_d;
	RepCanvas *canvas_d;
	RpToolBar *toolbar_d;
public:
	RepFrame(wxFrame *frame, WxFramedRpDevice *rpdev, char *title, Int x, Int y, Int w, Int h);
	~RepFrame();
          
	inline WxFramedRpDevice *wxrepDev();
	inline RpToolBar *toolbar();
	void makeToolBar();

	int OnClose();
	virtual void OnMenuCommand(int choice);
  	virtual void OnSize(int width, int height);
};
                                  
                                  
class  RepCanvas: public wxCanvas
{
	RepFrame *frame_d;	
	WxFramedRpDevice *wxrepDev_d;
	wxBrush *bgBrush_d;
	Int width_d;
	Int height_d;
                        	
public:
	RepCanvas(RepFrame *frame, Int x, Int y, Int w, Int h,
								Int s=wxRETAINED );
	~RepCanvas() ;
	
	void build();
	
	virtual void OnChar(wxKeyEvent& event);
  	virtual void OnSize(int width, int height);
};
                              
                              
class RpToolBar : public wxToolBarEx
{
	RepFrame *frame_d;
	Int height_d;
    
public:
	RpToolBar(RepFrame *rf, int x, int y, int w, int h);
	~RpToolBar();
                 
	inline Int height() const;
	inline void height(Int h);
	
	virtual Bool OnLeftClick(int toolIndex, Bool toggleDown);
	virtual Bool OnLeftAction(int toolIndex, Bool toggleDown);
	virtual void DrawButtonDescr(int toolIndex);	
};
	
void SetSizeHints(wxFrame *frame, int minW, int minH=-1,int maxW=-1, int maxH=-1, 
						int incW=-1, int incH=-1);
void GetFontSize(wxWindow *wnd, int *x, int *y,
		int *descent = NULL, int *externalLeading = NULL);
void GetScrillbarSizes(wxCanvas *canv, int *vscroll, int *hscroll);

#include <ideafix/priv/rpcanv.icc>

#endif /* RPCANV_H */
                                                                                                                 
