/********************************************************************
* Copyright (c) 1994 InterSoft Co.  All Rights Reserved
* THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF InterSoft Co.
* The copyright notice above does not evidence any
* actual or intended publication of such source code.
*
* $Id: rpexpr.h,v 1.2 1996/07/15 19:54:09 eugen Exp $
*
* DESCRIPTION
* Class definitions for RpExpr Type.
*********************************************************************/

#ifndef RPEXPR_H
#define RPEXPR_H

#ifdef __GNUC__
#	pragma interface
#endif

#include <ifound/expr.h>


class RpRep;
class RepZoneRep;

class RpExpr : public Expr {
	
// private:

	RpRep *rpRep_d;
	RepZoneRep *zrep_d;
	bool prevVal_d;
			
	void getEnv();
	void resolveOthers(Instruction::Id op);

	void execToday();
	void execHour();

	enum { RP_LOCAL_OBJ_MSK = 0x80000000 };
public:

	RpExpr(RpRep *r, RepZoneRep *zr = NULL);
	RpExpr(const String &txt, RpRep *r, RepZoneRep *zr = NULL);
	~RpExpr();
	
	AnyValue eval(bool pv);
	AnyValue eval();
	
	RpExpr *getRpExpr();

	inline RpRep *rpRep() const;
	inline RepZoneRep *zoneRep() const;
	inline void zoneRep(RepZoneRep *zone);

	void addFunctions();
	Int resolveFields();
	virtual void execLocalObjGet();
	virtual Int resolveGlobalObj(const String &fName);
	virtual Int resolveLocalObject(const String &fName);
	virtual Int installLocalObject(const String &fName);
};

class RpZoneExprObj; 

void rpClearAliases();
bool rpAddAlias(const String &aliasName, RpZoneExprObj *ze);
RpZoneExprObj *rpFindAlias(const String &aliasName);
bool rpDelAlias(const String &aliasName);
RpZoneExprObj *rpFindExpr(RpRep *rp, const String &name);
  
#include <ideafix/priv/rpexpr.icc>

#endif // RPEXPR_H
