// -----------------------------------------------------------------------
// Copyright (c) 1995 InterSoft Co.  All Rights Reserved
// THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF InterSoft Co.
// The copyright notice above does not evidence any actual or intended 
// publication of such source code.
//
// $Id: rpopval.h,v 1.2 1996/07/15 19:54:13 eugen Exp $
//
// Description:
// -----------------------------------------------------------------------

#ifndef RPOPVAL_H
#define RPOPVAL_H

#ifdef __GNUG__
#	pragma interface
#endif

#include <ideafix/priv/rpobj.h>
#include <ideafix/priv/opval.h>

class RpRep;
class RepZoneRep; 
class RpExpr;

class RpOptionValue : public OptionValue {
	typedef OptionValue inherited;
public:
	typedef RpRep ObjectOwner;

	inline RpRep *rpRep() const;

protected:
	RpOptionValue(RpRep *rpRep, ObjectOption::Type);

private:
	RpRep *rpRep_d;
};

//
// *** class RpExprVal
//
class RpExprVal : public RpOptionValue {
	typedef RpOptionValue inherited;

public:
	RpExprVal(RpRep *rp, RepZoneRep *zone, const String &s = NULL_STRING);
	RpExprVal(RpRep *rp);

	DECLARE_OPTION_VALUE(RpObject::typeRpExpr);

	virtual bool resolveFields();

	inline RpExpr &expr() const;
	const String &exprString() const;

private:
	RpExpr &expr_d;
};


#include <ideafix/priv/rpopval.icc>

#endif

