/*
 *
 * $Id: rptypes.h,v 1.2 1996/07/15 19:54:15 eugen Exp $
 *
 */


#ifndef RPTYPES_H
#define RPTYPES_H

#ifdef __GNUC__
#	pragma interface
#endif

class wxBitmap;

#define PTR_ARRAY(Class)			\
declare(PtrArray, Class);			\
implement(PtrArray, Class);

#define PTR_ARRAY_CURSOR(Class)		\
declare(PtrArray, Class);			\
implement(PtrArray, Class);			\
declare(PtrArrayCursor, Class);		\
implement(PtrArrayCursor, Class);

enum RpUnit {
	r_unit_none		= 0,
	r_internal,
	r_pixel,
	r_character,
	r_inch,
	r_point,
	r_mm,
	r_sm
};

enum RpPaperSize {
	r_size_none		= 0,
	r_letter,
	r_legal,
	r_A4,
	r_executive, 	
	r_ledger,
	r_A3
};

#define U_V_PIXEL          1000
#define U_V_CHARACTER     12000
#define U_V_INCH          72000
#define U_V_POINT		   1000
#define U_V_MM             2835
#define U_V_SM            28346

#define PS_V_LETTER			(792*U_V_POINT)
#define PS_V_LEGAL          (1008*U_V_POINT)
#define PS_V_A4             (287*U_V_MM)
#define PS_V_EXECUTIVE      (756*U_V_POINT)
#define PS_V_LEDGER      	(792*U_V_POINT)
#define PS_V_A3      		(1190*U_V_POINT)

#define U_H_PIXEL          1000
#define U_H_CHARACTER      7200
#define U_H_INCH          72000
#define U_H_POINT		   1000
#define U_H_MM             2835
#define U_H_SM            28346

#define PS_H_LETTER   		(612*U_H_POINT)
#define PS_H_LEGAL          (612*U_H_POINT)
#define PS_H_A4             (210*U_H_MM)
#define PS_H_EXECUTIVE      (522*U_H_POINT)
#define PS_H_LEDGER      	(1224*U_H_POINT)
#define PS_H_A3      		(842*U_H_POINT)

Int	unitToInternVert(Num val, RpUnit inpUnit);
Int	unitToInternHoriz(Num val, RpUnit inpUnit);
Num	unitToOutVert(Int val, RpUnit outUnit);
Num	unitToOutHoriz(Int val, RpUnit outUnit);
void paperSize(Int& w, Int& h, RpPaperSize papSize); 
void paperSize(Num& w, Num& h, RpPaperSize papSize); 

enum Orientation {
    r_any			= 0,
 	r_horizontal	= 1,
    r_vertical		= 2
};

enum Alignment {
	left	= 0,
	center	= 1,
	right	= 2
};

enum FillStyle {
	transparent 		= 0,
	solid				= 1,
	horizontal_hatch	= 2,
	vertical_hatch		= 3,
	cross_hatch			= 4,
	cross_diagonal_hatch= 5,
	b_diagonal_hatch	= 6,
	f_diagonal_hatch	= 7
};

enum DrawStyle {
	solidLine	= 0,
	dot			= 1,
	dot_dash	= 2,
	long_dash	= 3,
	short_dash	= 4,
	double_solid = 5,
};

int wxFillStyle(FillStyle s);
int wxDrawStyle(DrawStyle s);


class IBitmap {
public:
	String	name_d;
	wxBitmap *bitmap_d;
	IBitmap(const String& name, wxBitmap *bitmap) :
		name_d(name), bitmap_d(bitmap) {};
	~IBitmap() {};
};
			
#endif /* RPTYPES_H */
