// -------------------------------------------------------------------------
// Copyright (c) 1995 InterSoft Co.  All Rights Reserved
// THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF InterSoft Co.
// The copyright notice above does not evidence any actual or intended 
// publication of such source code.
//
// $Id: tdialg.h,v 3.2 1996/07/30 15:11:22 ksa Exp $
//
// Description:
// -------------------------------------------------------------------------

#ifndef FDIALG_H
#define FDIALG_H

#ifdef __GNUC__
#	pragma interface
#endif


class wxFrame;
class wxDialogBox;
class wxMessage;
class wxButton;
class wxItem;
class TableItem;
class gtype(PtrArray,TableItem);

#define LEFT	0
#define UP		0
#define CENTER	1
#define RIGHT	2
#define DOWN	2
#define FILL	3

class TableItem
{
protected :
	wxItem *item_d;
	int w_d;
	int h_d;

	Int column_d;
	Int row_d;
	Int width_d;
	Int height_d;

	Int alignH_d;
	Int alignV_d;
	

public :
	TableItem(wxItem *it, Int x, Int y, Int w = 1, Int h = 1,
				Int alignH = LEFT, Int alignV = CENTER);
	~TableItem(void);

	void align(Int x, Int y, Int w, Int h);
	void GetSize();

	Int w() 	{ return w_d; 		}
	Int h() 	{ return h_d; 		}
	Int column(){ return column_d; 	}
	Int row()	{ return row_d; 	}
	Int width()	{ return width_d; 	}
	Int height(){ return height_d; 	}
	
};

class TableLayoutDialog : public wxDialogBox
{
public :
	enum Buttons {
		none=0,
		ok = 1,
		cancel = 1<<1,
		help = 1<<2
	};
protected :

	gtype(PtrArray,TableItem) *items_d;

	Int *widths_d;
	Int *heights_d;
	Int columns_d;
	Int rows_d;
	
	Int tableX_d;
	Int tableY_d;
	Int tableW_d;
	Int tableH_d;
	
	Int dialogW_d;
	Int dialogH_d;

	int headerW_d;
	int headerH_d;
	int footerW_d;
	int footerH_d;

	wxWindow* parent_d;
	String sTitle_d;
	wxMessage *title_d;
	Bool header_d;

	Int buttons_d;
	wxButton *ok_d;
	wxButton *cancel_d;
	wxButton *help_d;


	void columnsAndRows();
	void sizeOfCells();
	void cellGeometry(TableItem* it);
	void positionsOfItems();
	void createHeader();
	void createFooter();
	void setHeader();
	void setFooter();
	void SetDefault(wxButton* b);

	virtual void onOk();
	virtual void onCancel();
	virtual void onHelp();

	void calculateGeometry(Bool showTable = false);
	void add(wxItem *it, Int x, Int y, Int w = 1, Int h = 1,
				Int alignH = LEFT, Int alignV = CENTER);
	
public :
	TableLayoutDialog(wxWindow *pw, const String &str, 
		Int butt = ok | cancel, Bool header = false);
	~TableLayoutDialog();

	virtual Bool itemsCallback(wxItem *o);
	virtual void onCloseChild(void* from);
};

void TLDialogFunctions(wxObject &o, wxCommandEvent &);

#endif // FDIALG_H
