// -----------------------------------------------------------------------
// Copyright (c) 1995 InterSoft Co.  All Rights Reserved
// THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF InterSoft Co.
// The copyright notice above does not evidence any actual or intended 
// publication of such source code.
//
// $Id: pupmenu.h,v 1.4 1996/07/31 15:00:03 ksa Exp $
//
// Description:
// User level class for opening feedable menus
// -----------------------------------------------------------------------

#ifndef PUPMENU_H
#define PUPMENU_H

#include <ifound.h>
#include <ifound/mainobj.h>

class PopMenuRep;

class PopMenu : public FramedObject
{

public:

	PopMenu();
	PopMenu(FramedObject *parent, const String &title, Int x, Int y,
			Int width, Int height, Int nrows, Int ncols, 
			bool stay = false);
	~PopMenu();

	// for wxWindows
	bool canUseWxWindows() const;
	bool wxWindowsCreate();
	void wxWindowsDestroy();
	Int wxWindowsMainLoop();

	// for Cracker
	bool canUseCracker() const;
	bool crackerCreate(RequestConnection &conn);
	void crackerDestroy(RequestConnection &conn);

	bool processRequest(RequestConnection &conn);

	// toDo: in the future should use PopMenuObject instead
	// of Strings
	virtual String onLineRequest(Int n) = 0;
	virtual bool onSelect(Int n);
	virtual Int search(Int from, const String &s, bool back = false);

	inline PopMenuRep *menuRep() const;

protected:

	void create(FramedObject *parent, const String &title,
		Int x, Int y, Int w, Int h, Int r, Int c, bool stay);

private:

	PopMenuRep *menu_d;
};

inline PopMenuRep *
PopMenu::menuRep() const
{
	return menu_d;
}

#endif
