/***********************************************************************
* Copyright (c) 1994 InterSoft Co.  All Rights Reserved
* THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF InterSoft Co.
* The copyright notice above does not evidence any
* actual or intended publication of such source code.
*
* $Id: btypes.h,v 1.10 1996/08/15 20:02:42 eduardoc Exp $
*
* DESCRIPTION
* Basic type definitions
*********************************************************************/

#ifndef	BTYPES_H
#define	BTYPES_H


#ifndef BYTE_TYPEDEF
#	define BYTE_TYPEDEF
	typedef signed char Byte;
	typedef unsigned char UnByte;
	typedef Byte *BytePtr;
#endif

#ifndef CHAR_TYPEDEF
#	define CHAR_TYPEDEF
	/* For the moment... */
	typedef char Char;
/*	typedef unsigned char Char; */
	typedef unsigned char UnChar;		/* =[:(  deprecated */
#endif

#ifndef WIDECHAR_TYPEDEF
#	define WIDECHAR_TYPEDEF
	typedef short WideChar;
#endif

#ifndef SHORT_TYPEDEF
#	define SHORT_TYPEDEF
	typedef signed short Short;
	typedef unsigned short UnShort;
#endif

#ifndef INT_TYPEDEF
#	define INT_TYPEDEF
	typedef signed Int Int;
	typedef unsigned Int UnInt;
#endif

#ifndef LONG_TYPEDEF
#	define LONG_TYPEDEF
#ifndef HAVE_LONGLONGBUG
	typedef long signed long Long;
	typedef long unsigned long UnLong;
#else                                                                         _
    typedef signed long Long;                                                 _
    typedef unsigned long UnLong;                                             _
#endif                                                                        _
#endif

#ifndef BOOL_TYPEDEF
#	define BOOL_TYPEDEF
#	ifndef HAVE_BOOL
		typedef signed char bool;
#		ifdef true
#			undef true
#		endif
#		define true ((signed char) 1)
#		ifdef false
#			undef false
#		endif
#		define false ((signed char) 0)
#	else
#		ifndef false
#			ifdef __cplusplus
#				define false	false
#			else
#				define false	0
#			endif
#		endif
#		ifndef true
#			ifdef __cplusplus
#				define true		true
#			else
#				define true		1
#			endif
#		endif
#	endif
#endif

typedef char FmtBuff[256];

typedef short TypeId;
#include <ifound/typeid.h>

/* Options to format every date - read from config file */
#define INTER_FMT	(0)
#define USA_FMT		(1 << 0)

/* Options to format a particular date - passed as parameter on each call */
#define YEAR2_FMT	(1 << 1)
#define SEPAR_FMT	(1 << 2)
#define DAYNAME_FMT	(1 << 3)
#define LDAYNAME_FMT	(1 << 4)
#define MONTHNAME_FMT	(1 << 5)
#define LMONTHNAME_FMT	(1 << 6)
#define DEFAULT_FMT	(SEPAR_FMT)

/* Options to format a particular time */
#define SEPAR_TFMT		(1 << 1)
#define SECONDS_TFMT	(1 << 2)
#define DATE_TFMT		(1 << 3)
#define FULL_TFMT		(SEPAR_TFMT|SECONDS_TFMT|DATE_TFMT)
#define DEFAULT_TFMT	(SEPAR_TFMT|SECONDS_TFMT)


#ifndef BOOL_NULL
#	define BOOL_NULL	(-1)
#endif

#ifndef NO
#	define NO		false
#endif

#ifndef YES
#	define YES		true
#endif

#define TODAY		"NOW"
#define NOW			"NOW"

/* Useful constants */

#undef BYTE_MAX
#undef BYTE_MIN
#undef BYTE_NULL
#undef UN_INT_MAX
#undef INT_MAX
#undef INT_MIN
#undef INT_NULL
#undef LONG_MAX
#undef LONG_MIN
#undef LONG_NULL
#undef SHORT_MAX
#undef SHORT_MIN
#undef SHORT_NULL
#undef UN_SHORT_MAX
#undef DOUBLE_MAX
#undef DOUBLE_MIN
#undef DOUBLE_NULL
#undef SPECIAL_VALUE

#define BYTE_MAX		(127)
#define BYTE_MIN		(-BYTE_MAX-1)
#define BYTE_NULL		BYTE_MIN

#define UN_INT_MAX		((UnInt) 0xffffffff)
#define INT_MAX			((Int) 2147483647)
#define INT_MIN			(-INT_MAX-1)
#define INT_NULL		INT_MIN

#define LONG_MAX		INT_MAX
#define LONG_MIN		INT_MIN
#define LONG_NULL		INT_NULL

#define SHORT_MAX		((short) 32767)
#define SHORT_MIN		(-SHORT_MAX-1)
#define SHORT_NULL		SHORT_MIN

#define UN_SHORT_MAX	((unsigned short) 0xffff)

#define DOUBLE_MAX		(1e50)
#define DOUBLE_MIN		(-DOUBLE_MAX)
#define DOUBLE_NULL		DOUBLE_MIN

#define SPECIAL_VALUE		(INT_MAX - 1)

#endif
