/********************************************************************
* Copyright (c) 1991 InterSoft Co.  All Rights Reserved
* THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF InterSoft Co.
* The copyright notice above does not evidence any
* actual or intended publication of such source code.
*
* $Id: gfuncs.h,v 1.30 1996/08/21 16:51:07 eugen Exp $
*
* DESCRIPTION
* General purpose function prototypes
*********************************************************************/

#ifndef GFUNCS_H
#define GFUNCS_H

#include <ifound/osdep.h>
#include <ifound/functype.h>
#include <ifound/macros.h>
#include <ifound/btypes.h>
#include <ifound/istdarg.h>

#define UNAME_ERROR		0
#define UNAME_CHECK		1
#define UNAME_NOCHECK	2
#define UNAME_OLDSHAD	3

typedef Char *(*ConvertFunction)(	Int, const Char **, Int, Int *, va_list *,
									Char *, Char *, Int *);

class String;
class Time;
class OptionParser;
class Num;
class GUIConnection;
class Message;

// toDo: Dudosas
void turnIntoDaemon(IFPICCPCCP fatalHandler = NULL, 
					IFPICCPCCP dispErrHandler = NULL, 
					IFPICCPCCP dispHandler = NULL);
Int setEnvironment(const Char *file);
void banner(const String &prog, const String &version);
String versionStr(Int vers);
// toDo: Duplicadas? procTty() y procPid()?
const String &getTty();
Int getPid();
Int unlinkFile(const String &file);
Int statFile(const String &file, struct stat *st = NULL);
Time timeStamp(const String &file);
bool renameFile(const String &oldName, const String &newName);
Int wait_for_child(Int p);

#ifdef toascii
# undef toascii
#endif


extern "C" {
	extern int tolower(int x);
	extern int toupper(int x);
	extern int toascii(int);
	extern int fromascii(int);
}

void	startUp(const String &applName, int &argc, Char **&argv,
				OptionParser &);
void	startUp(const String &applName, int &argc, Char **&argv);

IFPICCPCCP displayHandler(IFPICCPCCP handler);
IFPICCPCCP displayErrorHandler(IFPICCPCCP handler);
IFPICCPCCP fatalErrorHandler(IFPICCPCCP handler);
IFPICCPCCP ariErrorHandler(IFPICCPCCP handler);

Int		ariError(const String &msg, ...);
void	error(const String &msg, ...);
void	warning(const String &msg, ...);
void	notice(const String &msg, ...);
void	msgCtrl(Int flag);
void	display(const String &label, const String &msg);
void	displayError(const String &msg);
Int	 	fatalError(const String &msg);


const String& appName();
const String& sysName();
const String& appVersion();

void setAppName(const String &sys, const String &prg,
				const String &vers);

GUIConnection *_appConnection();
GUIConnection *appConnection();

const String &dayOfWeekName(Int d);
const String &monthName(Int m);

String libMsg(const String &msg);
Message libMsg(const String &msg, const Char *dmsg);
String libMsg(const Char *msg);
Message libMsg(const Char *msg, const Char *dmsg);
String appMsg(const String &msg);
Message appMsg(const String &msg, const Char *dmsg);
String appMsg(const Char *msg);
Message appMsg(const Char *msg, const Char *dmsg);

Int		userId(const Char *);
Char*	userName(Int);
Char*	fullUserName(Int);
Int		groupId(const Char *);
Char*	groupName(Int);
Int		userGid(Int);
Char*	userHomeDir(Int);

#ifdef HAVE_NETAPI
	int getFileOwner(const char *fname);
	bool amIinLocalGroup(char *grp);
#endif

void	background();
void	procUpdatePerm(bool v);
bool	procUpdatePerm();
void	procAddPerm(bool v);
bool	procAddPerm();
void	procDelPerm(bool v);
bool	procDelPerm();
void	setProcUserId(UnShort uid);
void	setProcUserGid(UnShort gid);
void 	setUserServer(bool usersv);
bool 	procUserServer();
UnShort procUserId();
UnShort procUserGid();
Int		procPid();
const String &procTtyName();
Char**	procArgs();
Time	procInitTime();
Int		procSig();
const String &procTty();
void	stop(Int val);
void	onStop(FP func);
void	onAbnormalStop(FP func);

Char	decPoint();
Char	thousandSep();

Int		dateFmt();
void	dateFmt(Int dfmt);

Int		argCnt();
String	argVal(Int n);
Char**	argRefVal();

void addConvertFunction(Int c, ConvertFunction fp);
void processMask(Char *obuff, Char *mask, Char *ibuff);
Int compileMask(Char *mask, Char *tstmask, Char *omask);
Int sizeOfMask(Char *mask);
Char *baseName(Char const *path);
void setEnableIntHandler(FPI f);
void enableInterrupts(FPI fp);
void initCrypt(Char *pw, Int sflag);
String encryption(const String &txt, const String &key);
Int swapInfo(Num &swapin, Num &swapout);
Int cryptChar(Int i);
void cryptString(Char *str);
int locate(const Char *datum, const Char *table, UnInt nel, UnInt size,
		IFPCPCP comp);
const Char *toCharPtr(Int v, Int length = 0, Int base = -10);
Int toInt(const char *);
Int memCmpI(const Char *, const Char *, Int);
const Char *strStr(const Char *, const Char *);
const Char *strStrBackw(const Char *s1, const Char *s2, const Char *s3);

void swap(Int &a, Int &b);
Int add(Int a, Int b);
Int div(Int a, Int b);
Int mult(Int a, Int b);
inline Int min(Int a, Int b) { return a < b ? a : b; }
inline Int max(Int a, Int b) { return a > b ? a : b; }
void chkheap();

extern "C" bool IxVerboseLevel(UnInt level);

#endif

