#include <ifound/chset.h>

// Parts of graphic characters
#define L_HOR		1 << 0
#define R_HOR		1 << 1
#define U_VER		1 << 2
#define D_VER		1 << 3

#define L_HOR_D		1 << 4
#define R_HOR_D		1 << 5
#define U_VER_D		1 << 6
#define D_VER_D		1 << 7

// Some auxiliary simbols (halfs of verticals and horisontals)
#define C_HOR_L		1
#define C_HOR_R		2
#define C_VER_U		3
#define C_VER_D		4

#define C_D_HOR_L	5
#define C_D_HOR_R	6
#define C_D_VER_U	7
#define C_D_VER_D	8

static char ComposeGraphicsMask[][2] =  {
	{	C_HOR_L		, L_HOR									},
	{	C_HOR_R		, R_HOR									},
	{	C_VER_U		, U_VER									},
	{	C_VER_D		, D_VER									},
	{	C_D_HOR_L	, L_HOR_D								},
	{	C_D_HOR_R	, R_HOR_D								},
	{	C_D_VER_U	, U_VER_D								},
	{	C_D_VER_D	, D_VER_D								},

	{	C_VERT		, U_VER   | D_VER						},
	{	C_HORIZ		, L_HOR   | R_HOR						},
	{	C_LL		, R_HOR	  | U_VER						},
	{	C_BOT		, L_HOR	  | R_HOR   | U_VER				},
	{	C_LR		, L_HOR   | U_VER						},
	{	C_RIGHT		, L_HOR   | U_VER   | D_VER				},
	{	C_CEN		, L_HOR   | R_HOR   | U_VER   | D_VER	},
	{	C_LEFT		, R_HOR   | U_VER   | D_VER				},
	{	C_UL		, R_HOR   | D_VER						},
	{	C_TOP		, L_HOR   | R_HOR   | D_VER				},
	{	C_UR		, L_HOR   | D_VER						},
	{	C_D_VERT	, U_VER_D | D_VER_D						},
	{	C_D_HORIZ	, L_HOR_D | R_HOR_D						},
	{	C_D_LL		, R_HOR_D | U_VER_D						},
	{	C_D_BOT		, L_HOR_D | R_HOR_D | U_VER_D			},
	{	C_D_LR		, L_HOR_D | U_VER_D						},
	{	C_D_RIGHT	, L_HOR_D | U_VER_D | D_VER_D			},
	{	C_D_CEN		, L_HOR_D | R_HOR_D | U_VER_D | D_VER	},
	{	C_D_LEFT	, R_HOR_D | U_VER_D | D_VER_D			},
	{	C_D_UL		, R_HOR_D | D_VER_D						},
	{	C_D_TOP		, L_HOR_D | R_HOR_D | D_VER_D			},
	{	C_D_UR		, L_HOR_D | D_VER_D						},
	{	C_DS_BOT	, L_HOR_D | R_HOR_D | U_VER				},
	{	C_DS_RIGHT	, L_HOR   | U_VER_D | D_VER_D			},
	{	C_DS_LEFT	, R_HOR   | U_VER_D | D_VER_D			},
	{	C_DS_TOP	, L_HOR_D | R_HOR_D | D_VER				},
	{	0,0}
};

