/********************************************************************
*
* Copyright (c) 1995 InterSoft Co.  All Rights Reserved
* THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF InterSoft Co.
* The copyright notice above does not evidence any
* actual or intended publication of such source code.
*
* $Id: ideaobj.h,v 1.3 1996/08/23 21:35:33 diego Exp $
*
* DESCRIPTION:
*
*********************************************************************/

#ifndef IDEAOBJ_H
#define IDEAOBJ_H

#include <ifound/dbobj.h>

class IdeaTable : public Table {

private:

	String currentCurInd;
	dbcursor cur;
	enum SetType {
		from,
		to,
	};
	void setCursor(SetType, Int, FieldsArray &);

	const AnyValue &value(dbfield, Int);

	void setFlds();

public:	

	IdeaTable(const String &, const String &);
	virtual ~IdeaTable();

	virtual bool fldId(const String &, Int &, Int &) const;

	virtual Int get(Int);
	virtual void put();
	virtual void add();
	virtual void del();
	virtual void init();
	
	// Cursor handling
	virtual bool createCursor(const String &);
	virtual inline void setFrom(Int, FieldsArray &);
	virtual inline void setTo(Int, FieldsArray &);
	virtual void use(StringsArray &);
	virtual void use(Int *);
	virtual Int fetch();
};

#include <ifound/ideaobj.icc>

#endif //IDEAOBJ_H

