/********************************************************************
* Copyright (c) 1991 InterSoft Co.  All Rights Reserved
* THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF InterSoft Co.
* The copyright notice above does not evidence any
* actual or intended publication of such source code.
*
*
* $Id: instruct.h,v 1.12 1996/05/31 14:44:44 gustavof Exp $
*
*
* DESCRIPTION:
*
*      Definitions for operators types. 
*
*********************************************************************/

#ifndef INSTRUCT_H
#define INSTRUCT_H

#include <ifound.h>

#ifdef __GNUC__
#pragma interface
#endif


/* Relational operators types */

class Instruction {

// private:

	static const char *name[];

public:

	enum Id {

		stop,			/* Special operators */
		null,
		pad,
		void_value,
		arg_end,
		arg_separ,
        resetStack,

		string_type,		/* Constants		 */
		num_type,
		time_type,
		date_type,
		bool_type,
		int_type,

		hour,
		today,
		user,
		
		get_env,

		function,
		method,

		eq, 			/* Relational operators	*/
		ne,
		gt,
		lt,
		ge,
		le,
		in,
		between,


		or, 		/* Logic Operators 	*/
		and,
		not,
		cond_if,
		when,


		add, 		/* Arithmetic Operators */
		dif,
		mult,
		div,
		umin,

		msg,

		local_decl,	/* Objects operations */
		local_set,
		local_get,
		id_set,
		id_get,
		global_obj_set,
		global_obj_get,
		foreign_obj_set,
		foreign_obj_get,


		foreach_inst,
		if_inst,
		while_inst,
		break_inst,
		continue_inst,
		return_inst,

		assign,
		assign_add,
		assign_sub,
		assign_mul,
		assign_div,
		like,
		match,
	};

	static const char *descr(Instruction::Id id);
};

#endif
