/********************************************************************
*
* Copyright (c) 1996 InterSoft Co.  All Rights Reserved
* THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF InterSoft Co.
* The copyright notice above does not evidence any
* actual or intended publication of such source code.
*
* $Id: interf.sc,v 1.1.2.1 1996/08/23 20:07:58 gustavof Exp $
*
* DESCRIPTION:
*
*********************************************************************/

schema interf descr "Base de Datos para interfaces de Ideafix" language "C";

table esquemas descr "Esquemas"
{
	nombre	char(20)	descr "Nombre" not null,
    formato	char		descr "Formato" in ("D" : "ASCII",
                                            "I" : "IdeaFix",
                                            "F" : "Informix",
                                            "O" : "Oracle")
						mask ">A"
						not null,
	observ	char(30)	descr "Observaciones",
}
primary key (nombre);

table tablas descr "Tablas"     
{
	esq		char (20)	descr "Id. del esquema"
						in esquemas:nombre
						not null,
	nombre	char(20)	descr "Nombre" not null,
}
primary key  (esq, nombre);

table campos descr "Campos"
{
	esq		char(20)		descr "Id. del esquema" not null,
	tab		char(20)		descr "Id. de la tabla"
							in tablas(esq):nombre
							not null,
	nombre	char(20)		descr "Nombre" not null,
	pos		num(4)	   		descr "Posicin" not null,
	dim		num(4)			descr "Dimensin"
							default 0
							not null,
	tipo	char			descr "Tipo de dato"
							in ("N" : "Numrico",
								"A" : "Alfanumrico",
								"F" : "Fecha",
								"H" : "Hora")
							
								mask ">A"
								not null,
}
primary key (esq, tab, nombre),
unique index pos (esq, tab, pos);







