/********************************************************************
*
* Copyright (c) 1995 InterSoft Co.  All Rights Reserved
* THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF InterSoft Co.
* The copyright notice above does not evidence any
* actual or intended publication of such source code.
*
* $Id: intexpr.h,v 1.6 1996/08/23 19:57:22 gustavof Exp $
*
* DESCRIPTION:
*
*********************************************************************/
#ifndef INTEXPR_H
#define INTEXPR_H

#include <ideafix.h>
#if IDEA_VERSION >= 432
#include <ifound/expr.h>
#else
#include <expr.h>
#endif

#include <ifound/dbobj.h>

enum MethType {
	getMeth,    
	putMeth,
	addMeth,
	delMeth,
	initMeth,
};

typedef int (*INTERFMSGHAND) (Int,const char *);

class InterfExpr : public Expr {

private:

	// Methods
	static bool resolveMeth(ExprObject &, ExprStack &);
	static void execMeth(MethType, ExprObject &, ExprStack &, Int);
	static inline void execPut(ExprObject &, ExprStack &);
	static inline void execAdd(ExprObject &, ExprStack &);
	static inline void execGet(ExprObject &, ExprStack &);
	static inline void execGetl(ExprObject &, ExprStack &);
	static inline void execDel(ExprObject &, ExprStack &);
	static inline void execInit(ExprObject &, ExprStack &);
	void addMethods();
                             
	// Functions
	static void execError(ExprStack &s);		
	static void execWarning(ExprStack &s);		
	static void execSubString(ExprStack &s);	
	void addFunctions();

	//
	static INTERFMSGHAND _errorHandler;
	static INTERFMSGHAND _warningHandler;
	static int defaultErrorHandler(Int msgno, const char *msg);
	static int defaultWarningHandler(Int msgno, const char *msg);

protected:

	virtual Int findKeyword(const String &lex);

	virtual Int installLocalObject(const String &);

	Table *tab;//set/unset by resolveForeach(), used by resolveForeignObj()
	virtual bool resolveForeignObj(const String &, Int &, Int &);
	virtual bool resolveForeach(Datum &);

	virtual void resolveOthers(Instruction::Id);
	virtual void execForeach(Datum &);
    
public:	

	static INTERFMSGHAND errorHandler(INTERFMSGHAND);
	static INTERFMSGHAND warningHandler(INTERFMSGHAND);
	
	explicit InterfExpr(const String &);
    explicit InterfExpr(const InterfExpr &);
	explicit InterfExpr();
};

#include <ifound/intexpr.icc>

#endif //INTEXPR_H
