/***********************************************************************
* Copyright (c) 1991 InterSoft Co.  All Rights Reserved
* THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF InterSoft Co.
* The copyright notice above does not evidence any
* actual or intended publication of such source code.
*
* $Id: borland.h,v 1.16 1996/08/22 19:48:03 eduardoc Exp $
*
* DESCRIPTION
* Operating system dependent defines
*********************************************************************/

#ifndef BORLAND_H
#define BORLAND_H

#define _OS_	"MS DOS"
#define _OSVER_	"5.0 +"
#define _OS_SHORT_NAME_	"borland"

#if defined(ACADEMIC_VERSION)
#define EXTRA_BANNER_INFO   " (Academic-Beta) "
#elif defined (BETA_VERSION)
#   define  EXTRA_BANNER_INFO   " (Beta) " 
#else
#       define  EXTRA_BANNER_INFO   ""
#endif

/* Typedefs */
typedef unsigned SizeT;

/* Dummy typedefs */
typedef long Int;
typedef unsigned short UidT;
typedef unsigned short GidT;
typedef unsigned OffT;
typedef unsigned PidT;
typedef unsigned KeyT;
typedef unsigned short ModeT;
typedef union u_SemunT {
        int val;
        struct semid_ds *buf;
        unsigned short *array;
} SemunT;

/* Insert here locally needed defines */
#undef _POSIX_SOURCE
#undef _POSIX_VERSION

/* Compiler dependant capabilities */

/* Non compiler dependant capabilities */
#undef BAD_STRNCPY
#define CANT_DEL_WHOLE_FILE			1
#undef CHKSUM
#undef C_HEAP
#undef DEBUG_LOCK
#undef DIRENT
#define END_OF_TEXT_FILE_CHAR		26
#define ENOTDIR_IS_ENOENT			1
#define EXEC_TAKES_TIME				1
#define HAVE_ABORT					1
#undef HAVE_ALTZONE
#undef HAVE_AR_AIAMAG
#undef HAVE_AR_FL_HDR
#undef HAVE_AR_NAMLEN
#undef HAVE_AR_NUMERIC
#undef HAVE_ASYNC_IO
#undef HAVE_BAD_CVT
#undef HAVE_BCOPY
#undef HAVE_BSDTTY_H
#undef HAVE_BZERO
#undef HAVE_CLOSEDIR_BUG
#define HAVE_COMMAND_COM			1
#undef HAVE_EMULTIHOP
#undef HAVE_ENOLINK
#undef HAVE_ERRLIST
#undef HAVE_ETC_SHADOW
#undef HAVE_FCNTL
#undef HAVE_FIONREAD
#undef HAVE_FIORDCHK
#define HAVE_FREEMEM				1
#undef HAVE_FSYNC
#undef HAVE_FULL_SIGNALS
#undef HAVE_F_SETOWN
#undef HAVE_GETDFREE
#undef HAVE_GETGROUPS
#undef HAVE_GETPWANAM
#undef HAVE_GETSPNAM
#undef HAVE_HEAP_WALK
#undef HAVE_INETD
#undef HAVE_IPC
#undef HAVE_JOB_CONTROL
#undef HAVE_LOCALTIME
#undef HAVE_LOCKF
#define HAVE_LOCKING				1
#undef HAVE_LTCHARS
#undef HAVE_MAIL
#define HAVE_MEMMOVE				1
#undef HAVE_MKTEMP
#undef HAVE_OPENDIR
#define HAVE_PASTE					1
#undef HAVE_PID
#undef HAVE_PIPES
#undef HAVE_PROC
#undef HAVE_PROC_DIR
#define HAVE_PSEUDO_CONCURR			1
#undef HAVE_RANLIB
#undef HAVE_REAL_LOCKS
#define HAVE_RENAME					1
#undef HAVE_RESTARTABLE_SYSCALLS
#define HAVE_SAVEMEM				1
#undef HAVE_SECURITY
#define HAVE_SECURITY_CHECK		1
#undef HAVE_SEMAPHORES
#undef HAVE_SETRLIMIT
#undef HAVE_SETSID
#undef HAVE_SETUID
#undef HAVE_SGR

#undef HAVE_SHORT_ENV
#undef HAVE_SHORT_FILE_NAMES
#undef HAVE_SHORT_MEMSET
#undef HAVE_SIGABRT
#undef HAVE_SIGACTION
#undef HAVE_SIGPWR
#undef HAVE_SIGSET
#undef HAVE_SIGVEC 
#define HAVE_SIGEMT				1
#undef HAVE_SIGUNUSED
#define HAVE_SIGSYS				1
#define HAVE_SOUND_BEEP				1
#undef HAVE_STKLEN
#define HAVE_STRSTR					1
#define HAVE_STRTOK					1
#undef HAVE_SWAP
#undef HAVE_SYNC
#undef HAVE_SYSTTOLD_H
#undef HAVE_SYS_TIMEB_H
#undef HAVE_SYS_VFS_H
#define HAVE_TERMIO_H				1
#define HAVE_TEXT_FILES				1
#undef HAVE_TIMEOFFSET
#undef HAVE_TIMEZONE

#define HAVE_TIME_H					1
#define HAVE_TMPFILE				1
#undef HAVE_TM_ZONE
#undef HAVE_TRUNCATE
#undef HAVE_TTY
#undef HAVE_UMASK
#undef HAVE_UNISTD_H
#define HAVE_USEUSEMUN				1
#undef HAVE_GETUSERPW
#undef HAVE_USERS
#undef HAVE_WAITPID
#undef HAVE_XCC
#ifndef DOS16RM
#	undef HAVE_ZPM
#else
#	define HAVE_ZPM	1
#endif
#undef LOG_DBG
#define NEED_AR_PORTAR				1
#undef NEED_CLOSE_FOR_SYNC
#undef NEED_MEM_DEBUG
#undef NEED_NETBIOS_FOPEN
#define NO_ADVISORY_LOCK			1
#undef NO_EXTERN_CONST
#undef NO_MKRMDIR
#undef NO_SERVICES
#undef OPEN_CANT_CREATE
#define SPANISH						1
#undef HAVE_AF_UNIX_LEN
#undef HAVE_LONG_ARGV
#undef HAVE_OP_CONST_VOID_PTR
#undef HAVE_O_SYNC
#undef HAVE_TERMIOS_H
#undef HAVE_UTIME_H
#undef MAIL_LIST
#define FM_MAX_OPEN					128
#define MAIL_HOME					"/usr/mail"

#undef STATFS_HAS_LEN
#define SYSDIR						1
#undef SYSNDIR
#define USE_FGETC					1
#define VOLUME_LETTER_SEP			":"
#undef USG
#define _G_USE_PROTOS				1
#undef HAVE_SARWITHSWAP
#define HAVE_NOPROBLEMSCLOSING012	1
#undef HAVE_SYSLOG
#undef HAVE_VARARGS_BUG
#undef HAVE_GRAPHICS
#undef HAVE_MMF
#undef HAVE_USEFULFTRUNCATE

/* Non compiler dependant parameter types */
#define ABORTRETTYPE 			void
#define ALLOCRETTYPE			void *
#define BCOPYPARAM3TYPE			int
#define BZEROPARAM2TYPE			int
#define BINDPARAM2TYPE			const void *
#define BINDPARAM3TYPE			int
#define CFTIMEPARAM2TYPE		char *
#define CHOWNPARAM2TYPE 		int
#define CHOWNPARAM3TYPE 		GidT
#define CONNECTPARAM1TYPE		int
#define CONNECTPARAM2TYPE		struct sockaddr *
#define CONNECTPARAM3TYPE		int
#define EXECVPPARAM2TYPE		const char * const *
#define FCNTLPARAM3TYPE			...
#define FTELLRETTYPE			long
#define FTELLPARAM1TYPE			FILE *
#define FPUTCPARAM1TYPE			int
#define FREADPARAM1TYPE			void *
#define FWRITEPARAM1TYPE		void const *
#define GCVTPARAM2TYPE          int    
#define GETCWDPARAM1TYPE		char const *
#define GETCWDPARAM2TYPE 		SizeT
#define GETGRGIDPARAMTYPE		GidT
#define GETHOSTBNPARAMTYPE		const char *
#define GETHOSTNPARAM2TYPE		int
#define GETPEERNAMEPARAM2TYPE	void *
#define GETPEERNAMEPARAM3TYPE	int *
#define GETPWUIDPARAMTYPE		UidT
#define GETSERVBNPARAM1TYPE		const char *
#define GETSERVBNPARAM2TYPE		const char *
#define MSGCTLPARAM3TYPE		struct msqid_ds *
#define MSGRCVPARAM2TYPE		struct msgbuf *
#define MSGRCVPARAM3TYPE		int
#define MSGSNDPARAM2TYPE		struct msgbuf *
#define MSGSNDPARAM3TYPE		int
#define MUNMAPPARM1TYPE			void *
#define	MUNMAPPARAM2TYPE		size_t
#define OPENPARAM3TYPE			...
#define OPENRRETTYPE			SizeT
#define PAUSERETTYPE 			void
#define POPENPARAMTYPE			char *
#define PUTENVPARAMTYPE			char const *
#define READRETTYPE				int
#define RETSIGTYPE				void
#define SBRKPARAMTYPE			int
#define SBRKRETTYPE 			void *
/* #define SEMCTLPARAM4TYPE		SemunT */
#define SEMOPPARAM3TYPE			unsigned
#define SLEEPPARAMTYPE			long
#define SLEEPRETTYPE			void
#define SPRINTFRETTYPE			int
#define	STRDUPPARAMTYPE			const char *
#define SRANDRETTYPE			void
#define WRITERETTYPE			int
#define _FLSBUFPARAM1TYPE		unsigned char
#define EXECVPPARAM1TYPE		const char *
#define MKDIRPARAM1TYPE			char *
#define QSORTPARAM2TYPE			unsigned
#define QSORTPARAM3TYPE			unsigned
#define QSORTRETTYPE			void
#define READPARAM3TYPE			unsigned
#define TEMPNAMPARAM1TYPE		char *
#define TEMPNAMPARAM2TYPE		char *
#define WRITEPARAM3TYPE			unsigned
#define POLLPARAM1TYPE 			void
#define POLLPARAM2TYPE			void
#define POLLPARAM3TYPE			void
#define FCVTRETTYPE 			char *
#define FCVTPARAM2TYPE			int
#define BITFIELDSTYPE			unsigned int
#define FDOPENPARAM2TYPE		char *
#define CONNECTRETTYPE			int
#define SOCKETRETTYPE			int
#define EXITRETTYPE				void
#define SYNCRETTYPE				void
#define WINDOWTYPE				int
#define ACCEPTPARAM2TYPE		struct sockaddr *
#define ACCEPTPARAM3TYPE		int *
#define	WAITPARAMTYPE			int *

/* Miscelaneous */
#define PSUID_CMD			""
#define PSUID_POS			(-1)
#define MAX_WINDOWS			128
#define	STDERR				stderr
#define AR_MOD_SEP			'/'
#define DEFAULT_PATH		"C:\\;C:\\DOS"
#define DEFAULT_SHELL		"C:\\COMMAND.COM"
#define MAIL_LIST			0
#define NEW_LINE			"\r\n"
#define PATH_SEP			";"
#define PATH_SLASH			"\\"
#define PATH_SLASH_UNIV		"/"
#define VEC_DEL_SIZE(a)
#define quote(a)			#a
#define COD_ZERO 			0x80

#define HAVE_PRIV_DERIV_BUG		1
#undef HAVE_STD_TCP_HEADERS
#undef HAVE_SYS_UTSNAME_H
#define HAVE_GENERIC_HPP		1
#define	HAVE_BUGOPER			1
#define	HAVE_CTRLC				1
#define HAVE_DISKFREESPACE		1
#undef HAVE_DSO
#define HAVE_STRICT_CHECK		1
#define HAVE_FIND				1
#define HAVE_DOS_H				1
#define DONT_ALLOW_REDEF		1
#define HAVE_LOCK_CHAIN			1
#define HAVE_CDINPATH			1
#define	TIME_FROM68				1
#undef HAVE_AR
#define stddbg	stdout
#undef NEED_WCHAR_T
#undef NO_CONTROL_192_255
#undef _16BIT
#undef IDEAWIN

/* End of zone */
#ifdef __cplusplus
extern "C" {
#endif

typedef RETSIGTYPE (*SigHandlerT)(int);

#	ifdef __cplusplus
}
#	endif

/* Compiler dependent define */
#ifndef DOS386
#	define HAVE_PRAGMA_ALIGN	1
#	define HAVE_64KLIMIT		1
#else
#	undef HAVE_PRAGMA_ALIGN
#	undef HAVE_64KLIMIT
#	define _far
#endif

#ifdef IDEAFIX
#	define printf idea_printf
#	define sprintf idea_sprintf
#	define	fprintf	idea_fprintf
#	ifdef __cplusplus
		extern "C" {
#	endif
#include <stdio.h>
int fprintf(FILE *,const char *,...);
#	ifdef __cplusplus
}
#	endif

#endif

#define MEMCHECK				((Int) 0x31415926)
#define BAD_MEM_BLOCK   		((Int) 0x46524565)
#ifdef ERROR
#	undef ERROR
#endif

/* Cfix stuff */
#undef CFIX_HAVE_SHLIB
#undef CFIX_HAVE_ESS_SHLIB
#undef CFIX_HAVE_OVERLAYS
#define CFIX_NEED_EXE_EXT	1
#undef CFIX_NEED_MINUSYP
#undef CFIX_NEED_QPATH
#define CFIX_C_EXT			".c"
#define CFIX_EXE_EXT		".exe"
#define CFIX_OBJ_EXT		".obj"
#define CFIX_LIB_EXT		".lib"
#define CFIX_COMPILER		"sc -c -mx "
#define CFIX_OPTIM			" -w "
#define CFIX_DEBUG			" -g -v -x "
#define CFIX_LINK			"sc -mx "
#define CFIX_LIBDIRSFLAG	" -L"
#define CFIX_LIBDIR			"lib "
#define CFIX_SHLIBDIR		"/SH421"
#define CFIX_LINKSTRIP		" -s "
#define CFIX_LINKDEBUG		" -v "
#define CFIX_OUTFILE		"-o "
#define CFIX_IXDBLIB		"ideax.lib"
#define CFIX_ESDBLIB		"essentia.lib"
#define CFIX_SCKTLIB		""
#define CFIX_IDEALIB		""
#define CFIX_IXDBSHLIB		""
#define CFIX_ESDBSHLIB		""
#define CFIX_SCKTSHLIB		""
#define CFIX_IDEASHLIB		""
#define CFIX_MAX_MODS		40
#define CFIX_INCLUDE 		"\\include"

#endif



