/***********************************************************************
* Copyright (c) 1991 InterSoft Co.  All Rights Reserved
* THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF InterSoft Co.
* The copyright notice above does not evidence any
* actual or intended publication of such source code.
*
* $Id: linux.h,v 1.22 1996/08/22 23:27:59 gustavof Exp $
*
* DESCRIPTION
* Operating system dependent defines
*********************************************************************/

#ifndef LINUX_H
#define LINUX_H

#include <_G_config.h>

#define _OS_	"Linux"
#define _OSVER_	"1.3.X"
#define _OS_SHORT_NAME_	"linux"

#if defined(ACADEMIC_VERSION)
#define EXTRA_BANNER_INFO   " (Academic-Beta) "
#elif defined (BETA_VERSION)
#   define  EXTRA_BANNER_INFO   " (Beta) " 
#else
#       define  EXTRA_BANNER_INFO   ""
#endif

#define MITRACE	{TRACE; tr_mem_check(); }
/* Typedefs */

#define INT32BITS	long
#ifndef	INT_TYPEDEF
#define INT_TYPEDEF
typedef INT32BITS Int;
typedef unsigned INT32BITS UnInt;
#endif

typedef unsigned int SizeT;
typedef unsigned short UidT;
typedef unsigned short GidT;
typedef int OffT;
typedef int PidT;
typedef int KeyT;
typedef unsigned short ModeT;
typedef union u_SemunT {
	int val;
	struct semid_ds *buf;
	unsigned short *array;
} SemunT;

/* Insert here locally needed defines */
#undef _POSIX_SOURCE
#undef _POSIX_VERSION
#define __USE_BSD		1

#define	stddbg	stderr
/* Compiler dependant capabilities */

/* Non compiler dependant capabilities */
#undef BAD_STRNCPY
#undef CANT_DEL_WHOLE_FILE
#undef CHKSUM
#undef DEBUG_LOCK
#define DIRENT 					1
#undef END_OF_TEXT_FILE_CHAR
#undef ENOTDIR_IS_ENOENT
#undef EXEC_TAKES_TIME
#undef HAVE_64KLIMIT
#define HAVE_ABORT				1
#define HAVE_AF_UNIX			1
#undef HAVE_AF_UNIX_LEN
#undef HAVE_ALTZONE
#define HAVE_AR					1
#undef HAVE_AR_AIAMAG
#undef HAVE_AR_FL_HDR
#undef HAVE_AR_NAMLEN
#undef HAVE_AR_NUMERIC
#undef HAVE_ASYNC_IO
#undef HAVE_BAD_CVT
#define HAVE_BCOPY				1
#define HAVE_BZERO				1
#undef HAVE_BSDTTY_H
#undef HAVE_CLOSEDIR_BUG
#undef HAVE_COMMAND_COM
#undef HAVE_EMULTIHOP
#undef HAVE_ENOLINK
#undef HAVE_ERRLIST
#undef HAVE_ETC_SHADOW
#define HAVE_FCNTL				1
#define HAVE_FIONREAD			1
#undef HAVE_FIORDCHK
#undef HAVE_FREEMEM
#define HAVE_FSYNC				1
#define HAVE_FULL_SIGNALS		1
#define HAVE_F_SETOWN			1
#undef HAVE_GETDFREE
#define HAVE_GETGROUPS			1
#undef HAVE_GETPWANAM
#undef HAVE_GETSPNAM
#undef HAVE_GETUSERPW
#undef HAVE_HEAP_WALK
#define	HAVE_INETD				1
#define HAVE_IPC				1
#define HAVE_JOB_CONTROL		1
#define	HAVE_INLINE_STAT		1
#define HAVE_LOCALTIME			1
#undef HAVE_LOCKF
#undef HAVE_LOCKING
#define HAVE_LONG_ARGV			1
#undef HAVE_LTCHARS
#define HAVE_MAIL				1
#undef HAVE_MMDF				
#define HAVE_MEMMOVE			1
#define HAVE_MKNOD				1
#define HAVE_MKTEMP				1
#undef HAVE_OP_CONST_VOID_PTR
#define HAVE_O_SYNC				1
#define HAVE_OPENDIR			1
#undef HAVE_PASTE
#undef HAVE_PW_COMMENT
#define HAVE_PID				1
#define HAVE_PIPES				1
#undef HAVE_PRAGMA_ALIGN
#define HAVE_PROC				1
#define HAVE_PROC_DIR			1
#undef HAVE_PSEUDO_CONCURR
#define HAVE_RANLIB				1
#define HAVE_REAL_LOCKS			1
#define HAVE_RENAME

#define HAVE_RESTARTABLE_SYSCALLS	1
#undef HAVE_SAVEMEM
#define HAVE_SECURITY			1
#define HAVE_SECURITY_CHECK		0
#define HAVE_SEMAPHORES			1
#define HAVE_SETRLIMIT			1
#define HAVE_SETSID				1
#define HAVE_SETUID				1
#undef HAVE_SGR
#undef HAVE_SHORT_ENV
#undef HAVE_SHORT_FILE_NAMES
#undef HAVE_SHORT_MEMSET
#define HAVE_SIGABRT			1
#define HAVE_SIGPWR			1
#undef HAVE_SIGSET
#undef HAVE_SIGVEC
#define	HAVE_SIGACTION				1
#undef HAVE_SIGEMT
#define HAVE_SIGUNUSED				1
#undef HAVE_SIGSYS
#undef HAVE_SOUND_BEEP
#undef HAVE_STKLEN
#define HAVE_STRSTR				1
#define HAVE_STRTOK				1
#undef HAVE_SWAP
#define HAVE_SYNC				1
#undef HAVE_SYSTTOLD_H
#undef HAVE_SYS_TIMEB_H
#define HAVE_SYS_VFS_H			1
#define HAVE_TERMIO_H
#define HAVE_TERMIOS_H			1
#undef HAVE_TEXT_FILES
#undef HAVE_TIMEOFFSET
#define HAVE_TIMEZONE			1
#define HAVE_TIME_H				1
#define HAVE_TMPFILE			1
#define HAVE_TMPBUGS			1
#undef HAVE_TM_ZONE
#define HAVE_TRUNCATE			1
#define HAVE_TTY				1
#define HAVE_UMASK				1
#define HAVE_UNISTD_H			1
#define HAVE_USERS				1
#define HAVE_UTIME_H			1
#define HAVE_USEUSEMUN			1
#define HAVE_WAITPID			1
#undef HAVE_XCC
#undef HAVE_ZPM
#undef LOG_DBG
#define NEED_AR_PORTAR			1
#undef NEED_CLOSE_FOR_SYNC
#undef NEED_MEM_DEBUG
#undef NEED_NETBIOS_FOPEN
#undef NEED_WCHAR_T
#undef NO_ADVISORY_LOCK
#undef NO_EXTERN_CONST
#undef NO_MKRMDIR
#undef NO_SERVICES
#undef OPEN_CANT_CREATE
#undef SPANISH
#define ENGLISH					1
#undef STATFS_HAS_LEN
#undef SYSDIR
#undef SYSNDIR
#undef USE_FGETC
#undef USG
#define _G_USE_PROTOS			1
#undef HAVE_SARWITHSWAP
#define HAVE_NOPROBLEMSCLOSING012	1
#define HAVE_SYSLOG				1
#undef HAVE_VARARGS_BUG
#undef HAVE_GRAPHICS
#undef HAVE_MMF
#define HAVE_USEFULFTRUNCATE	1
#define	HAVE_TERMINFO_LINES_BUG 1
#define CAN_HAVE_INLINE_STAT	1

/* Compiler dependant parameter types */

#undef HAVE_PRIV_DERIV_BUG
#define HAVE_STD_TCP_HEADERS	1
#define HAVE_SYS_UTSNAME_H		1
#undef HAVE_GENERIC_HPP
#undef HAVE_CTRLC
#undef HAVE_DISKFREESPACE
#define HAVE_DSO				1
#undef HAVE_STRICT_CHECK
#undef HAVE_FIND
#undef HAVE_DOS_H
#undef DONT_ALLOW_REDEF
#undef HAVE_LOCK_CHAIN
#undef HAVE_CDINPATH
#undef TIME_FROM68
#undef NO_CONTROL_192_255
#undef IDEAWIN
#undef _16BIT
#define _far
#define __far

/* Non compiler dependant parameter types */
#define ABORTRETTYPE 			void
#define ALLOCRETTYPE			void *
#define BCOPYPARAM3TYPE			int
#define	BZEROPARAM2TYPE			int

#ifdef _LINIX_C_LIB_VERSION_MAJOR
#if ((_LINUX_C_LIB_VERSION_MAJOR * 10 + _LINUX_C_LIB_VERSION_MINOR) >= 52)
#define BINDPARAM2TYPE			const struct sockaddr *
#else
#define BINDPARAM2TYPE			struct sockaddr *
#endif
#else
#define BINDPARAM2TYPE			const struct sockaddr *
#endif

#define BINDPARAM3TYPE			int
#define CFTIMEPARAM2TYPE		char *
#define CHOWNPARAM2TYPE 		UidT
#define CHOWNPARAM3TYPE 		GidT
#define	SOCKETRETTYPE			int
#define	CONNECTRETTYPE			int
#define	CONNECTPARAM1TYPE		int
#ifdef _LINIX_C_LIB_VERSION_MAJOR
#if ((_LINUX_C_LIB_VERSION_MAJOR * 10 + _LINUX_C_LIB_VERSION_MINOR) >= 52)
#define CONNECTPARAM2TYPE		const struct sockaddr *
#else
#define CONNECTPARAM2TYPE		struct sockaddr *
#endif
#define CONNECTPARAM3TYPE		int
#else
#define CONNECTPARAM2TYPE		const struct sockaddr *
#define CONNECTPARAM3TYPE		int
#endif
#define EXECVPPARAM1TYPE		const char * 
#define EXECVPPARAM2TYPE		char * const *
#define FCNTLPARAM3TYPE			...
#define FTELLRETTYPE			long
#define FTELLPARAM1TYPE			FILE *
#define FDOPENPARAM2TYPE		const char *
#define FPUTCPARAM1TYPE			int
#define FREADPARAM1TYPE			void *
#define FTRUNCATEPARAM2TYPE		SizeT
#define FWRITEPARAM1TYPE		const void *
#define GCVTPARAM2TYPE          unsigned int    
#define GETCWDPARAM1TYPE		char *
#define GETCWDPARAM2TYPE 		SizeT
#define GETGRGIDPARAMTYPE		GidT
#define GETPWUIDPARAMTYPE		UidT
#define MKDIRPARAM1TYPE			const char *
#define MSGCTLPARAM3TYPE		struct msqid_ds *
#define MSGRCVPARAM2TYPE		struct msgbuf *
#define MSGRCVPARAM3TYPE		int
#define MSGSNDPARAM2TYPE		struct msgbuf *
#define MSGSNDPARAM3TYPE		int
#define MUNMAPPARM1TYPE			void *
#define	MUNMAPPARAM2TYPE		size_t
#define OPENPARAM3TYPE			...
#define OPENRETTYPE				int
#define PAUSERETTYPE 			int
#define POPENPARAMTYPE			const char *
#define PUTENVPARAMTYPE			const char *
#define QSORTPARAM2TYPE			SizeT
#define QSORTPARAM3TYPE			SizeT
#define QSORTRETTYPE			void
#define READPARAM3TYPE			SizeT
#define READRETTYPE				int
#define RETSIGTYPE				void
#define SBRKPARAMTYPE 			int
#define SBRKRETTYPE 			void *
/* #define SEMCTLPARAM4TYPE		SemunT */
#define SEMOPPARAM3TYPE			unsigned
#define SLEEPPARAMTYPE			unsigned
#define SLEEPRETTYPE			unsigned
#define SPRINTFRETTYPE			int
#define SRANDRETTYPE			void
#define	STRDUPPARAMTYPE			const char *
#define STATFSPARAM1TYPE		const char *
#define WRITEPARAM3TYPE			SizeT
#define WRITERETTYPE			int
#define _FLSBUFPARAM1TYPE		unsigned char
#define POLLPARAM1TYPE 			struct pollfd *
#define POLLPARAM2TYPE			unsigned long
#define POLLPARAM3TYPE			int
#define FCVTPARAM2TYPE			unsigned
#define FCVTRETTYPE 			char *
#define ECVTPARAM2TYPE			unsigned int
#define ECVTRETTYPE 			char *
#define EXITRETTYPE				void
#define	SYNCRETTYPE				int
#define TEMPNAMPARAM1TYPE		char const *
#define TEMPNAMPARAM2TYPE		char const *
#define GETHOSTBNPARAMTYPE		char const *
#define GETSERVBNPARAM1TYPE		char const *
#define GETSERVBNPARAM2TYPE		char const *
#define GETHOSTNPARAM2TYPE		unsigned
#define GETPEERNAMEPARAM2TYPE	struct sockaddr *
#define GETPEERNAMEPARAM3TYPE	int *
#define WINDOWTYPE			int
#ifdef _LINIX_C_LIB_VERSION_MAJOR
#if ((_LINUX_C_LIB_VERSION_MAJOR * 10 + _LINUX_C_LIB_VERSION_MINOR) >= 52)
#define ACCEPTPARAM2TYPE		const struct sockaddr *
#else
#define ACCEPTPARAM2TYPE		struct sockaddr *
#endif
#define ACCEPTPARAM3TYPE		int *
#else
#define ACCEPTPARAM2TYPE		const struct sockaddr *
#define ACCEPTPARAM3TYPE		int *
#endif
#define BITFIELDSTYPE			unsigned long
#define	WAITPARAMTYPE			void *

/* Miscelaneous */
#define PSUID_CMD				"ps -lp%ld"
#define PSUID_POS				1
#define MAX_WINDOWS				512
#define	STDERR					stderr
#define FM_MAX_OPEN				128
#define AR_MOD_SEP				'/'
#define DEFAULT_PATH			":/bin:/usr/ideafix/bin"
#define DEFAULT_SHELL			"/bin/sh"
#define MAIL_HOME				"/var/mail"
#define NEW_LINE				"\n"
#define PATH_SEP				":"
#define PATH_SLASH				"/"
#define PATH_SLASH_UNIV			"/"
#define VEC_DEL_SIZE(a)
#undef VOLUME_LETTER_SEP
#define quote(a)				#a
typedef RETSIGTYPE (*SigHandlerT)(int);

/* Cfix stuff */
#define CFIX_HAVE_SHLIB	1
#define  CFIX_HAVE_ESS_SHLIB	1
#undef CFIX_HAVE_OVERLAYS
#undef CFIX_NEED_EXE_EXT
#undef CFIX_NEED_MINUSYP
#undef CFIX_NEED_QPATH
#define CFIX_C_EXT			".c"
#define CFIX_EXE_EXT		".exe"
#define CFIX_OBJ_EXT		".o"
#define CFIX_LIB_EXT		".a"
#define CFIX_COMPILER		"cc -c "
#define CFIX_OPTIM			" -O "
#define CFIX_DEBUG			" -g "
#define CFIX_LINK			"cc "
#define CFIX_LIBDIRSFLAG	" -L"
#define CFIX_LIBDIR			"/lib "
#define CFIX_SHLIBDIR		"-L/SH432"
#define CFIX_LINKSTRIP		" -s "
#define CFIX_LINKDEBUG		" -g "
#define CFIX_OUTFILE		"-o "
#define CFIX_IXDBLIB		" -lixdb "
#define CFIX_ESDBLIB		" -lesdb "
#define CFIX_SCKTLIB		" "
#define CFIX_IDEALIB		" -lidea "
#define CFIX_IXDBSHLIB		" -lixdb_s "
#define CFIX_ESDBSHLIB		" -lesdb_s "
#define CFIX_SCKTSHLIB		" "
#define CFIX_IDEASHLIB		" -lidea_s -lm "
#define CFIX_MAX_MODS		100
#define CFIX_INCLUDE 		"/include"

/* because of COD_ZERO, invented by Eugen, we must define it somewere*/
#define	COD_ZERO	0x1f

#endif

