/***********************************************************************
* Copyright (c) 1991 InterSoft Co.  All Rights Reserved
* THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF InterSoft Co.
* The copyright notice above does not evidence any
* actual or intended publication of such source code.
*
* MODULE & VERSION : @(#)nt.h
* DATE             : 96/04/16
* TIME             : 17:15:06
*
* DESCRIPTION:
*                               Operating system dependent defines
*
*********************************************************************/


#ifndef __NT_H
#define __NT_H
#ifndef __NT__
#error "You must compile it with NT flat model"
#endif

#ifndef _WINDOWS
#       define _WINDOWS         1
#endif

#define _OLE2_H_	1
#define _OLEAUTO_H_	1
#define __oaidl_h__   1

#undef MSDOS
#undef IDEAWIN
#define stddbg	stderr
#define __PRETTY_FUNCTION__ __FUNC__
#define _OS_    "MS WINDOWS-NT"
#define _OSVER_ "3.5 +"
#define _OS_SHORT_NAME_	"NT"

/* Typedefs */
typedef unsigned SizeT;

/* Dummy typedefs */

typedef unsigned short UidT;
typedef unsigned short GidT;
typedef unsigned OffT;
typedef unsigned PidT;
typedef unsigned KeyT;
typedef unsigned short ModeT;
typedef union u_SemunT {
        int val;
        struct semid_ds *buf;
        unsigned short *array;
} SemunT;

/* Insert here locally needed defines */
#undef _POSIX_SOURCE
#undef _POSIX_VERSION

/* Compiler dependant capabilities */
#define HAVE_LONGLONGBUG	1
/* Non compiler dependant capabilities */
#undef BAD_STRNCPY
#define CANT_DEL_WHOLE_FILE                     1
#undef CHKSUM
#undef C_HEAP
#undef DEBUG_LOCK
#undef DIRENT
#define END_OF_TEXT_FILE_CHAR                   26
#define ENOTDIR_IS_ENOENT                       1
#undef EXEC_TAKES_TIME
#define HAVE_ABORT                              1
#undef HAVE_ALTZONE
#undef HAVE_AR_AIAMAG
#undef HAVE_AR_FL_HDR
#undef HAVE_AR_NAMLEN
#undef HAVE_AR_NUMERIC
#undef HAVE_BCOPY
#undef HAVE_BSDTTY_H

//#define HAVE_COMMAND_COM                        1
#undef HAVE_COMMAND_COM
#undef HAVE_EMULTIHOP
#undef HAVE_ENOLINK
#undef HAVE_ERRLIST
#undef HAVE_FCNTL
#undef HAVE_FIONREAD
#undef HAVE_FIORDCHK
#undef HAVE_FREEMEM
#undef HAVE_FSYNC
#undef HAVE_FULL_SIGNALS
#undef HAVE_F_SETOWN
#undef HAVE_GETDFREE
#undef HAVE_HEAP_WALK
#undef HAVE_IPC
#undef HAVE_JOB_CONTROL
#undef HAVE_LOCALTIME
#undef HAVE_LOCKF
//#define HAVE_LOCKING                            1
#undef HAVE_LOCKING
#undef HAVE_LTCHARS
#define HAVE_DIFFERENT_SLASH			1
#define HAVE_WINSOCK				1
#define HAVE_CLOSEPRINTER_CONFLICT	1
#define HAVE_CREATECURSOR_CONFLICT	1
#define HAVENT_UI				1
#define	HAVE_SYSTEMTIME		1
#define HAVE_PM			1


#undef HAVE_MAIL
#define HAVE_MEMMOVE                            1
#undef HAVE_MKTEMP
#undef HAVE_OPENDIR
#define HAVE_PASTE                              1
#undef HAVE_PID
#undef HAVE_PIPES
#define HAVE_PRAGMA                             1
#define HAVE_PROC							1
#undef HAVE_PROC_DIR
#define HAVE_PSEUDO_CONCURR                     1
#undef HAVE_RANLIB
#undef HAVE_REAL_LOCKS
#define HAVE_RENAME                             1
#undef HAVE_RESTARTABLE_SYSCALLS
#define HAVE_SAVEMEM                            1
#define HAVE_SECURITY						1
#define	HAVE_REGISTRY						1
#undef HAVE_SEMAPHORES
#undef HAVE_SETSID
#undef HAVE_SETUID
#undef HAVE_SGR

#undef HAVE_SHORT_ENV
#undef HAVE_SHORT_FILE_NAMES
#undef HAVE_SHORT_MEMSET
#undef HAVE_SIGABRT
#undef HAVE_SIGPWR
#undef HAVE_SIGSET
#undef HAVE_SIGVEC
#define HAVE_SOUND_BEEP                         1
#undef HAVE_STKLEN
#define HAVE_STRSTR                             1
#define HAVE_STRTOK                             1
#undef HAVE_SWAP
#undef HAVE_SYNC
#undef HAVE_SYSTTOLD_H
#undef HAVE_SYS_TIMEB_H
#undef HAVE_SYS_VFS_H
#define HAVE_TERMIO_H                           1
#define HAVE_TEXT_FILES                         1
#undef HAVE_TIMEOFFSET
#undef HAVE_TIMEZONE
#undef HAVE_SYSLOG
#define HAVE_VARARGS_BUG			1
#undef HAVE_GRAPHICS
#undef HAVE_MMF
#undef HAVE_USEFULFTRUNCATE

#define HAVE_TIME_H                             1
#define HAVE_TMPFILE                            1
#undef HAVE_TM_ZONE
#undef HAVE_TRUNCATE
#undef HAVE_TTY
#undef HAVE_UMASK
#undef HAVE_UNISTD_H
//#undef	HAVE_USERS
#define	HAVE_USERS							1
#undef HAVE_XCC
#undef HAVE_ZPM
#undef LOG_DBG
#define NEED_AR_PORTAR                          1
#undef NEED_CLOSE_FOR_SYNC
#undef NEED_MEM_DEBUG
#undef NEED_NETBIOS_FOPEN
//#define NO_ADVISORY_LOCK                        1
#undef NO_ADVISORY_LOCK
#undef NO_EXTERN_CONST
#undef NO_MKRMDIR
#undef NO_SERVICES
#undef OPEN_CANT_CREATE
#define MKDIR_HAS_ONE_PARAM                     1
#define HAVE_LOCKFILEEX

#define ENGLISH                                 1

#define HAVE_NETAPI					1
#undef HAVE_AF_UNIX_LEN
#undef HAVE_LONG_ARGV
#undef HAVE_O_SYNC
#undef HAVE_TERMIOS_H
#undef HAVE_UTIME_H
#undef MAIL_LIST
#define FM_MAX_OPEN                             128
#define MAIL_HOME                               "/usr/mail"
#undef STATFS_HAS_LEN
#define SYSDIR                                  1
#undef SYSNDIR
#define USE_FGETC                               1
#define VOLUME_LETTER_SEP                       ":"
#undef USG
#define _G_USE_PROTOS                           1
#define MULTI_LINE_ANY_ROW                      1
#define NEED_WCHAR_T							1
#define HAVE_PRIV_DERIV_BUG             1
#undef HAVE_STD_TCP_HEADERS
#undef HAVE_SYS_UTSNAME_H
#define HAVE_GENERIC_HPP                1
#define HAVE_BUGOPER                    1
#undef  HAVE_CTRLC
#define HAVE_DISKFREESPACE              1
#define HAVE_STRICT_CHECK               1
#define HAVE_FIND                               1
#define HAVE_DOS_H                              1
#define DONT_ALLOW_REDEF                1
#define HAVE_LOCK_CHAIN                 1
#define HAVE_CDINPATH                   1
#undef TIME_FROM68                             1
#undef HAVE_AR
#define HAVE_INETD						1
#define HAVE_STAT_SIZE_BUG              1
#define HAVE_FFLUSH_BUG                 1
#define STDERR  stdout

/* Compiler dependant parameter types */

/* Non compiler dependant parameter types */
#define ABORTRETTYPE                    void
#define ALLOCRETTYPE                    void *
#define BCOPYPARAM3TYPE                 int
#define	BZEROPARAM2TYPE					int
#define BINDPARAM2TYPE					const struct sockaddr *
#define BINDPARAM3TYPE					int
#define	CFTIMEPARAM2TYPE				char *
#define CHOWNPARAM2TYPE                 int
#define CHOWNPARAM3TYPE                 GidT
#define CONNECTPARAM1TYPE               unsigned int
#define CONNECTPARAM2TYPE               struct sockaddr *
#define CONNECTPARAM3TYPE               struct sockaddr *
#define EXECVPPARAM2TYPE                const char * const *
#define FCNTLPARAM3TYPE                 ...
#define FPUTCPARAM1TYPE                 int
#define FREADPARAM1TYPE                 void *
#define FTELLRETTYPE					long
#define FTELLPARAM1TYPE					FILE *
#define FTRUNCATEPARAM2TYPE		OffT
#define FWRITEPARAM1TYPE                void const *
#define GCVTPARAM2TYPE          		int
#define GETCWDPARAM1TYPE                char *
#define GETCWDPARAM2TYPE                SizeT
#define GETPEERNAMEPARAM2TYPE	void *
#define GETPEERNAMEPARAM3TYPE	int *
#define GETPWUIDTYPE1PARAM              UidT
#define MSGCTLPARAM3TYPE                struct msqid_ds *
#define MSGRCVPARAM2TYPE                struct msgbuf *
#define MSGRCVPARAM3TYPE                int
#define MSGSNDPARAM2TYPE                struct msgbuf *
#define MSGSNDPARAM3TYPE                int
#define MUNMAPPARAM1TYPE	 			char *
#define MUNMAPPARAM2TYPE				size_t
#define OPENPARAM3TYPE                  ...
#define	OPENRETTYPE						int
#define PAUSERETTYPE                    void
#define POPENPARAMTYPE                  char *
#define PUTENVPARAMTYPE                 char const *
#define READRETTYPE                             int
#define RETSIGTYPE                              void
#define SBRKRETTYPE                     void *
#define SBRKPARAMTYPE                   unsigned
#define SEMCTLPARAM4TYPE                SemunT
#define SEMOPPARAM3TYPE                 unsigned
#define SLEEPPARAMTYPE                  long
#define SLEEPRETTYPE                    void
#define SPRINTFRETTYPE		   			int
#define SRANDRETTYPE					void
#define STRDUPPARAMTYPE			const char *
#define STATFSPARAM1TYPE				const char *
#define WRITERETTYPE                    int
#define _FLSBUFPARAM1TYPE               unsigned char
#define EXECVPPARAM1TYPE                const char *
#define GETGRGIDPARAMTYPE               GidT
#define GETPWUIDPARAMTYPE               UidT
#define MKDIRPARAM1TYPE                 char const *
#define QSORTPARAM2TYPE                 unsigned
#define QSORTPARAM3TYPE                 unsigned
#define QSORTRETTYPE					void
#define READPARAM3TYPE                  unsigned
#define TEMPNAMPARAM1TYPE				char *
#define TEMPNAMPARAM2TYPE				char *
#define WRITEPARAM3TYPE                 unsigned
#define POLLPARAM1TYPE                  void
#define POLLPARAM2TYPE                  void
#define POLLPARAM3TYPE                  void
#define FCVTRETTYPE                     char *
#define FCVTPARAM2TYPE	 				int
#define BITFIELDSTYPE			unsigned long
#define FDOPENPARAM2TYPE		char const *
#define CONNECTRETTYPE					int
#define SOCKETRETTYPE					unsigned int
#define EXITRETTYPE						void
#define SYNCRETTYPE						void
#define WINDOWTYPE				int
#define ACCEPTPARAM2TYPE				struct sockaddr *
#define ACCEPTPARAM3TYPE				int *

/* Miscelaneous */
#define AR_MOD_SEP                      '/'
#define DEFAULT_PATH                    "C:\\;C:\\DOS"
#define DEFAULT_SHELL                   "DEFAULT.PIF"
#define MAIL_LIST                       0
#define NEW_LINE                        "\r\n"
#define PATH_SEP                        ";"
#define PATH_SLASH                      "\\"
#define PATH_SLASH_UNIV                 "/"
#define VEC_DEL_SIZE(a)
#define quote(a)                        #a

/* Added in SC */
/* End of zone */

#ifdef __cplusplus
extern "C" {
#endif

typedef RETSIGTYPE (*SigHandlerT)(int);
#       ifdef __cplusplus
}
#       endif

#undef _16BIT
#undef HAVE_64KLIMIT
#define  _export
#define FAR
#define far
#define _far
#define __far
#define __cs

#define printf idea_printf
#define sprintf idea_sprintf
#define fprintf idea_fprintf


#define MEMCHECK		((long) 0x31415926)
#define BAD_MEM_BLOCK	((long) 0x46524565)


/* Cfix stuff */
#undef CFIX_HAVE_SHLIB
#undef CFIX_HAVE_ESS_SHLIB
#undef CFIX_HAVE_OVERLAYS
#define CFIX_NEED_EXE_EXT       1
#undef CFIX_NEED_MINUSYP
#undef CFIX_NEED_QPATH
#define CFIX_C_EXT                      ".c"
#define CFIX_EXE_EXT            ".exe"
#define CFIX_OBJ_EXT            ".obj"
#define CFIX_LIB_EXT            ".lib"
#define CFIX_COMPILER           "sc -c -mn -DSTRICT -D__NTSERVER__ -Jm -p "
#define CFIX_OPTIM              " -o+speed "
#define CFIX_DEBUG              ""
#define CFIX_LINK               "sc -mn kernel32.lib user32.lib gdi32.lib advapi32.lib wsock32.lib "
#define CFIX_LIBDIRSFLAG        ""
#define CFIX_LIBDIR              "\\lib "
#define CFIX_LINKSTRIP          ""
#define CFIX_LINKDEBUG          ""
#define CFIX_OUTFILE            "-o "
#define CFIX_IXDBLIB            "libixdb.lib "
#define CFIX_ESDBLIB            "libesdb.lib "
#define CFIX_SCKTLIB            ""
#define CFIX_IDEALIB            "libidea.lib "
#define CFIX_IXDBSHLIB          "libixdb.lib "
#define CFIX_ESDBSHLIB          "libesdb.lib "
#define CFIX_SCKTSHLIB          ""
#define CFIX_IDEASHLIB          "libidea.lib"
#define CFIX_MAX_MODS           40
#define CFIX_INCLUDE            "\\include"

#define  CFIX_CPP_EXT   ".cc"
#define  CFIX_RES_FLAG  "-r "
#define  CFIX_ICON_FLAG "-i "
#define  CFIX_HAVE_RES  1
#define  CFIX_HAVE_IDEAWIN      1
#define  CFIX_RESOURCE  "rcc "
#define  CFIX_MAKES_LIB  1
#define CFIX_LIB        "lib "
#define CFIX_LIB_OPT    " /NOI /B "
#define CFIX_ICON_EXT	".ico"


#ifdef ERROR
#       undef ERROR
#endif

#undef FAR_STATIC_DATA

/* New macros in IDEAWIN */
#define DEF_LANG        "ENGLISH"
#define COD_ZERO 0x1F
#define NO_CONTROL_192_255
#undef HAVE_MAP_FILE
#undef DONT_HAVE_ALLOCA
#	ifdef __cplusplus
	extern "C" {
#	endif
 		void Fprintf(char *, ...);
#	ifdef __cplusplus
	}
#	endif

#	define Ftrace Fprintf("%s %d\t :%s\n",__FILE__,__LINE__,__PRETTY_FUNCTION__);


#endif /* __NT_H */
