.\"
.\" $Id: portdoc.mm,v 1.6 1996/08/15 16:39:03 eduardoc Exp $
.\"
.\" ************************************************
.\" WARNING : THIS FILE CAN NOT BE EDITED WITH DALI.
.\" ************************************************
.nr O 0
.so /usr/lib/tmac/tmac.m
.PH "''''"
.S 8 8
The following table should be used as a guide.  It must not be
taken strictly since it is possible that some of the commands
do not work on some machines and when we say 'Only for XXX' we
really mean 'generally only for XXX'.  All boolean values (HAVE_XXX,
etc.) should be defined to 1 for true and undefined for false.
.TS
center, box, tab(:);
cw(5c)|cw(10c)|cw(8c)|cw(1c)
l|l|l|l.
Variable:Description:How to obtain its value:Example
_
_OS_:T{
Operating system/machine name
T}:T{
\f(CWuname -a\fR.
T}:T{
386/ix
T}
_OSVER_:T{
Operating system version
T}:T{
\f(CWuname -a\fR.
T}:T{
3.2 2+
T}
SizeT, UidT, GidT, PidT,
.br
KeyT, ModeT, SemunT:T{
Standard data types \f(CWsize_t,\fR \f(CWuid_t,\fR \f(CWgid_t,\fR
\f(CWpid_t,\fR \f(CWkey_t,\fR
\f(CWmode_t\fR and \f(CWunion\fR semun (used in many library functions).
T}:T{
\f(CWvi /usr/include/sys/types.h\fR.
.br
\f(CWvi /usr/include/sys/sem.h\fR.
T}:T{
'typedef unsigned SizeT;', etc.
T}
BAD_STRNCPY:T{
If the function \f(CWstrncpy\fR does not work correctly (Xenix, for
example).
T}:T{
Compile a program that uses it and try it.
T}:T{
T}
CANT_DEL_WHOLE_FILE:T{
Whether the function \f(CWDelAllRecords\fR can erase the whole file or
it should be done with \f(CWDelRecord's\fR (don't know why it is done
this way in MS-DOS... may be a bug).
T}:T{
Only for MS-DOS.
T}:T{
T}
CHKSUM:T{
Whether the tree nodes should use checksums.
T}:T{
Only for debugging.
T}:T{
T}
C_HEAP:T{
Whether the function \f(CWchkheap\fR should be compiled.
T}:T{
Only for debugging.
T}:T{
T}
DEBUG_LOCK:T{
Whether a lock log should be generated.
T}:T{
Only for debugging.
T}:T{
T}
DIRENT:T{
Whether the \f(CW<dirent.h>\fR header exists.
T}:T{
\f(CWls /usr/include/dirent.h\fR.
T}:T{
T}
END_OF_TEXT_FILE_CHAR:T{
Whether it is necessary or not to write a character indicating
end of file (\f(CWCtrl-Z\fR for MS-DOS).
T}:T{
Only for MS-DOS.
T}:T{
T}
ENOTDIR_IS_ENOENT:T{
Whether errno \f(CWENOTDIR\fR really means \f(CWENOENT\fR.
T}:T{
Only for MS-DOS (Zortech).
T}:T{
T}
EXEC_TAKES_TIME:T{
Whether \f(CWexec\fR of an executable takes time (so as to make the
menu option blink in the meantime).
T}:T{
Only for MS-DOS.
T}:T{
T}
HAVE_64KLIMIT:T{
Whether more than 64K can be "malloc"ed.
T}:T{
Only for MS-DOS on some memory models.
T}:T{
T}
HAVE_ABORT:T{
Whether the \f(CWabort\fR function exists.
T}:T{
\f(CWgrep abort /usr/include[/sys]/*.h\fR.
T}:T{
T}
HAVE_ASYNC_IO:T{
Whether the \f(CWaiowrite\fR, \f(Caioread\fR, \f(Caiowait\fR functions exists.
T}:T{
\f(CWgrep aiowrite /usr/include[/sys]/*.h\fR.
T}:T{
T}
HAVE_ALTZONE:T{
Whether the \f(CWaltzone\fR variable exists for time adjustment.
T}:T{
\f(CWgrep altzone /usr/include[/sys]/time.h\fR.
T}:T{
T}
HAVE_AR_AIAMAG:T{
Whether the \f(CWar\fR magic is the \f(CWAIAMAG\fR macro (only for AIX).
T}:T{
\f(CWvi /usr/include[/sys]/ar.h\fR.
T}:T{
T}
HAVE_AR_FL_HDR:T{
Whether the \f(CW<ar.h>\fR header has the \f(CWstruct\fR fl_hdr structure
(only for AIX).
T}:T{
\f(CWvi /usr/include[/sys]/ar.h\fR.
T}:T{
T}
HAVE_AR_NAMLEN:T{
Whether \f(CWar\fR has variable length object names (only for AIX).
T}:T{
\f(CWvi /usr/include[/sys]/ar.h\fR.
T}:T{
T}
HAVE_AR_NUMERIC:T{
Whether \f(CW<ar.h>\fR has the MAGIC and size in binary (instead of ASCII)
form (only for Xenix).
T}:T{
\f(CWvi /usr/include/ar.h\fR.
T}:T{
T}
HAVE_BCOPY:T{
Whether the \f(CWbcopy\fR function exists.
T}:T{
\f(CWgrep bcopy /usr/include[/sys]/*.h\fR.
T}:T{
T}
.TE
.bp
.TS
center, box, tab(:);
cw(5c)|cw(10c)|cw(8c)|cw(1c)
l|l|l|l.
Variable:Description:How to obtain its value:Example
_
HAVE_COMMAND_COM:T{
Whether the operating system has \f(CWcommand.com\fR (obviously only for MS-DOS).
T}:T{
Only for MSDOS.
T}:T{
T}
HAVE_EMULTIHOP:T{
Whether errno \f(CWEMULTIHOP\fR exists.
T}:T{
\f(CWgrep EMULTIHOP /usr/include[/sys]/errno.h\fR.
T}:T{
T}
HAVE_ENOLINK:T{
Whether errno \f(CWENOLINK\fR exists.
T}:T{
\f(CWgrep ENOLINK /usr/include[/sys]/errno.h\fR.
T}:T{
T}
HAVE_ERRLIST:T{
Whether the \f(CWerrlist\fR variable exists.
T}:T{
\f(CWgrep errlist /usr/include[/sys]/errno.h\fR.
T}:T{
T}
HAVE_FCNTL:T{
Whether the \f(CWfcntl\fR function exists.
T}:T{
\f(CWgrep fcntl /usr/include[/sys]/*.h\fR.
T}:T{
T}
HAVE_FIONREAD:T{
Whether the \f(CWFIONREAD\fR parameter exists for the \f(CWioctl\fR function.
T}:T{
\f(CWgrep FIONREAD /usr/include[/sys]/*.h\fR.
T}:T{
T}
HAVE_FIORDCHK:T{
Whether the flag \f(CWFIORDCHK\fR parameter exists for the \f(CWioctl\fR function.
T}:T{
\f(CWgrep FIORDCHK /usr/include[/sys]/*.h\fR.
T}:T{
T}
HAVE_FREEMEM:T{
Whether the \f(CWFreeMem\fR function can be implemented.
T}:T{
Only for MS-DOS.
T}:T{
T}
HAVE_FSYNC:T{
Whether the \f(CWfsync\fR function exists.
T}:T{
\f(CWgrep fsync /usr/include[/sys]/*.h\fR.
T}:T{
T}
HAVE_FULL_SIGNALS:T{
Whether signals are fully supported.
T}:T{
Everyone except MS-DOS.
T}:T{
T}
HAVE_F_SETOWN:T{
Whether the \f(CWF_SETOWN\fR parameter exists for the \f(CWfcntl\fR function.
T}:T{
\f(CWgrep F_SETOWN /usr/include[/sys]/*.h\fR.
T}:T{
T}
HAVE_GETDFREE:T{
Whether the \f(CWgetdfree\fR function exists.
T}:T{
\f(CWgrep getdfree /usr/include[/sys]/*.h\fR.
T}:T{
T}
HAVE_HEAP_WALK:T{
Whether the \f(CWheap_walk\fR function exists.
T}:T{
Only for MS-DOS (Borland).
T}:T{
T}
HAVE_IPC:T{
Whether IPC (Inter Process Communications) facilities exist.
T}:T{
Everyone except MS-DOS.
T}:T{
T}
HAVE_JOB_CONTROL:T{
Whether job control facilities exist.
T}:T{
Enter \f(CWvi\fR and type \f(CWCtrl-Z,\fR if you're back in the shell
then you have job control (use \f(CWfg\fR to return to \f(CWvi)\fR.
T}:T{
T}
HAVE_LOCALTIME:T{
Whether the \f(CWlocaltime\fR variable exists.
T}:T{
\f(CWgrep localtime /usr/include[/sys]/time.h\fR.
T}:T{
T}
HAVE_LOCKF:T{
Whether the \f(CWlockf\fR function exists.
T}:T{
\f(CWgrep lockf /usr/include[/sys]/*.h\fR.
T}:T{
T}
HAVE_LOCKING:T{
Whether the \f(CWlocking\fR function exists.
T}:T{
\f(CWgrep locking /usr/include[/sys]/*.h\fR.
T}:T{
T}
HAVE_LONG_ARGV:T{
Whether a Int command line can be used.
T}:T{
Everyone except MS-DOS.
T}:T{
T}
HAVE_LTCHARS:T{
Whether the \f(CWstruct\fR ltchars structure exists.
T}:T{
\f(CWgrep ltchars /usr/include[/sys]/*.h\fR.
T}:T{
T}
.TE
.bp
.TS
center, box, tab(:);
cw(5c)|cw(10c)|cw(8c)|cw(1c)
l|l|l|l.
Variable:Description:How to obtain its value:Example
_
HAVE_MAIL:T{
Whether the mail facility is available.
T}:T{
Everyone except MS-DOS.
T}:T{
T}
MMDF:T{
Whether the mailer is MMDF or a more normal one like sendmail.
T}:T{
Only for SCO Unix.
T}:T{
T}
HAVE_BCOPY:T{
Whether the \f(CWbcopy\fR function exists.
T}:T{
\f(CWgrep bcopy /usr/include[/sys]/*.h\fR.
T}:T{
T}
HAVE_BZERO:T{
Whether the \f(CWbzero\fR function exists.
T}:T{
\f(CWgrep memmove /usr/include[/sys]/*.h\fR.
T}:T{
T}
HAVE_MEMMOVE:T{
Whether the \f(CWmemmove\fR function exists.
T}:T{
\f(CWgrep memmove /usr/include[/sys]/*.h\fR.
T}:T{
T}
HAVE_MKTEMP:T{
Whether the \f(CWmktemp\fR exists.
T}:T{
\f(CWgrep mktemp /usr/include[/sys]/*.h\fR.
T}:T{
T}
HAVE_OPENDIR:T{
Whether the \f(CWopendir\fR function exists.
T}:T{
\f(CWgrep opendir /usr/include[/sys]/*.h\fR.
T}:T{
T}
HAVE_PASTE:T{
Whether the \f(CW_Paste,\fR etc. macros exist.
T}:T{
Only for MS-DOS.
T}:T{
T}
HAVE_PID:T{
Whether the process id concept exists.
T}:T{
Everyone except MS-DOS.
T}:T{
T}
HAVE_PIPES:T{
Whether the pipe concept exists.
T}:T{
Everyone except MS-DOS.
T}:T{
T}
HAVE_PRAGMA:T{
Whether the preprocessor supports \f(CW#pragma interface\fR and
\f(CW#pragma implementation\fR.
T}:T{
Try to compile a program that uses them.
T}:T{
T}
HAVE_PROC:T{
Whether the process concept exists.
T}:T{
Everyone except MS-DOS.
T}:T{
T}
HAVE_PSEUDO_CONCURR:T{
Whether a pseudo concurrency exists (netbios)
T}:T{
Only for MS-DOS.
T}:T{
T}
HAVE_RANLIB:T{
Whether the 'ranlib' command should be applied to modified libraries.
T}:T{
\f(CWtype ranlib\fR.
.br
Only for Sun or Xenix.
T}:T{
T}
HAVE_REAL_LOCKS:T{
Whether locks work correctly (that locks get freed when a program terminates,
etc.).
T}:T{
Everyone except MS-DOS.
T}:T{
T}
HAVE_RENAME:T{
Whether the \f(CWrename\fR function exists.
T}:T{
\f(CWgrep rename /usr/include[/sys]/*.h\fR.
T}:T{
T}
HAVE_RESTARTABLE_SYSCALLS:T{
Whether some interrupted system calls (read and others) retry
automatically instead of returning with errno = EINTR.
T}:T{
Make a program or test whether \f(CWmenu\fR works correctly.
T}:T{
T}
HAVE_SAVEMEM:T{
Whether there is little memory available and we should try to
occupy as little as possible.
T}:T{
Only for MS-DOS.
T}:T{
T}
HAVE_SECURITY:T{
Whether Ideafix gets compiled with security checks (ixset, etc.).
T}:T{
Everyone except MS-DOS.
T}:T{
T}
HAVE_SEMAPHORES:T{
Whether the semaphore concept exists.
T}:T{
Everyone except MS-DOS.
T}:T{
T}
HAVE_SETSID:T{
Whether the \f(CWsetsid\fR function exists.
T}:T{
\f(CWgrep setsid /usr/include[/sys]/*.h\fR.
T}:T{
T}
HAVE_SETUID:T{
Whether \f(CWsetuid\fR function exists.
T}:T{
\f(CWgrep setuid /usr/include[/sys]/*.h\fR.
T}:T{
T}
.TE
.bp
.TS
center, box, tab(:);
cw(5c)|cw(10c)|cw(8c)|cw(1c)
l|l|l|l.
Variable:Description:How to obtain its value:Example
_
HAVE_SHORT_ENV:T{
Whether we have a short environment and therefore should provide the 'env' file.
T}:T{
Only for MS-DOS.
T}:T{
T}
HAVE_SHORT_FILE_NAMES:T{
Whether the operating system supports files names of up to 8 characters.
T}:T{
Only for MS-DOS.
T}:T{
T}
HAVE_SHORT_MEMSET:T{
Whether memset function receives a short parameter.
T}:T{
Only for Xenix.
T}:T{
T}
HAVE_SIGABRT:T{
Whether \f(CWSIGABRT\fR signal exists.
T}:T{
\f(CWgrep SIGABRT /usr/include[/sys]/*.h\fR.
T}:T{
T}
HAVE_SIGPWR:T{
Whether \f(CWSIGPWR\fR signal exists.
T}:T{
\f(CWgrep SIGPWR /usr/include[/sys]/*.h\fR.
T}:T{
T}
HAVE_SIGSET:T{
Whether \f(CWsigset\fR function exists.
T}:T{
\f(CWgrep sigset /usr/include[/sys]/*.h\fR.
T}:T{
T}
HAVE_SIGVEC:T{
Whether \f(CWsigvec\fR function exists.
T}:T{
\f(CWgrep sigvec /usr/include[/sys]/*.h\fR.
T}:T{
T}
HAVE_SOUND_BEEP:T{
Whether \f(CWsound_beep\fR function exists.
T}:T{
Only for MS-DOS (Borland).
T}:T{
T}
HAVE_STKLEN:T{
Whether \f(CW_stklen\fR variable exists.
T}:T{
Only for MS-DOS (Borland).
T}:T{
T}
HAVE_STRSTR:T{
Whether \f(CWstrstr\fR function exists.
T}:T{
\f(CWgrep strstr /usr/include[/sys]/*.h\fR.
T}:T{
T}
HAVE_STRTOK:T{
Whether \f(CWstrtok\fR function exists.
T}:T{
\f(CWgrep strtok /usr/include[/sys]/*.h\fR.
T}:T{
T}
HAVE_SWAP:T{
Whether the compiler supports the \f(CWsystem\fR function with swap feature (xspawn).
T}:T{
Only for MS-DOS (Borland with xspawn).
T}:T{
T}
HAVE_SYNC:T{
Whether \f(CWsync\fR function exists.
T}:T{
\f(CWgrep sync /usr/include[/sys]/*.h\fR.
T}:T{
T}
HAVE_SYSTTOLD_H:T{
Whether \f(CW<sys/ttold.h>\fR header exists.
T}:T{
\f(CWls /usr/include/sys/ttold.h\fR.
T}:T{
T}
HAVE_SYS_TIMEB_H:T{
Whether \f(CW<sys/timeb.h>\fR header exists.
T}:T{
\f(CWls /usr/include/sys/timeb.h\fR.
T}:T{
T}
HAVE_SYS_VFS_H:T{
Whether \f(CW<sys/vfs.h>\fR header exists.
T}:T{
\f(CWls /usr/include/sys/vfs.h\fR.
T}:T{
T}
HAVE_TERMIO_H:T{
Whether \f(CW<termio.h>\fR header exists.
T}:T{
\f(CWls /usr/include/termio.h\fR.
T}:T{
T}
HAVE_TEXT_FILES:T{
Whether we must differentiate text and binary files
(in \f(CWopen\fR, etc.).
T}:T{
Only for MS-DOS.
T}:T{
T}
HAVE_TIMEOFFSET:T{
Whether we must apply an offset to \f(CWtime\fR's return value (time).
T}:T{
Everyone except MS-DOS.
T}:T{
T}
HAVE_TIMEZONE:T{
Whether \f(CWtimezone\fR variable exists.
T}:T{
\f(CWgrep timezone /usr/include[/sys]/*.h\fR.
T}:T{
T}
.TE
.bp
.TS
center, box, tab(:);
cw(5c)|cw(10c)|cw(8c)|cw(1c)
l|l|l|l.
Variable:Description:How to obtain its value:Example
_
HAVE_TIME_H:T{
Whether \f(CW<time.h>\fR header exists.
T}:T{
\f(CWls /usr/include/time.h\fR.
T}:T{
T}
HAVE_TMPFILE:T{
Whether \f(CWtmpfile\fR function exists.
T}:T{
\f(CWgrep tmpfile /usr/include[/sys]/*.h\fR.
T}:T{
T}
HAVE_TM_ZONE:T{
Whether \f(CWstruct\fR tm_zone exists.
T}:T{
\f(CWgrep tm_zone /usr/include[/sys]/*.h\fR.
T}:T{
T}
HAVE_TTY:T{
Whether the operating system supports terminals.
T}:T{
Everyone except MS-DOS.
T}:T{
T}
HAVE_UMASK:T{
Whether \f(CWumask\fR function exists.
T}:T{
\f(CWgrep umask /usr/include[/sys]/*.h\fR.
T}:T{
T}
HAVE_UNISTD_H:T{
Whether \f(CW<unistd.h>\fR header exists.
T}:T{
\f(CWls /usr/include/unistd.h\fR.
T}:T{
T}
HAVE_USERS:T{
Whether the operating system supports users.
T}:T{
Everyone except MS-DOS.
T}:T{
T}
HAVE_XCC:T{
Whether we use xcc instead of cc to compile programs.
T}:T{
Only for Xenix.
T}:T{
T}
HAVE_ZPM:T{
Whether the compiler uses the extended memory manager ZPM.
T}:T{
Only for MS-DOS (Zortech in Z model).
T}:T{
T}
LOG_DBG:T{
Whether we have to debug the transaction log.
T}:T{
Only for debugging.
T}:T{
T}
NEED_AR_PORTAR:T{
Whether we have to define \f(CWPORTAR\fR variable before including \f(CW<ar.h>\fR
header.
T}:T{
Everyone except Xenix 286.
T}:T{
T}
NEED_CLOSE_FOR_SYNC:T{
Whether we have to close a file in order to get it flushed to disk.
T}:T{
Only for MS-DOS.
T}:T{
T}
NEED_MEM_DEBUG:T{
Whether we have to debug the dynamic memory manager.
T}:T{
Only for MS-DOS.
T}:T{
T}
NEED_NETBIOS_FOPEN:T{
Whether it is necesary to use our \f(CWfopen\fR function so that
the \f(CWlock\fR function works correctly.
T}:T{
Only for MS-DOS (Borland).
T}:T{
T}
NO_ADVISORY_LOCK:T{
Whether the operating system has advisory locks (locks that don't block us
when reading locked records without locking).
T}:T{
Only for MS-DOS.
T}:T{
T}
NO_EXTERN_CONST:T{
Whether there are problems when we declare static variables (C++) like
\f(CWextern const\fR (not defined symbols).
T}:T{
Only for HP-UX.
T}:T{
T}
NO_MKRMDIR:T{
Whether \f(CWmkdir\fR and \f(CWrmdir\fR functions exist.
T}:T{
\f(CWegrep "mkdir|rmdir" /usr/include[/sys]/*.h\fR.
T}:T{
T}
NO_SERVICES:T{
Whether we must not compile Ideafix services (F3).
T}:T{
Only for MS-DOS (when there is little memory available).
T}:T{
T}
OPEN_CANT_CREATE:T{
Whether \f(CWopen\fR function can create the file when it doesn't exist (some
old unix version allow this, only with \f(CWcreat\fR system call).
T}:T{
\f(CWgrep open /usr/include[/sys]/*.h\fR.
.br
and see if it has the creation flag.
T}:T{
T}
SPANISH:T{
Whether we use spanish language (for functions like \f(CWstr_cmp)\fR.
T}:T{
All.
T}:T{
T}
.TE
.bp
.TS
center, box, tab(:);
cw(5c)|cw(10c)|cw(8c)|cw(1c)
l|l|l|l.
Variable:Description:How to obtain its value:Example
_
STATFS_HAS_LEN:T{
Whether \f(CWstatfs\fR function has third and fourth parameter.
T}:T{
\f(CWgrep statfs /usr/include[/sys]/*.h\fR.
T}:T{
T}
SYSDIR:T{
Whether \f(CW<sys/dir.h>\fR header exists.
T}:T{
\f(CWls /usr/include/sys/dir.h\fR.
T}:T{
T}
SYSNDIR:T{
Whether \f(CW<sys/ndir.h>\fR header exists.
T}:T{
\f(CWls /usr/include/sys/ndir.h\fR.
T}:T{
T}
USE_FGETC:T{
Whether we can use \f(CWfgetc\fR function to read caraters from the screen.
T}:T{
Only for MS-DOS.
T}:T{
T}
USG:T{
Whether the operating system is System V.
T}:T{
See if \f(CW<stdio.h>\fR header file defines \f(CWL_ctermid\fR.
T}:T{
T}
_G_USE_PROTOS:T{
Whether we must use prototypes in header files.
T}:T{
It must be turned on always (it is used only in gcc headers files).
T}:T{
T}
AR_MOD_SEP:T{
This character marks the end of a module's name in an \f(CWar\fR file.
T}:T{
Execute \f(CWstrings x.a\fR and see what character follows each module's name.
It is generally either \f(CW'/'\fR or \f(CW' '\fR.
T}:T{
\f(CW'/'\fR
T}
DEFAULT_PATH:T{
This is the default path that we assume if we don't find the PATH
environment variable.
T}:T{
Use ix386.h DEFAULT_PATH.
T}:T{
T}
DEFAULT_SHELL:T{
This is the shell that we assume if we don't find the SHELL
environment variable.
T}:T{
On unix: \f(CW/bin/sh\fR.
T}:T{
\f(CW"/bin/sh"\fR
T}
MAIL_HOME:T{
This is the home directory where we find the mailboxes.
T}:T{
\f(CWman mail\fR.
T}:T{
\f(CW"/usr/mail"\fR
T}
NEW_LINE:T{
This are the end of line character(s). 
T}:T{
\f(CW"\n"\fR on Unix or \f(CW"\r\n"\fR on MS-DOS.
T}:T{
\f(CW"\n"\fR
T}
PATH_SEP:T{
This is the character used to separate the paths in the \f(CWPATH\fR
environment variable.
T}:T{
\f(CW":"\fR on Unix or \f(CW";"\fR on MS-DOS.
T}:T{
\f(CW":"\fR
T}
PATH_SLASH:T{
This is the character used to separate the directories in a path.
T}:T{
\f(CW"/"\fR on Unix or \f(CW"\e"\fR on MS-DOS.
T}:T{
\f(CW"/"\fR
T}
PATH_SLASH_UNIV:T{
This is the universal character used to separate the directories in 
a path.
T}:T{
\f(CW"/"\fR always.
T}:T{
\f(CW"/"\fR
T}
VEC_DEL_SIZE:T{
This macro must be defined so as to leave it's argument untouched
or map it to nothing depending on whether the C++ compiler considers
the size in the 'delete []' statement obsolete or it needs it.
T}:T{
Leave it removing it's argument and see if some warnings appear.
T}:T{
T}
quote:T{
It must be defined so as to put quotes around its argument.
T}:T{
Make a program and try it.
T}:T{
\f(CW#a\fR
T}
SigHandlerT:T{
The type of the signal handlers.
T}:T{
\f(CWvi /usr/include[/sys]/signal.h\fR.
T}:T{
T}
HAVE_BSDTTY_H:T{
Whether the \f(CW<bsdtty.h>\fR header exists.
T}:T{
\f(CWls /usr/include/bsdtty.h\fR.
T}:T{
T}
HAVE_SGR:T{
Whether \f(CWtparm\fR function exists for set \f(CWsgr\fR capability.
T}:T{
\f(CWgrep tparm /usr/include[/sys]/*.h\fR.
T}:T{
T}
PSUID_CMD:T{
The command to use to obtain the user id of the specified process id.
It should print in the second line the information for the process.
T}:T{
\f(CWman ps\fR.
T}:T{
\f(CW"ps -lp%d"\fR
T}
PSUID_POS:T{
The position of the UID within the second line of the output of
the command specified by PSUID_CMD.
T}:T{
\f(CWman ps\fR.
T}:T{
\f(CW2\fR
T}
HAVE_GETGROUPS:T{
Whether \f(CWgetgroups\fR function exists (to obtain supplementary
groups when users are allowed to belong to more than one group)
Generally BSD systems should have this option.
T}:T{
\f(CWgrep getgroups /usr/include[/sys]/*.h\fR.
T}:T{
T}
HAVE_GETPWANAM:T{
Whether \f(CWgetpwanam\fR function exists (to obtain a user password
when not found in the \f(CW/etc/passwd\fR file).
T}:T{
\f(CWgrep getpwanam /usr/include[/sys]/*.h\fR
T}:T{
T}
HAVE_GETSPNAM:T{
Whether \f(CWgetspnam\fR function exists (to obtain a user password
when not found in the \f(CW/etc/passwd\fR file).
T}:T{
\f(CWgrep getspnam /usr/include[/sys]/*.h\fR
T}:T{
T}
HAVE_GETUSERPW:T{
Whether \f(CWgetuserpw\fR function exists (to obtain a user password
when not found in the \f(CW/etc/passwd\fR file).
T}:T{
\f(CWgrep getuserpw /usr/include[/sys]/*.h\fR
T}:T{
T}
HAVE_ETC_SHADOW:T{
Whether passwords not kept in file \f(CW/etc/passwd\fR are kept in
\f(CW/etc/shadow\fR with the format \f(CWlogin:cryptedpasswd:...\fR
T}:T{
\f(CWpg /etc/shadow\fR
T}:T{
T}
.TE
