/***********************************************************************
* Copyright (c) 1991 InterSoft Co.  All Rights Reserved
* THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF InterSoft Co.
* The copyright notice above does not evidence any
* actual or intended publication of such source code.
*
* $Id: sun4.h,v 1.42 1996/08/22 19:41:29 eduardoc Exp $
*
* DESCRIPTION
* Operating system dependent defines
*********************************************************************/

/*
	Comments on the port

	Use gnu's stdarg.h
*/

#ifndef SUN4_H
#define SUN4_H

#define _OS_	"SunOS"
#define _OSVER_	"4.x"
#define _OS_SHORT_NAME_	"sun4"

#if defined(ACADEMIC_VERSION)
#define EXTRA_BANNER_INFO   " (Academic-Beta) "
#elif defined (BETA_VERSION)
#   define  EXTRA_BANNER_INFO   " (Beta) " 
#else
#       define  EXTRA_BANNER_INFO   ""
#endif


/* Typedefs */
typedef long Int;
typedef Int unsigned int SizeT;
typedef unsigned short UidT;
typedef unsigned short GidT;
typedef int OffT;
typedef int PidT;
typedef Int KeyT;
typedef unsigned short ModeT;
typedef union u_SemunT {
	int val;
	struct semid_ds *buf;
	unsigned short *array;
} SemunT;

/* Insert here locally needed defines */
#undef _ALL_SOURCE
#undef _ANSI_C_SOURCE
#undef _XOPEN_SOURCE
#define SUN_4	1

#ifdef __cplusplus
extern "C" {
#endif

typedef void (*SIGF_FP )(...);
typedef void (*SigHandlerT)(int, SIGF_FP);

#ifdef __cplusplus
}
#endif

/* Compiler dependant capabilities */

/* Non compiler dependant capabilities */
#undef BAD_STRNCPY
#undef CANT_DEL_WHOLE_FILE
#undef CHKSUM
#undef DEBUG_LOCK
#define DIRENT 					1
#undef END_OF_TEXT_FILE_CHAR
#undef ENOTDIR_IS_ENOENT
#undef EXEC_TAKES_TIME
#undef HAVE_64KLIMIT
#define HAVE_ABORT				1
#define HAVE_AF_UNIX			1
#undef HAVE_AF_UNIX_LEN
#undef HAVE_ALTZONE
#define HAVE_AR					1
#undef HAVE_AR_AIAMAG
#undef HAVE_AR_FL_HDR
#undef HAVE_AR_NAMLEN
#undef HAVE_AR_NUMERIC
#undef HAVE_ASYNC_IO
#undef HAVE_BAD_CVT
#define HAVE_BCOPY				1
#undef HAVE_BSDTTY_H
#define HAVE_BZERO				1
#undef HAVE_CLOSEDIR_BUG
#undef HAVE_COMMAND_COM
#define HAVE_EMULTIHOP			1
#define HAVE_ENOLINK			1
#undef HAVE_ERRLIST
#undef HAVE_ETC_SHADOW
#define HAVE_FCNTL				1
#define HAVE_FIONREAD			1
#undef HAVE_FIORDCHK
#undef HAVE_FREEMEM
#define HAVE_FSYNC				1
#define HAVE_FULL_SIGNALS		1
#define HAVE_F_SETOWN			1
#undef HAVE_GETDFREE
#define HAVE_GETGROUPS			1
#define HAVE_GETPWANAM			1
#undef HAVE_GETSPNAM
#undef HAVE_HEAP_WALK
#define HAVE_INETD				1
#define HAVE_IPC				1
#define HAVE_JOB_CONTROL		1
#define HAVE_LOCALTIME			1
#define HAVE_LOCKF				1
#undef HAVE_LOCKING
#define HAVE_LONG_ARGV			1
#define HAVE_LTCHARS			1
#define HAVE_MAIL				1
#undef HAVE_MMDF			  
#define HAVE_MEMMOVE			1
#define HAVE_MKTEMP				1
#define	HAVE_NOPROBLEMSCLOSING012	1
#undef HAVE_OP_CONST_VOID_PTR
#define HAVE_O_SYNC				1
#define HAVE_OPENDIR			1
#undef HAVE_PASTE
#define HAVE_PW_COMMENT			1
#define HAVE_PID				1
#define HAVE_PIPES				1
#define HAVE_PROC				1
#undef HAVE_PROC_DIR
#undef HAVE_PSEUDO_CONCURR
#define HAVE_RANLIB				1
#define HAVE_REAL_LOCKS			1
#undef HAVE_RENAME
#define HAVE_RESTARTABLE_SYSCALLS	1
#undef HAVE_SAVEMEM
#define HAVE_SECURITY			1
#define HAVE_SECURITY_CHECK		1
#define HAVE_SEMAPHORES			1
#define HAVE_SETRLIMIT			1
#define HAVE_SETSID				1
#define HAVE_SETUID				1
#undef HAVE_SGR
#undef HAVE_SHORT_ENV
#undef HAVE_SHORT_FILE_NAMES
#undef HAVE_SHORT_MEMSET
#define HAVE_SIGABRT			1
#undef HAVE_SIGACTION
#undef HAVE_SIGPWR
#undef HAVE_SIGSET
#define HAVE_SIGVEC				1
#define HAVE_SIGEMT				1
#undef HAVE_SIGUNUSED
#define HAVE_SIGSYS				1
#undef HAVE_SOUND_BEEP
#undef HAVE_STKLEN
#define HAVE_STRSTR				1
#define HAVE_STRTOK				1
#undef HAVE_SWAP
#define HAVE_SYNC				1
#define HAVE_SYSTTOLD_H			1
#undef HAVE_SYS_TIMEB_H
#define HAVE_SYS_VFS_H			1
#define HAVE_TERMIO_H			1
#undef HAVE_TERMIOS_H
#undef HAVE_TEXT_FILES
#define HAVE_TIMEOFFSET			1
#undef HAVE_TIMEZONE
#define HAVE_TIME_H				1
#define HAVE_TMPFILE			1
#undef HAVE_TM_ZONE
#undef HAVE_TRUNCATE
#define HAVE_TTY				1
#define HAVE_UMASK				1
#define HAVE_UNISTD_H			1
#undef HAVE_GETUSERPW
#define HAVE_USERS				1
#define HAVE_UTIME_H			1
#undef	HAVE_USEUSENUM
#undef HAVE_WAITPID
#undef HAVE_XCC
#undef HAVE_ZPM
#undef LOG_DBG
#define NEED_AR_PORTAR			1
#undef NEED_CLOSE_FOR_SYNC
#undef NEED_MEM_DEBUG
#undef NEED_NETBIOS_FOPEN
#undef NO_ADVISORY_LOCK
#undef NO_EXTERN_CONST
#undef NO_MKRMDIR
#undef NO_SERVICES
#undef OPEN_CANT_CREATE
#define SPANISH					1
#undef STATFS_HAS_LEN
#define SYSDIR					1
#undef SYSNDIR
#undef USE_FGETC
#undef USG
#define _G_USE_PROTOS			1
#undef HAVE_SARWITHSWAP
#define HAVE_SYSLOG				1
#undef HAVE_VARARGS_BUG
#undef HAVE_GRAPHICS
#define HAVE_MMF				1
#define HAVE_USEFULFTRUNCATE	1

/* Compiler dependant parameter types */

#undef HAVE_PRIV_DERIV_BUG
#define HAVE_STD_TCP_HEADERS	1
#define HAVE_SYS_UTSNAME_H		1
#undef HAVE_GENERIC_HPP
#undef HAVE_CTRLC
#undef HAVE_DISKFREESPACE
#undef HAVE_DSO
#undef HAVE_STRICT_CHECK
#undef HAVE_FIND
#undef HAVE_DOS_H
#undef DONT_ALLOW_REDEF
#undef HAVE_LOCK_CHAIN
#undef HAVE_CDINPATH
#undef TIME_FROM68
#undef HAVE_PRAGMA_ALIGN
#define _far
#define stddbg stderr
#undef NEED_WCHAR_T
#undef NO_CONTROL_192_255
#undef _16BIT
#undef IDEAWIN

/* Non compiler dependant parameter types */
#define ABORTRETTYPE			void
#define ALLOCRETTYPE			void *
#define BCOPYPARAM3TYPE			int
#define	BZEROPARAM2TYPE			int
#define BINDPARAM2TYPE          const void *
#define CFTIMEPARAM2TYPE		char *
#define CHOWNPARAM2TYPE 		GidT
#define CHOWNPARAM3TYPE 		GidT
#define CONNECTPARAM1TYPE		int
#define CONNECTPARAM2TYPE		struct sockaddr *
#define EXECVPPARAM1TYPE		const char * 
#define EXECVPPARAM2TYPE		char * const *
#define FCNTLPARAM3TYPE			...

#define FTELLPARAM1TYPE			FILE *
#define FPUTCPARAM1TYPE			int
#define FREADPARAM1TYPE			void *
#define FREADPARAM2				char *
#define FWRITEPARAM1TYPE		const void *
#define FWRITEPARAM2			char const *
#define GCVTPARAM2TYPE          int    
#define GETCWDPARAM1TYPE		char *
#define GETCWDPARAM2TYPE 		SizeT
#define GETGRGIDPARAMTYPE		GidT
#define GETHOSTBNPARAMTYPE		char *
#define GETHOSTNPARAM2TYPE		int
#define GETPEERNAMEPARAM2TYPE	void *
#define GETPEERNAMEPARAM3TYPE	int *
#define GETPWUIDPARAMTYPE		UidT
#define GETSERVBNPARAM1TYPE		char *
#define GETSERVBNPARAM2TYPE		char *
#define MKDIRPARAM1TYPE			char const *
#define MSGCTLPARAM3TYPE		struct msqid_ds *
#define MSGRCVPARAM2TYPE		struct msgbuf *
#define MSGRCVPARAM3TYPE		int
#define MSGSNDPARAM2TYPE		struct msgbuf *
#define MSGSNDPARAM3TYPE		int
#define MUNMAPPARM1TYPE			void *
#define	MUNMAPPARAM2TYPE		size_t
#define OPENPARAM3TYPE			...
#define OPENRETTYPE				SizeT
#define PAUSERETTYPE			int 
#define POPENPARAMTYPE			const char *
#define PUTENVPARAMTYPE			char *
#define QSORTPARAM2TYPE			SizeT
#define QSORTPARAM3TYPE			SizeT
#define QSORTRETTYPE			int
#define READPARAM3TYPE			SizeT
#define READRETTYPE				int
#define RETSIGTYPE				void
#define SBRKPARAMTYPE 			unsigned
#define SBRKRETTYPE 			char *
/* #define SEMCTLPARAM4TYPE		SemunT */
#define SEMOPPARAM3TYPE			int
#define SLEEPPARAMTYPE			unsigned
#define SLEEPRETTYPE			unsigned
#define SPRINTFRETTYPE			char *
#define SRANDRETTYPE			int
#define	STRDUPPARAMTYPE			const char *
#define STATFSPARAM1TYPE		const char *
#define FCNTLPARAM3TYPE			...
#define TEMPNAMPARAM1TYPE		const char *
#define TEMPNAMPARAM2TYPE		const char *
#define WRITEPARAM3TYPE			SizeT
#define WRITERETTYPE			int
#define _FLSBUFPARAM1TYPE		unsigned int
#define POLLPARAM1TYPE 			struct pollfd *
#define POLLPARAM2TYPE			unsigned long
#define POLLPARAM3TYPE			int
#define FCVTRETTYPE 			char const *
#define FCVTPARAM2TYPE	 		int
#define BITFIELDSTYPE			unsigned long
#define FDOPENPARAM2TYPE		char const *
#define CONNECTRETTYPE			int
#define SOCKETRETTYPE			int
#define EXITRETTYPE				void
#define SYNCRETTYPE				void
#define WINDOWTYPE				int
#define ACCEPTPARAM2TYPE		struct sockaddr *
#define	WAITPARAMTYPE			int *

/* Miscelaneous */
#define PSUID_CMD				"ps -l%ld"
#define PSUID_POS				1
#define MAX_WINDOWS				512
#define FM_MAX_OPEN				128
#define AR_MOD_SEP				' '
#define	STDERR					stderr
#define DEFAULT_PATH			":/bin:/usr/ideafix/bin"
#define DEFAULT_SHELL			"/bin/sh"
#define MAIL_HOME				"/usr/mail"
#define NEW_LINE				"\n"
#define PATH_SEP				":"
#define PATH_SLASH				"/"
#define PATH_SLASH_UNIV			"/"
#define VEC_DEL_SIZE(a)
#undef VOLUME_LETTER_SEP
#define quote(a)				#a
#define COD_ZERO 				0x80

/* Cfix stuff */
#define CFIX_HAVE_SHLIB		1
#define CFIX_HAVE_ESS_SHLIB 1
#undef CFIX_HAVE_OVERLAYS
#undef CFIX_NEED_EXE_EXT
#undef CFIX_NEED_MINUSYP
#undef CFIX_NEED_QPATH
#define CFIX_C_EXT			".c"
#define CFIX_EXE_EXT		".exe"
#define CFIX_OBJ_EXT		".o"
#define CFIX_LIB_EXT		".a"
#define CFIX_COMPILER		"cc -c "
#define CFIX_OPTIM			" -O "
#define CFIX_DEBUG			" -g "
#define CFIX_LINK			"cc "
#define CFIX_LIBDIRSFLAG	" -L"
#define CFIX_LIBDIR			"/lib "
#define CFIX_SHLIBDIR		"/SH421"
#define CFIX_LINKSTRIP		" -s "
#define CFIX_LINKDEBUG		" -g "
#define CFIX_OUTFILE		"-o "
#define CFIX_IXDBLIB		" -lixdb "
#define CFIX_ESDBLIB		" -lesdb "
#define CFIX_SCKTLIB		""
#define CFIX_IDEALIB		" -lidea "
#define CFIX_IXDBSHLIB		" -lixdb "
#define CFIX_ESDBSHLIB		" -lesdb "
#define CFIX_SCKTSHLIB		""
#define CFIX_IDEASHLIB		" -lidea -lc "
#define CFIX_MAX_MODS		100
#define CFIX_INCLUDE 		"/include"

#endif
