/***********************************************************************
* Copyright (c) 1991 InterSoft Co.  All Rights Reserved
* THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF InterSoft Co.
* The copyright notice above does not evidence any
* actual or intended publication of such source code.
*
* $Id: ultrix.h,v 1.5 1996/08/22 19:42:33 eduardoc Exp $
*
* DESCRIPTION
* Operating system dependent defines
*********************************************************************/
#ifndef ULTRIX_H
#define ULTRIX_H

#define _OS_	"Ultrix"
#define _OSVER_	"4.3"

#include <sys/types.h>
/* Typedefs */
typedef long Int;
typedef unsigned int SizeT;
typedef short UidT;
typedef short GidT;
typedef int PidT;
typedef Int KeyT;
typedef unsigned short ModeT;
typedef union u_SemunT {
	int val;
	struct semid_ds *buf;
	unsigned short *array;
} SemunT;

#undef IDEAWIN
/* Insert here locally needed defines */
#ifndef __STDC__
#define __STDC__	1
#endif
#undef _ALL_SOURCE
#undef _ANSI_C_SOURCE
#undef _XOPEN_SOURCE
#undef SUN_4
#ifdef JAVIER
typedef void (*SIGF_FP )(...);
typedef void (*SigHandlerT)(int, SIGF_FP);
#endif
typedef void (*SigHandlerT)(int);

/* Compiler dependant capabilities */

/* Non compiler dependant capabilities */
#undef BAD_STRNCPY
#undef CANT_DEL_WHOLE_FILE
#undef CHKSUM
#undef DEBUG_LOCK
#define DIRENT 					1
#undef END_OF_TEXT_FILE_CHAR
#undef ENOTDIR_IS_ENOENT
#undef EXEC_TAKES_TIME
#undef HAVE_64KLIMIT
#define HAVE_ABORT				1
#define HAVE_AF_UNIX			1
#undef HAVE_AF_UNIX_LEN
#undef HAVE_ALTZONE
#undef HAVE_AR_AIAMAG
#undef HAVE_AR_FL_HDR
#undef HAVE_AR_NAMLEN
#undef HAVE_AR_NUMERIC
#define HAVE_AR					1
#define HAVE_BCOPY				1
#undef HAVE_BSDTTY_H
#undef HAVE_COMMAND_COM
#undef HAVE_EMULTIHOP
#undef HAVE_ENOLINK
#undef HAVE_ERRLIST
#define HAVE_FCNTL				1
#define HAVE_FIONREAD			1
#undef HAVE_FIORDCHK
#undef HAVE_FREEMEM
#define HAVE_FSYNC				1
#define HAVE_FULL_SIGNALS		1
#define HAVE_F_SETOWN			1
#undef HAVE_GETDFREE
#define HAVE_GETGROUPS			1
#undef HAVE_HEAP_WALK
#define HAVE_IPC				1
#define HAVE_INETD				1
#define HAVE_JOB_CONTROL		1
#define HAVE_LOCALTIME			1
#define HAVE_LOCKF				1
#define	HAVE_SYSLOG				1
#undef HAVE_LOCKING
#define HAVE_LONG_ARGV			1
#define HAVE_LTCHARS			1
#define HAVE_MAIL				1
#undef HAVE_MMDF			  
#define HAVE_MEMMOVE			1
#define HAVE_MKTEMP				1
#define HAVE_O_SYNC				1
#define HAVE_OPENDIR			1
#undef HAVE_PASTE
#define HAVE_PW_COMMENT			1
#define HAVE_PID				1
#define HAVE_PIPES				1
#undef HAVE_PRAGMA
#define HAVE_PROC				1
#undef HAVE_PSEUDO_CONCURR
#define HAVE_RANLIB				1
#define HAVE_REAL_LOCKS			1
#undef HAVE_RENAME
#define HAVE_RESTARTABLE_SYSCALLS	1
#undef HAVE_SAVEMEM
#define HAVE_SECURITY			1
#define HAVE_SECURITY_CHECK		1
#define HAVE_SEMAPHORES			1
#define HAVE_SETSID				1
#define HAVE_SETUID				1
#undef HAVE_SGR
#undef HAVE_SHORT_ENV
#undef HAVE_SHORT_FILE_NAMES
#undef HAVE_SHORT_MEMSET
#define HAVE_SIGABRT			1
#undef HAVE_SIGPWR
#undef HAVE_SIGSET
#undef HAVE_SIGVEC
#undef HAVE_SOUND_BEEP
#undef HAVE_STKLEN
#define HAVE_STRSTR				1
#define HAVE_STRTOK				1
#undef HAVE_SWAP
#define HAVE_SYNC				1
#undef HAVE_SYSTTOLD_H
#undef HAVE_SYS_TIMEB_H
#define HAVE_SYS_VFS_H			1
#define HAVE_TERMIO_H			1
#undef HAVE_TERMIOS_H
#undef HAVE_TEXT_FILES
#define HAVE_TIMEOFFSET			1
#undef HAVE_TIMEZONE
#define HAVE_TIME_H				1
#define HAVE_TMPFILE			1
#undef HAVE_TM_ZONE
#define HAVE_TTY				1
#undef HAVE_UMASK				1
#define HAVE_UNISTD_H			1
#define HAVE_USERS				1
#define HAVE_UTIME_H			1
#undef HAVE_XCC
#undef HAVE_ZPM
#undef LOG_DBG
#define NEED_AR_PORTAR			1
#undef NEED_CLOSE_FOR_SYNC
#undef NEED_MEM_DEBUG
#undef NEED_NETBIOS_FOPEN
#undef NO_ADVISORY_LOCK
#undef NO_EXTERN_CONST
#undef NO_MKRMDIR
#undef NO_SERVICES
#undef OPEN_CANT_CREATE
#define SPANISH					1
#undef STATFS_HAS_LEN
#define SYSDIR					1
#undef SYSNDIR
#undef USE_FGETC
#undef USG
#define _G_USE_PROTOS			1
#define _OS_SHORT_NAME_		"ultrix4.3"

#define HAVE_SETRLIMIT			1
#define HAVE_NOPROBLEMSCLOSING012	1
/* Compiler dependant parameter types */

#undef HAVE_PRIV_DERIV_BUG
#define HAVE_STD_TCP_HEADERS	1
#define HAVE_SYS_UTSNAME_H		1
#undef HAVE_GENERIC_HPP
#undef HAVE_CTRLC
#undef HAVE_DISKFREESPACE
#undef HAVE_STRICT_CHECK
#undef HAVE_FIND
#undef HAVE_DOS_H
#undef DONT_ALLOW_REDEF
#undef HAVE_LOCK_CHAIN
#undef HAVE_CDINPATH
#undef TIME_FROM68
#undef _16BIT
#define _far

/* Non compiler dependant parameter types */
#define ABORTRETTYPE			void
#define ACCEPTPARAM2TYPE		struct sockaddr *
#define ACCEPTPARAM1TYPE		struct sockaddr *
#define ALLOCRETTYPE			void *
#define BCOPYPARAM3TYPE			int
#define BINDPARAM2TYPE			struct sockaddr *
#define BITFIELDSTYPE			unsigned int
#define CHOWNPARAM2TYPE 		GidT
#define CHOWNPARAM3TYPE 		GidT
#define CONNECTRETTYPE			int
#define CONNECTPARAM1TYPE		int 
#define CONNECTPARAM2TYPE		struct sockaddr *
#define EXECVPPARAM1TYPE		char const * 
#define EXECVPPARAM2TYPE		char *const *
#define EXITRETTYPE				void
#define FCNTLPARAM3TYPE			...
#define FCVTPARAM2TYPE			int
#define FDOPENPARAM2TYPE		char *
#define FPUTCPARAM1TYPE			int
#define FREADPARAM1TYPE			void *
#define FTELLRETTYPE			long
#define FTELLPARAM1TYPE			FILE *
#define FWRITEPARAM1TYPE		const void *
#define GCVTPARAM2TYPE			int
#define GETCWDPARAM1TYPE		char *
#define GETCWDPARAM2TYPE 		unsigned int
#define GETGRGIDPARAMTYPE		GidT
#define GETHOSTBNPARAMTYPE		char *
#define GETHOSTNPARAM2TYPE		int
#define GETPEERNAMEPARAM2TYPE	struct sockaddr *
#define GETPWUIDPARAMTYPE		UidT
#define GETSERVBNPARAM1TYPE		char *
#define GETSERVBNPARAM2TYPE		char *
#define LSEEKRETTYPE			int
#define LSEEKPARAM2TYPE			int
#define MKDIRPARAM1TYPE			char const *
#define MSGCTLPARAM3TYPE		struct msqid_ds *
#define MSGRCVPARAM2TYPE		struct msgbuf *
#define MSGRCVPARAM3TYPE		int
#define MSGSNDPARAM2TYPE		struct msgbuf *
#define MSGSNDPARAM3TYPE		int
#define OPENPARAM3TYPE			...
#define PAUSERETTYPE			int 
#define POPENPARAMTYPE			const char *
#define PUTENVPARAMTYPE			char *
#define QSORTRETTYPE			void
#define QSORTPARAM2TYPE			size_t
#define QSORTPARAM3TYPE			size_t
#define READPARAM3TYPE			unsigned
#define READRETTYPE				int
#define RETSIGTYPE				void
#define SBRKRETTYPE 			char *
#define SBRKPARAMTYPE			int
#define SPRINTFRETTYPE			int
#define SEMCTLPARAM4TYPE		SemunT
#define SEMOPPARAM3TYPE			int
#define SRANDRETTYPE			void
#define SYNCRETTYPE				void
#define SLEEPPARAMTYPE			unsigned
#define SLEEPRETTYPE			unsigned
#define SOCKETRETTYPE			int
#define STRDUPPARAMTYPE			char *
#define TEMPNAMPARAM1TYPE		char const *
#define TEMPNAMPARAM2TYPE		char const *
#define TIMERETTYPE				int
#define TIMEPARAM1TYPE			int *
#define UMASKRETTYPE			short unsigned int
#define WINDOWTYPE				int
#define WRITEPARAM3TYPE			unsigned
#define WRITERETTYPE			int
#define _FLSBUFPARAM1TYPE		unsigned char
#define POLLPARAM1TYPE 			struct pollfd *
#define POLLPARAM2TYPE			unsigned long
#define POLLPARAM3TYPE			int
#define FCVTRETTYPE 			char const *
#define	WAITPARAMTYPE			int *

/* Miscelaneous */
#define FM_MAX_OPEN				128
#define AR_MOD_SEP				'/'
#define DEFAULT_PATH			":/bin:/usr/ideafix/bin"
#define DEFAULT_SHELL			"/bin/sh"
#define MAIL_HOME				"/usr/mail"
#define NEW_LINE				"\n"
#define PATH_SEP				":"
#define PATH_SLASH				"/"
#define PATH_SLASH_UNIV			"/"
#define VEC_DEL_SIZE(a)
#undef VOLUME_LETTER_SEP
#define quote(a)				#a
#define PSUID_CMD				"ps -l%ld"
#define PSUID_POS				1
#define MAX_WINDOWS				512
#define	STDERR					stderr
#define COD_ZERO 				0x80

/* Cfix stuff */
/* Antes   #define CFIX_HAVE_SHLIB		0 */
#undef CFIX_HAVE_SHLIB
#undef CFIX_HAVE_ESS_SHLIB
#undef CFIX_HAVE_OVERLAYS
#undef CFIX_NEED_EXE_EXT
#undef CFIX_NEED_MINUSYP
#undef CFIX_NEED_QPATH
#define CFIX_C_EXT			".c"
#define CFIX_EXE_EXT		".exe"
#define CFIX_OBJ_EXT		".o"
#define CFIX_LIB_EXT		".a"
#define CFIX_COMPILER		"gcc -c "
#define CFIX_OPTIM			" -O "
#define CFIX_DEBUG			" -g "
#define CFIX_LINK			"gcc "
#define CFIX_LIBDIRSFLAG	" -L"
#define CFIX_LIBDIR			"/lib "
#define CFIX_LINKSTRIP		" -s "
#define CFIX_LINKDEBUG		" -g "
#define CFIX_OUTFILE		"-o "
#define CFIX_IXDBLIB		" -lixdb "
#define CFIX_ESDBLIB		" -lesdb "
#define CFIX_SCKTLIB		""
#define CFIX_IDEALIB		" -lidea "
#define CFIX_IXDBSHLIB		" -lixdb "
#define CFIX_ESDBSHLIB		" -lesdb "
#define CFIX_SCKTSHLIB		""
#define CFIX_IDEASHLIB		" -lidea -lc "
#define CFIX_MAX_MODS		100
#define CFIX_INCLUDE 		"/include"


#endif
