/***********************************************************************
* Copyright (c) 1991 InterSoft Co.  All Rights Reserved
* THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF InterSoft Co.
* The copyright notice above does not evidence any
* actual or intended publication of such source code.
*
* osdep.h,v 1.1.1.1 1996/04/16 18:51:31 gustavof Exp
*
* DESCRIPTION
* Operating system dependant defines
*********************************************************************/

#ifndef OSDEP_H
#define OSDEP_H

#ifdef DEBUG
#	define	ISDEBUG	1
#endif

#ifdef ISDEBUG
#	define TRACE_MEMORY	1
#endif

/*
	Defines that we expect the compiler to define for the following
	operating systems are...

	AIX 3						_AIX
	A/UX 3 (Apple Unix)			AUX
	SunOS						sun
	Silicon Graphics Indigo		mips && sgi
	HP9000/800 w/HPUX			hppa && hpux
	Sco Unix					M_UNIX
	Borland C++/DOS				MSDOS && !__ZTC__
	Symantec C++/DOS			MSDOS && __ZTC__ && __SC__
	Zortech C++/DOS				MSDOS && __ZTC__ && !__SC__
	Symantec C++/Windows		MSDOS && __ZTC__ && __SC__ && _WINDOWS
	Symantec C++/Windows 32		MSDOS && __ZTC__ && __SC__ && _WINDOWS && __NT__
	Xenix 286					M_XENIX && CPU_I286
	Xenix 386					M_XENIX && CPU_I386
	Irix 4						mips && sgi && _IRIX4
	Irix 5						mips && sgi && !_IRIX4
	Linux						linux
	Interactive 386				<default>
*/

#ifdef __GNUC__

/* const & noreturn */
#if __GNUC__ < 2 || (__GNUC__ == 2 && __GNUC_MINOR__ < 5) || (defined(__cplusplus) && __GNUC__ == 2 && __GNUC_MINOR__ <= 5)
  /* Old GCC way. */
#	define CONSTVALUE_FUNC	__const__
#	define CONSTVALUE_FUNC_2
#	define NORETURN_FUNC	__volatile__
#	define NORETURN_FUNC_2
#else
  /* New GCC way. */
#	define	CONSTVALUE_FUNC
#	if defined(const) || !defined(__STDC__)
#		define	CONSTVALUE_FUNC_2	/* We don't want empty __attribute__ (()). */
#	else
#		define	CONSTVALUE_FUNC_2	__attribute__ ((const))
#	endif
#	define NORETURN_FUNC
#	ifdef noreturn
#		define	NORETURN_FUNC_2	/* We don't want empty __attribute__ (()). */
#	else
#		define	NORETURN_FUNC_2	__attribute__ ((noreturn))
#	endif
#endif

#else	/* Not GCC.  */

/* No idempotent functions.  */
#define	CONSTVALUE_FUNC
#define	CONSTVALUE_FUNC_2

/* No functions-of-no-return.  */
#define	NORETURN_FUNC
#define	NORETURN_FUNC_2

#endif /* const & noreturn */

#if (__GNUC__ >= 3) || ((__GNUC__ == 2) && (__GNUC_MINOR__ >= 6))
#	define HAVE_BOOL		1
#	define HAVE_OP_VEC_NEW	1
#endif

#if (!defined(__GNUC__) || __GNUC__ < 2 || ((__GNUC__ == 2) && (__GNUC_MINOR__ < 7)))
#	undef HAVE_EXPLICIT
#	undef HAVE_MUTABLE
#else
#	define HAVE_EXPLICIT	1
#	define HAVE_MUTABLE		1
#endif

#if defined(_AIX)
#	include <ifound/os/aix3.h>
#elif defined(sun)
#	if defined(__svr4__)
#		include <ifound/os/sunsol.h>
#	else
#		include <ifound/os/sun4.h>
#	endif
#elif defined(hppa) && defined(hpux)
#	include <ifound/os/hp9000.h>
#elif defined(linux)
#	include <ifound/os/linux.h>
#elif defined(mips) && defined(sgi)
#	if defined(_IRIX4)
#		include <ifound/os/iris4.h>
#	else
#		include <ifound/os/iris5.h>
#	endif
#elif defined(AUX)
#	include <ifound/os/aux3.h>
#elif defined(M_UNIX)
#	include <ifound/os/sco.h>
#elif defined(__NT__)
#	ifdef __SC__
#		ifdef __NTSERVER__
#			include <ifound/os/nt.h>
#		else
#			include <ifound/os/scwin.h>
#		endif
#	endif
#elif defined(_WINDOWS)
#	ifdef __SC__
#		include <ifound/os/scwin.h>
#	endif
#elif defined(MSDOS)
#	if __ZTC__
#		ifdef __SC__
#			include <ifound/os/sc.h>
#		else
#			include <ifound/os/ztc.h>
#		endif
#	else
#		include <ifound/os/borland.h>
#	endif
#elif defined(M_XENIX)
#	if defined(CPU_I286)
#		include <ifound/os/x286.h>
#	else
#		include <ifound/os/x386.h>
#	endif
#elif defined(__DGUX)
#	include	<ifound/os/dgux.h>
#elif defined(__SVR4__) || defined(__svr4__)
#	include	<ifound/os/uware.h>
#else
#	include <ifound/os/ix386.h>
#endif

#endif
