/********************************************************************
* Copyright (c) 1991 InterSoft Co.  All Rights Reserved
* THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF InterSoft Co.
* The copyright notice above does not evidence any
* actual or intended publication of such source code.
*
* $Id: phistory.h,v 3.1 1996/07/25 17:48:41 hernan Exp $
*
* DESCRIPTION
* Interface to generic Pointer Histories
*********************************************************************/

#ifndef	PHISTORY_H
#define	PHISTORY_H

#include <ifound/parray.h>

#ifdef HAVE_PRAGMA
#pragma interface
#endif

#define PtrHistory(CONTENT)		name2(CONTENT,PtrHistory)

#define	PtrHistorydeclare(CONTENT)									\
																	\
class PtrHistory(CONTENT) : public BasePtrArray { 					\
																	\
	Int _addIndex;						   							\
	Int _currIndex;													\
																	\
public:																\
																	\
	explicit PtrHistory(CONTENT)(Int n = 0, Int chunk = ARRAY_REALLOC)\
			: BasePtrArray(n, chunk), _addIndex(0), _currIndex(0) {}\
																	\
	void clear();													\
	bool isEmpty() const;											\
	bool catalogued(CONTENT *elem) const;							\
	Int  add(CONTENT *elem); 										\
	CONTENT *&operator[](Int n); 									\
																	\
	operator int();													\
	void operator=(Int n);											\
	void operator++();												\
	void operator++(int);											\
	CONTENT* current() const;										\
																	\
};																	\
																	\
inline void PtrHistory(CONTENT)::operator=(Int n)					\
{																	\
	require(n >= 0 && n < dim());									\
	_currIndex = n;													\
}                                                                   \
                                                                    \
inline PtrHistory(CONTENT)::operator int()                          \
{                                                                   \
	return (_currIndex < _addIndex);                                \
}                                                                   \
                                                                    \
inline void PtrHistory(CONTENT)::operator ++()                      \
{                                                                   \
	_currIndex++;                                                   \
}                                                                   \
                                                                    \
inline void PtrHistory(CONTENT)::operator ++(int)                   \
{                                                                   \
	_currIndex++;													\
}																	\
																	\
inline CONTENT*& PtrHistory(CONTENT)::operator [](Int n)            \
{                                                                   \
	return (CONTENT*&) elemTest(n);									\
}																	\
																	\
inline CONTENT* PtrHistory(CONTENT)::current() const 				\
{                                                                   \
	return (CONTENT*) c[_currIndex];								\
}																	\
																	\
inline void PtrHistory(CONTENT)::clear()		  					\
{																	\
	_addIndex = 0;													\
}																	\
																	\
inline Int PtrHistory(CONTENT)::add(CONTENT *elem)					\
{																	\
	int size = dim();                                               \
	                                                                \
	if (_addIndex == size) {                                    	\
		for (Int i = 0; i < size - 1; i++)                          \
			c[i] = c[i + 1];                                        \
		_addIndex--;												\
	}                                                               \
	c[_addIndex] = elem;                                          	\
                                                                    \
	return _addIndex++;                                             \
}																	\
																	\
inline bool PtrHistory(CONTENT)::catalogued(CONTENT *elem) const	\
{																	\
	bool result = false;											\
	for (int i = 0; i < dim(); i++)									\
		if (c[i] == elem) result = true;							\
	return result;													\
}																	\
																	\
inline bool PtrHistory(CONTENT)::isEmpty() const  					\
{																	\
	return (_addIndex == 0);  										\
}

#define	PtrHistoryimplement(CONTENT)

#endif
