/********************************************************************
* Copyright (c) 1991 InterSoft Co.  All Rights Reserved
* THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF InterSoft Co.
* The copyright notice above does not evidence any
* actual or intended publication of such source code.
*
* $Id: gfuncs.h,v 1.12 1996/08/15 16:40:48 eduardoc Exp $
*
* DESCRIPTION:
* General purpose private function prototypes
*********************************************************************/

#ifndef PRIV_GFUNCS_H
#define PRIV_GFUNCS_H

#include <ifound.h>
#include <ifound/functype.h>
#include <ifound/priv/macros.h>

class String;
class Time;
class ProcessConfig;

#ifdef HAVE_SYS_TIMEB_H
	struct timeb;
	Int _osTimeZoneAdj(struct timeb *);
#else
	Int _osTimeZoneAdj(Int);
#endif

FILE *openDataDirFile(const String &data, const String &language, 
					  const String &file);

Int _osTime();
bool isBigEndian();
Int ldlong(register const void *p);
void stlong(register Int l, register void *p);
double lddbl(register const void *p);
void stdbl(double d, register void *p);
const char *readEnvVar(const char *v);
void putEnvVar(const char *v);
char *longToStr(Int v, register char *cp, int base);
void floatToStr(double val, register char *buff, int dec, int tipo);
int doFormat(IFPICP ofunct, char *funct_arg, const char *fmt, va_list ap);
bool findInPath(const String &name, String ext, const String &path,
		String &fullname);
String findInPath(const String &filename, const String &path);
bool isAbsolutePath(const String &path);
ProcessConfig *_processConfig();
void setArgs(int argc, char **argv);
int lockFile(int fd, bool lock, bool test, Int offset, Int len);
int freeFile(int fd, Int offset, Int len);
Int fdLockOwner(int fd, Int offset, Int len);
UnShort ldUnShort(FILE *fp);
short ldShort(FILE *fp);
signed char ldChar(FILE *fp);
Byte ldByte(FILE *fp);
UnByte ldUnByte(FILE *fp);
Int ldInt(FILE *fp);
String ldString(FILE *fp);
bool ldBool(FILE *fp);
Int stStringLength(const String &str);
void stString(FILE *fp, const String &str);
void stInt(FILE *fp, Int n);
void stInt(Int l, char *&p);
Int ldInt(const char *&p);
void stUnShort(FILE *fp, UnShort n);
void stShort(FILE *fp, short n);
void stChar(FILE *fp, signed char);
void stByte(FILE *fp, Byte b);
void stUnByte(FILE *fp, UnByte b);
void stBool(FILE *fp, bool v);
FILE *admOpen(const char *nm, const char *ver = NULL);
void admClose(FILE *f);

#endif

