/********************************************************************
* Copyright (c) 1991 InterSoft Co.  All Rights Reserved
* THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF InterSoft Co.
* The copyright notice above does not evidence any
* actual or intended publication of such source code.
*
* $Id: timedefs.h,v 1.7 1996/08/15 16:40:54 eduardoc Exp $
*
* DESCRIPTION
* Date/Time handling function prototypes
*********************************************************************/

#ifndef PRIV_TIMEDEFS_H
#define PRIV_TIMEDEFS_H

typedef Int LTIME;
typedef Int LDATE;

/* Useful constants */

#define	SECONDS_DAY			((Int)(60L*60L*24L))
#define	SECONDS_HOUR		((Int)(60L*60L))
#define SECONDS_MINUTE		(60L)

/* +++ Prototypes +++ */

void _date_to_dmy(LDATE idate, Int *day, Int *month, Int *year);
LDATE _dmy_to_date(Int day, Int month, Int year);
LDATE _str_to_date(const char *sd, Int fmt);
const char *_date_to_str(LDATE l, char *buf, Int fmt);
Int _date_to_osdate(LDATE idate);
LDATE _osdate_to_date(Int l);

void _time_to_dhms(LTIME i, Int *d, Int *h, Int *m, Int *s);
LTIME _dhms_to_time(Int d, Int h, Int m, Int s);
LTIME _str_to_time(const char *sd);
const char *_time_to_str(LTIME l, char *buf, Int tfmt);
Int _time_to_ostime(LTIME itime);
LTIME _ostime_to_time(Int l);

/* --- Prototypes --- */

#endif
