//- Copyright Notice
// -----------------------------------------------------------------------
// (C) Copyright  1996 InterSoft Argentina S.A.  All Rights Reserved
// THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF InterSoft Co.
// The copyright notice above does not evidence any actual or intended 
// publication of such source code.
//
// $Id: propties.h,v 3.1 1996/08/22 23:34:30 gustavof Exp $
//
// Description:
// -----------------------------------------------------------------------
#ifndef PROP_H
#define PROP_H

#include <ifound/hashtab.h>
#include <ifound/str.h>
#include <ifound/anyvalue.h>

#define	PROPTIES_DFLT_DIM	64

class String;
class AnyValue;
declare2(HashTab, String, AnyValue);

class Properties {

public:	
	virtual ~Properties();
	Properties::Properties()
		: propvals_d(*new HashTab(String,AnyValue)(PROPTIES_DFLT_DIM))
		{ }

	virtual void add(const String &n, const AnyValue &val = NULL_ANYVALUE);
	virtual AnyValue *get(const String &n);
	virtual const AnyValue *set(const String &n, const AnyValue &val);
	virtual void clearAll();
protected:
	HashTab(String,AnyValue) &propvals_d;

};

#endif //PROP_H


