// -----------------------------------------------------------------------
// Copyright (c) 1995 InterSoft Co.  All Rights Reserved
// THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF InterSoft Co.
// The copyright notice above does not evidence any actual or intended 
// publication of such source code.
//
// $Id: stack.h,v 1.1 1996/07/03 15:29:26 hernan Exp $
//
// Description:
// -----------------------------------------------------------------------

#ifndef STACK_H
#define STACK_H

#ifdef __GNUC__
#pragma interface
#endif

#include <ifound.h>
#include <ifound/template.h>

#define Stack(CONTENT)		name2(CONTENT, Stack)

#define Stackdeclare(CONTENT)										\
class Stack(CONTENT) {												\
public:																\
	Stack(CONTENT)() : size_d(0), dim_d(0), ptr_d(NULL) {}			\
	~Stack(CONTENT)() { reAlloc(0); }								\
																	\
	Int dim() const { return dim_d; }								\
	void push(const CONTENT elem)									\
	{																\
		if (dim_d >= size_d)										\
			reAlloc(dim_d + 8);										\
		ptr_d[dim_d++] = elem;										\
	}																\
	CONTENT pop()													\
	{																\
		assert(dim_d>0);											\
		return ptr_d[--dim_d];										\
	}																\
	CONTENT &elem(Int depth) const									\
	{																\
		assert(depth>=0 && depth<dim_d);							\
		return ptr_d[dim_d-1-depth];								\
	}																\
	CONTENT &top() const											\
	{																\
		assert(dim_d>0);											\
		return ptr_d[dim_d-1];										\
	}																\
																	\
private:															\
	void reAlloc(Int newSize);										\
	Int size_d;														\
	Int dim_d;														\
	CONTENT *ptr_d;													\
};

#define Stackimplement(CONTENT)										\
void Stack(CONTENT)::reAlloc(Int size)								\
{																	\
	CONTENT *newPtr;												\
	dim_d = min(dim_d, size);										\
	if (size == 0)													\
		newPtr = NULL;												\
	else {															\
		newPtr = tr_new CONTENT[size];								\
		for (Int i = 0; i<dim_d; i++)								\
			newPtr[i] = ptr_d[i];									\
	}																\
	tr_delete_vec(ptr_d);											\
	ptr_d = newPtr;													\
	size_d = size;													\
}

#endif


