/********************************************************************
* Copyright (c) 1991 InterSoft Co.  All Rights Reserved
* THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF InterSoft Co.
* The copyright notice above does not evidence any
* actual or intended publication of such source code.
*
* $Id: stdc.h,v 1.54 1996/08/22 23:27:50 gustavof Exp $
*
* DESCRIPTION
* Include with standard 'C' compiler function prototypes
*********************************************************************/

#ifndef	STDC_H
#define	STDC_H

#include <ifound/osdep.h>
#include <cfix/types.h>
#include <ifound/functype.h>

#ifdef __cplusplus
#	define STRUCT class
#else
#	define STRUCT struct
#endif
struct msqid_ds;
struct msgbuf;
struct group;
struct sembuf;
struct stat;
struct passwd;
struct sockaddr;
struct pollfd;
struct statfs;

#ifndef STDIN_FILENO
#	define	STDIN_FILENO	0
#endif
#ifndef STDOUT_FILENO
#	define STDOUT_FILENO	1
#endif
#ifndef STDERR_FILENO
#	define STDERR_FILENO	2
#endif

#ifdef HAVE_TEXT_FILES
#	define FOPEN_READ_MODE	"rb"
#	define FOPEN_WRITE_MODE	"wb"
#	define FOPEN_READ_WRITE_MODE	"r+b"
#	define FOPEN_WRITE_READ_MODE	"w+b"
#else
#	define FOPEN_READ_MODE	"r"
#	define FOPEN_WRITE_MODE	"w"
#	define FOPEN_READ_WRITE_MODE	"r+"
#	define FOPEN_WRITE_READ_MODE	"w+"
#endif

#ifdef HAVE_STD_TCP_HEADERS
struct hostent;
struct servent;
#endif /* HAVE_STD_TCP_HEADERS */

#ifdef HAVE_SYS_UTSNAME_H
struct utsname;
#endif /* HAVE_SYS_UTSNAME_H */

#ifdef __cplusplus
extern "C" {
#endif

/* +++ Prototypes +++ */

#ifdef HAVE_STATFS4PARAM
	extern int statfs(const char *, struct statfs *, int, int);
#else
	extern int statfs(const char *, struct statfs *);
#endif
	extern char *strcpy(char *, char const *);
	extern char *strncpy(char *, char const *, SizeT);
	extern SPRINTFRETTYPE sprintf(char *, char const *, ...);
	extern char *strcat(char *, char const *);
	extern char *strncat(char *, char const *, SizeT);
	extern char *strtok(char *, const char *);

#ifndef __cplusplus
	/* See below for C++ */
	extern char *strchr(char const *, int);
	extern char *strrchr(char const *, int);
	extern char *strstr(char const *, char const *);
#endif

	extern void *memcpy(void *, void const *, SizeT);
	extern void *memCopy(void *, void const *, SizeT);
	extern void *memmove(void *, void const *, SizeT);
	extern void *memMove(void *, void const *, SizeT);
	extern void *memset(void *, int, SizeT);
	extern ALLOCRETTYPE _proto_realloc(void *, SizeT);
 	extern char *getcwd(GETCWDPARAM1TYPE,GETCWDPARAM2TYPE);
	extern char *tempnam(TEMPNAMPARAM1TYPE, TEMPNAMPARAM2TYPE);
	extern char *mktemp(char *);

#ifdef HAVE_PID
	extern PidT getpid(void);
#endif
	extern int kill(PidT pid, int sig);
	extern int atoi(char const *);
	extern int memcmp(void const *, void const *, SizeT);
#if MKDIR_HAS_ONE_PARAM
	extern int mkdir(MKDIRPARAM1TYPE);
#else
	extern int mkdir(MKDIRPARAM1TYPE, ModeT);
#endif
	extern int fcntl(int fildes, int cmd, FCNTLPARAM3TYPE);
	extern int ioctl(int, int, ...);
#ifdef HAVE_LOCKING
	extern int locking(int, int, Int);
#endif
	extern int link(char const *, char const *);
	extern char *tmpnam(char *);
	extern char *getenv(char const *);
 	extern ABORTRETTYPE _proto_abort(void);
	extern PidT fork(void);
 	extern int execvp(EXECVPPARAM1TYPE, EXECVPPARAM2TYPE);
	extern int dup(int);
	extern int dup2(int, int);
	extern int chdir(char const *dir);
	extern char *ttyname(int fildes);
	extern int msgget(KeyT k, int flg);
 	extern int msgsnd(int, MSGSNDPARAM2TYPE, MSGSNDPARAM3TYPE, int);
	extern int msgrcv(int, MSGRCVPARAM2TYPE, MSGRCVPARAM3TYPE, Int, int);
 	extern int msgctl(int, int, MSGCTLPARAM3TYPE);
#ifdef HAVE_MMF
	extern int munmap(MUNMAPPARAM1TYPE, MUNMAPPARAM2TYPE);
#endif
#if CAN_HAVE_INLINE_STAT
#	ifndef LINUX_STAT_VERSION
	extern int fstat(int f, struct stat *s);
#	endif
#else
	extern int fstat(int f, struct stat *s);
#endif
	extern int lockf(int fildes, int function, Int size); 
	extern int rmdir(const char *p);
	extern int unlink(const char *p);
	extern char* realpath(const char *file_name, char *resolved_name);
#ifdef HAVE_TRUNCATE
	extern int ftruncate(int fildes, FTRUNCATEPARAM2TYPE length);
#endif
#ifdef HAVE_FSYNC
	extern int fsync(int fd);
#endif
	extern SizeT strlen(char const *);
	extern int strncmp(char const *, char const *, SizeT);
	extern int strcmp(char const *, char const *);
	extern int strcasecmp(char const *, char const *);
	extern int strncasecmp(char const *, char const *, SizeT);
	extern char* strdup(STRDUPPARAMTYPE);
	extern ModeT umask(ModeT cmask);
	extern Int atol(char const *);
#ifdef HAVE_LTOA1PARAM                
	extern char * ltoa(Int);	
#else
	extern char * ltoa(long, char *, int);
#endif
	extern READRETTYPE _proto_read(int, void *, READPARAM3TYPE);
	extern WRITERETTYPE _proto_write(int, void const *, WRITEPARAM3TYPE);
	extern OPENRETTYPE _proto_open(char const *, int, OPENPARAM3TYPE);
	extern PidT setsid(void);
	extern PidT setpgrp(void);
	extern int setuid(UidT);
	extern int setgid(GidT);
	extern int setpgid(PidT, PidT);
	extern Int _proto_time(Int *a);
	extern Int lseek(int, Int, int);
	extern int putenv(PUTENVPARAMTYPE);
	extern int system(const char *s);
	extern int pipe(int *);
	extern PidT wait(WAITPARAMTYPE);
	extern PidT waitpid(PidT, int *, int);
	extern void openlog(const char *ident, int option, int facility);
	extern int semget(KeyT k, int n, int s);
/* 	extern int semctl(int i, int s, int c,  SEMCTLPARAM4TYPE); */
	extern int semop(int i, struct sembuf *, SEMOPPARAM3TYPE);
	extern ALLOCRETTYPE malloc(SizeT);
	extern void free(void *);
	extern SLEEPRETTYPE sleep(SLEEPPARAMTYPE s);
	extern ModeT umask(ModeT cmask);
	extern UidT getuid(void);
	extern GidT getgid(void);
 	extern PAUSERETTYPE _proto_pause(void);
	extern void malloc_check(void);
#ifdef HAVE_NO_RETURN_FUNC_2
	extern NORETURN_FUNC EXITRETTYPE _proto_exit(int) NORETURN_FUNC_2;
	extern NORETURN_FUNC EXITRETTYPE _exit(int) NORETURN_FUNC_2;
#else
	extern NORETURN_FUNC EXITRETTYPE _proto_exit(int);
	extern NORETURN_FUNC EXITRETTYPE _exit(int);
#endif
	extern void tzset(void);
	extern QSORTRETTYPE qsort(void *, QSORTPARAM2TYPE, QSORTPARAM3TYPE, IFPVCPVCP);
	extern void openlog(const char *ident, int option, int facility);
	extern void syslog(int priority, const char *format, ...);
	extern int _proto_close(int);
	extern unsigned alarm(unsigned);
	extern UidT geteuid(void);
	extern GidT getegid(void);
	extern int printf(char const *, ...);
	extern void closelog(void);
 	extern SBRKRETTYPE sbrk(SBRKPARAMTYPE);
	extern FCVTRETTYPE fcvt(double, FCVTPARAM2TYPE, int *, int *);
	extern ECVTRETTYPE ecvt(double, ECVTPARAM2TYPE, int *, int *);
	extern double atof(char const *s);
	extern Int ulimit(int, Int);
 	extern void bcopy(void const *, void *, BCOPYPARAM3TYPE);
	extern void bzero(void *, int);
	extern int poll(POLLPARAM1TYPE, POLLPARAM2TYPE, POLLPARAM3TYPE);
 	extern struct passwd *getpwuid(GETPWUIDPARAMTYPE);
	extern struct passwd *getpwnam(char const *name);
	extern SYNCRETTYPE _proto_sync(void);
#ifndef HAVE_WINSOCK
	extern int bind(int, BINDPARAM2TYPE, BINDPARAM3TYPE);
	extern CONNECTRETTYPE _proto_connect(CONNECTPARAM1TYPE, CONNECTPARAM2TYPE, CONNECTPARAM3TYPE);
	extern SOCKETRETTYPE socket(int, int, int);
	extern int listen(int, int);
	extern int accept(int, ACCEPTPARAM2TYPE, ACCEPTPARAM3TYPE);
	extern int access(const char *, int);
	extern char *getlogin(void);
/*
extern int select(int, fd_set *, fd_set *, fd_set *, struct timeval *);
*/
#ifdef HAVE_STD_TCP_HEADERS
	extern int getpeername(int, GETPEERNAMEPARAM2TYPE, GETPEERNAMEPARAM3TYPE);
	extern int gethostname(char *, GETHOSTNPARAM2TYPE);
	extern struct hostent *gethostbyname(GETHOSTBNPARAMTYPE);
	extern struct servent *getservbyname(GETSERVBNPARAM1TYPE, GETSERVBNPARAM2TYPE);
#endif
#endif
#ifdef HAVE_SYS_UTSNAME_H
	extern int uname(struct utsname *);
#endif /* HAVE_SYS_UTSNAME_H */
	extern Int fpathconf(int, int);
	extern int getgroups(int, GidT []);
	extern void srand48(Int s);
	extern Int lrand48(void);
	extern int chown(char const *path, CHOWNPARAM2TYPE, CHOWNPARAM3TYPE);
	extern int isatty(int);
#ifdef HAVE_SETRLIMIT
	struct rlimit;
	int setrlimit(int resource, const struct rlimit *rlim);
#endif
#ifdef __NT__
	extern UnInt __stdcall GetCurrentProcessId();
#endif
/* --- Prototypes --- */

#ifdef __cplusplus
}
#endif

#ifndef HAVE_PID
#ifdef __NT__
#	define getpid()	GetCurrentProcessId()
#else
#	define getpid()	(1)
#endif
#endif

#define mSet(a, b, c)				memset((a), (b), (c))
#if HAVE_BZERO
#	define mZero(a, b)				bzero((a), (int)(b))
#else
#	define mZero(a, b)				memset((a), 0, (int)(b))
#endif

#ifdef HAVE_BCOPY
#	define mCopy(a, b, c)		bcopy((b), (a), (int)(c))
#else
#if defined HAVE_MEMCPYBUG
#	define mCopy(a, b, c)		memCopy((a), (b), (int)(c))
#else
#	define mCopy(a, b, c)		memcpy((a), (b), (int)(c))
#endif
#endif

#ifdef HAVE_MEMMOVE
#	define mMove(a, b, c)		memmove((a), (b), (int)(c))
#else
#	define mMove(a, b, c)		memMove((a), (b), (int)(c))
#endif

#define SigSet(a, b)	Signal((a), (SigHandlerT)(b))

#ifdef __cplusplus
extern "C" {
#endif
	SigHandlerT Signal(int sig, SigHandlerT fp);
#ifdef __cplusplus
}
#endif

#if HAVE_BAD_CVT
#	ifdef __cplusplus
extern "C" {
#	endif
	extern FCVTRETTYPE fCvt(double, int, int *, int *);
	extern FCVTRETTYPE eCvt(double, int, int *, int *);
#	ifdef __cplusplus
}
#	endif
#else
	#define fCvt(a, b, c, d)	fcvt(a, b, c, d)
	#define eCvt(a, b, c, d)	ecvt(a, b, c, d)
#endif

#ifdef __cplusplus

// For C++ standard str functions <cstring>
	extern "C" {
		char *strchr(char const *, int);
		char *strrchr(char const *, int);
		char *strstr(char const *, char const *);
	}
#if 0
	/*
	 * Eugen: we have to solve a problem with C/C++ str* functions.
	 */
#	ifndef __CSTRING__
#	define __CSTRING__

	extern "C" char *strchr(const char *, int);
	inline char *
	strchrCPP (char *s, int c)
	{
	  return strchr (s, c);
	}
	inline const char *
	strchrCPP (const char *s, int c)
	{
	  return strchr (s, c);
	}
#	define strchr strchrCPP

	extern "C" char *strpbrk (const char *, const char *);
	inline char *
	strpbrkCPP (char *s1, const char *s2)
	{
	  return strpbrk (s1, s2);
	}
	inline const char *
	strpbrkCPP (const char *s1, const char *s2)
	{
	  return strpbrk (s1, s2);
	}
#	define strpbrk strpbrkCPP

	extern "C" char *strrchr (const char *, int);
	inline char *
	strrchrCPP (char *s, int c)
	{
	  return strrchr (s, c);
	}
	inline const char *
	strrchrCPP (const char *s, int c)
	{
	  return strrchr (s, c);
	}
#	define strrchr strrchrCPP

	extern "C" char *strstr (const char *, const char *);
	inline char *
	strstrCPP (char *s1, const char *s2)
	{
	  return strstr (s1, s2);
	}
	inline const char *
	strstrCPP (const char *s1, const char *s2)
	{
	  return strstr (s1, s2);
	}
#	define strstr strstrCPP

	extern "C" void *memchr (const void *, int, SizeT);
	inline void *
	memchrCPP (void *s, int c, SizeT n)
	{
	  return memchr (s, c, n);
	}
	inline const void *
	memchrCPP (const void *s, int c, SizeT n)
	{
	  return memchr (s, c, n);
	}
#	define memchr memchrCPP

#	endif

#endif
#endif

#endif

