/*
 * File:	wx_popup.h
 * Purpose: Popup menu
 * Author:  Sergey Krasnov (sergey@orgland.ru)
 * Created: 1995
 * Updated:
 * Copyright:
 */

#ifndef wx_popuph
#define wx_popuph

#ifdef __GNUG__
#pragma interface
#endif

#include "common.h"
#include "wx_dialg.h"
#include "wx_vlbox.h"


typedef bool (*BFPCPPI)(char **, int);
typedef char *(*CPFPCPI)(char *, int);

class wxPopupMenu: public wxDialogBox
{
public:
    wxPopupMenu(wxFrame * parent, wxFunction func,
                int x, int y, int width, int height, char * Title,
                CPFPCPI get_optx, char *garg,
                BFPCPPI execf, char *earg[],
                int nrows = -1, int ncols = -1,
                long style = wxDEFAULT_DIALOG_STYLE);
    wxPopupMenu(wxFrame * parent, wxFunction func,
                int x, int y, char * Title,
                CPFPCPI get_optx, char *garg,
                BFPCPPI execf, char *earg[],
                int nrows, int ncols, long style = wxDEFAULT_DIALOG_STYLE);
    ~wxPopupMenu();
	int Execute(void);
	bool SelectOk(void);
	inline int GetSelection(void) 	{ return vListBox->GetSelection(); }
	void SetSelection(int n);
	void OnSearch(int SearchType);
	void Refresh(void);
    virtual void Fit(void);
    void ProcessCommand (wxCommandEvent & event);
private:
    	char *Title;
    	CPFPCPI GetOptx;
    	char *gArg;
        BFPCPPI ExecF;
        char **eArg;
    	long Style;
		int nRows;
		int nCols;
		int Width, Height;
		Bool SearchDown;
		Bool IgnoreCase;
		char SearchStr[256];
		wxButton *cancel, *next, *prev, *search;
        wxVirtListBox *vListBox;
		int Search(int SearchType);
protected:
};

char *wxGetSearchString(Bool& searchDown, Bool& ignoreCase,
                        char *default_value = "", wxFrame *parent = NULL,
                        int x = -1, int y = -1);

#endif // wx_popuph
