#ifndef wx_tbarhex
#define wx_tbarhex

#ifdef __GNUG__
#pragma interface                  
#endif


#include <common.h>
#include <wx_tbar.h>

#define	MAX_BAR_BITMAP_NUM	25
#define LARGE_MARGIN		10
#define SMALL_MARGIN		5

extern wxBitmap * wxLoadBitmap(char *,  wxColourMap **);

class wxToolBarEx: public wxToolBar
{
    int		activeLeftTool;
    int		activeRightTool;                
  	Bool	clearOnExit;
  	void drawTool(wxToolBarTool *tool);
  	void LeftDown(wxToolBarTool *tool);
    void RightDown(wxToolBarTool *tool);
  	void LeftUp(wxToolBarTool *tool);
  	void RightUp(wxToolBarTool *tool);
 public:

  /*
   * Public interface
   */

  wxToolBarEx(wxFrame *frame, int x = 0, int y = 0, int w = -1, int h = -1,
            int style = 0, int orientation = wxHORIZONTAL, int RowsOrColumns = 2);
  ~wxToolBarEx(void);

  wxToolBarTool * AddTool(int toolIndex, int actionId, wxBitmap *bitmap, wxBitmap *pushedBitmap = NULL,
               Bool toggle = FALSE, int xPos = -1, int yPos = -1);
  virtual void DrawTool(wxMemoryDC& memDC, wxToolBarTool *tool);
  void OnKillFocus(void);	
  void OnEvent(wxMouseEvent& event);


  // Handle wxToolBar events
  // Only allow toggle if OnLeftDown returns TRUE
  virtual Bool OnLeftClick(int toolIndex, Bool toggleDown);
  virtual void OnRightClick(int toolIndex, float x, float y);

  // OnLeftAction and OnRightAction	are called when user press
  // and then depress the same button.
  // More, they are called only OnLeftDown (OnRightDown) retuns TRUE,
  // i.e. button is enabed 
  virtual Bool OnLeftAction(int toolIndex, Bool toggleDown);
  virtual Bool OnRightAction(int toolIndex, Bool toggleDown);

  // Called if OnLeftDown retuns TRUE
  // Argument is -1 if mouse is exiting the toolbar and Action 
  // functions (if were called) return FALSE (allows not 
  // clear message after action) 
  virtual void DrawButtonDescr(int toolIndex);
  
};

#endif // wx_tbarhex
